/*!
 * Copyright (c) 2012 - 2019, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
*/
(function(root, factory) {
  factory(root["Bokeh"]);
})(this, function(Bokeh) {
  var define;
  return (function(modules, entry, aliases, externals) {
    if (Bokeh != null) {
      return Bokeh.register_plugin(modules, entry, aliases, externals);
    } else {
      throw new Error("Cannot find Bokeh. You have to load it prior to loading plugins.");
    }
  })
({
"aa4f566620": function _(r,e,t){var n=(this&&this.__importStar||function(r){if(r&&r.__esModule)return r;var e={};if(null!=r)for(var t in r)Object.hasOwnProperty.call(r,t)&&(e[t]=r[t]);return e.default=r,e})(r("4d02676c49"));t.Panel=n,r("@bokehjs/base").register_models(n)},
"4d02676c49": function _(a,e,r){var o=a("ff4b91e885");r.AcePlot=o.AcePlot;var t=a("12e90a1b7e");r.Audio=t.Audio;var c=a("cf3b018c7a");r.DeckGLPlot=c.DeckGLPlot;var d=a("70a2bb70ef");r.HTML=d.HTML;var v=a("dac8d750fa");r.JSON=v.JSON;var P=a("c81021c8fd");r.KaTeX=P.KaTeX;var b=a("a93ded647d");r.MathJax=b.MathJax;var l=a("98100899bc");r.Player=l.Player;var f=a("7d6e800353");r.PlotlyPlot=f.PlotlyPlot;var i=a("d9b3a262de");r.Progress=i.Progress;var n=a("4b4afba86a");r.State=n.State;var S=a("14b669e6fc");r.VegaPlot=S.VegaPlot;var V=a("71a2bbec38");r.Video=V.Video;var s=a("76bc93d621");r.VideoStream=s.VideoStream,function(a){for(var e in a)r.hasOwnProperty(e)||(r[e]=a[e])}(a("63070bc9ce"))},
"ff4b91e885": function _(t,e,o){var i,n=this&&this.__extends||(i=function(t,e){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)},function(t,e){function o(){this.constructor=t}i(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}),r=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var o in t)Object.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e.default=t,e})(t("@bokehjs/core/properties")),s=t("@bokehjs/models/layouts/html_box"),a=t("@bokehjs/core/dom");var c=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return n(e,t),e.prototype.initialize=function(){t.prototype.initialize.call(this),this._ace=window.ace,this._container=a.div({id:"_"+Math.random().toString(36).substr(2,9),style:{width:"100%",height:"100%"}})},e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this),this.connect(this.model.properties.code.change,function(){return e._update_code_from_model()}),this.connect(this.model.properties.theme.change,function(){return e._update_theme()}),this.connect(this.model.properties.language.change,function(){return e._update_language()}),this.connect(this.model.properties.annotations.change,function(){return e._add_annotations()}),this.connect(this.model.properties.readonly.change,function(){e._editor.setReadOnly(e.model.readonly)})},e.prototype.render=function(){var e=this;t.prototype.render.call(this),this._container!==this.el.childNodes[0]&&this.el.appendChild(this._container),this._container.textContent=this.model.code,this._editor=this._ace.edit(this._container.id),this._editor.setTheme("ace/theme/"+this.model.theme),this._editor.session.setMode("ace/mode/"+this.model.language),this._editor.setReadOnly(this.model.readonly),this._langTools=this._ace.require("ace/ext/language_tools"),this._editor.setOptions({enableBasicAutocompletion:!0,enableSnippets:!0,fontFamily:"monospace"}),this._editor.on("change",function(){return e._update_code_from_editor()})},e.prototype._update_code_from_model=function(){this._editor&&this._editor.getValue()!=this.model.code&&this._editor.setValue(this.model.code)},e.prototype._update_code_from_editor=function(){this._editor.getValue()!=this.model.code&&(this.model.code=this._editor.getValue())},e.prototype._update_theme=function(){this._editor.setTheme("ace/theme/"+this.model.theme)},e.prototype._update_language=function(){this._editor.session.setMode("ace/mode/"+this.model.language)},e.prototype._add_annotations=function(){this._editor.session.setAnnotations(this.model.annotations)},e.prototype.after_layout=function(){t.prototype.after_layout.call(this),this._editor.resize()},e.__name__="AcePlotView",e}(t("ec60963462").PanelHTMLBoxView);o.AcePlotView=c;var h=function(t){function e(e){return t.call(this,e)||this}return n(e,t),e.init_AcePlot=function(){this.prototype.default_view=c,this.define({code:[r.String],language:[r.String,"python"],theme:[r.String,"chrome"],annotations:[r.Array,[]],readonly:[r.Boolean,!1]}),this.override({height:300,width:300})},e.__name__="AcePlot",e.__module__="panel.models.ace",e}(s.HTMLBox);o.AcePlot=h,h.init_AcePlot()},
"ec60963462": function _(e,t,i){var o,n=this&&this.__extends||(o=function(e,t){return(o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i])})(e,t)},function(e,t){function i(){this.constructor=e}o(e,t),e.prototype=null===t?Object.create(t):(i.prototype=t.prototype,new i)}),s=e("@bokehjs/core/layout/layoutable"),h=e("@bokehjs/core/layout/types"),r=e("@bokehjs/core/dom"),a=e("@bokehjs/models/widgets/markup"),_=e("@bokehjs/models/layouts/html_box");function c(e,t){var i=null!=t.width?"fixed":"fit",o=null!=t.height?"fixed":"fit",n=t.sizing_mode;if(null!=n)if("fixed"==n)i=o="fixed";else if("stretch_both"==n)i=o="max";else if("stretch_width"==n)i="max";else if("stretch_height"==n)o="max";else switch(n){case"scale_width":i="max",o="min";break;case"scale_height":i="min",o="max";break;case"scale_both":i="max",o="max";break;default:throw new Error("unreachable")}"fixed"==i&&t.width?e.style.width=t.width+"px":"max"==i&&(e.style.width="100%"),"fixed"==o&&t.height?e.style.height=t.height+"px":"max"==o&&(e.style.height="100%")}i.set_size=c;var l=function(e){function t(t,i,o){var n=e.call(this)||this;return n.el=t,n.sizing_mode=i,n.changed=o,n._cache={},n._cache_count={},n}return n(t,e),t.prototype._measure=function(e){var t=this,i=[e.width,e.height,this.sizing_mode].toString(),o=this.changed&&"fixed"!=this.sizing_mode&&null!=this.sizing_mode?1:0;if(i in this._cache&&this._cache_count[i]>=o)return this._cache_count[i]=this._cache_count[i]+1,this._cache[i];var n=new h.Sizeable(e).bounded_to(this.sizing.size),s=r.sized(this.el,n,function(){var e=new h.Sizeable(r.content_size(t.el)),i=r.extents(t.el),o=i.border,n=i.padding;return e.grow_by(o).grow_by(n).map(Math.ceil)});return this._cache[i]=s,this._cache_count[i]=0,s},t.__name__="CachedVariadicBox",t}(s.Layoutable);i.CachedVariadicBox=l;var d=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return n(t,e),t.prototype._update_layout=function(){var e=void 0!==this._prev_sizing_mode&&this._prev_sizing_mode!==this.model.sizing_mode;this._prev_sizing_mode=this.model.sizing_mode,this.layout=new l(this.el,this.model.sizing_mode,e),this.layout.set_sizing(this.box_sizing())},t.prototype.render=function(){e.prototype.render.call(this),c(this.markup_el,this.model)},t.__name__="PanelMarkupView",t}(a.MarkupView);i.PanelMarkupView=d;var u=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return n(t,e),t.prototype._update_layout=function(){var e=void 0!==this._prev_sizing_mode&&this._prev_sizing_mode!==this.model.sizing_mode;this._prev_sizing_mode=this.model.sizing_mode,this.layout=new l(this.el,this.model.sizing_mode,e),this.layout.set_sizing(this.box_sizing())},t.prototype.render=function(){e.prototype.render.call(this),c(this.el,this.model)},t.__name__="PanelHTMLBoxView",t}(_.HTMLBoxView);i.PanelHTMLBoxView=u},
"12e90a1b7e": function _(t,e,o){var i,n=this&&this.__extends||(i=function(t,e){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)},function(t,e){function o(){this.constructor=t}i(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}),u=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var o in t)Object.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e.default=t,e})(t("@bokehjs/core/properties")),l=t("@bokehjs/models/layouts/html_box"),s=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return n(e,t),e.prototype.initialize=function(){t.prototype.initialize.call(this),this._blocked=!1,this._setting=!1,this._time=Date.now()},e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this),this.connect(this.model.properties.loop.change,function(){return e.set_loop()}),this.connect(this.model.properties.paused.change,function(){return e.set_paused()}),this.connect(this.model.properties.time.change,function(){return e.set_time()}),this.connect(this.model.properties.value.change,function(){return e.set_value()}),this.connect(this.model.properties.volume.change,function(){return e.set_volume()})},e.prototype.render=function(){var e=this;t.prototype.render.call(this),this.audioEl=document.createElement("audio"),this.audioEl.controls=!0,this.audioEl.src=this.model.value,this.audioEl.currentTime=this.model.time,this.audioEl.loop=this.model.loop,null!=this.model.volume?this.audioEl.volume=this.model.volume/100:this.model.volume=100*this.audioEl.volume,this.audioEl.onpause=function(){return e.model.paused=!0},this.audioEl.onplay=function(){return e.model.paused=!1},this.audioEl.ontimeupdate=function(){return e.update_time(e)},this.audioEl.onvolumechange=function(){return e.update_volume(e)},this.el.appendChild(this.audioEl),this.model.paused||this.audioEl.play()},e.prototype.update_time=function(t){t._setting?t._setting=!1:Date.now()-t._time<t.model.throttle||(t._blocked=!0,t.model.time=t.audioEl.currentTime,t._time=Date.now())},e.prototype.update_volume=function(t){t._setting?t._setting=!1:(t._blocked=!0,t.model.volume=100*t.audioEl.volume)},e.prototype.set_loop=function(){this.audioEl.loop=this.model.loop},e.prototype.set_paused=function(){!this.audioEl.paused&&this.model.paused&&this.audioEl.pause(),this.audioEl.paused&&!this.model.paused&&this.audioEl.play()},e.prototype.set_volume=function(){this._blocked?this._blocked=!1:(this._setting=!0,null!=this.model.volume&&(this.audioEl.volume=this.model.volume/100))},e.prototype.set_time=function(){this._blocked?this._blocked=!1:(this._setting=!0,this.audioEl.currentTime=this.model.time)},e.prototype.set_value=function(){this.audioEl.src=this.model.value},e.__name__="AudioView",e}(t("ec60963462").PanelHTMLBoxView);o.AudioView=s;var r=function(t){function e(e){return t.call(this,e)||this}return n(e,t),e.init_Audio=function(){this.prototype.default_view=s,this.define({loop:[u.Boolean,!1],paused:[u.Boolean,!0],time:[u.Number,0],throttle:[u.Number,250],value:[u.Any,""],volume:[u.Number,null]})},e.__name__="Audio",e.__module__="panel.models.widgets",e}(l.HTMLBox);o.Audio=r,r.init_Audio()},
"cf3b018c7a": function _(t,e,o){var n,i=this&&this.__extends||(n=function(t,e){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)},function(t,e){function o(){this.constructor=t}n(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}),r=this&&this.__assign||function(){return(r=Object.assign||function(t){for(var e,o=1,n=arguments.length;o<n;o++)for(var i in e=arguments[o])Object.prototype.hasOwnProperty.call(e,i)&&(t[i]=e[i]);return t}).apply(this,arguments)},a=this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var o in t)Object.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e.default=t,e},s=this&&this.__importDefault||function(t){return t&&t.__esModule?t:{default:t}},c=t("@bokehjs/core/dom"),l=a(t("@bokehjs/core/properties")),p=t("@bokehjs/models/layouts/html_box"),_=t("ec60963462"),u=t("27d3545a25"),h=s(t("093eb75864")),d=window.deck,f=window.mapboxgl,v=window.loaders;function y(){for(var t={},e=0,o=Object.keys(d).filter(function(t){return t.charAt(0)===t.charAt(0).toUpperCase()});e<o.length;e++){var n=o[e];t[n]=d[n]}return t}var m=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return i(e,t),e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this);var o=this.model.properties,n=o.data,i=o.mapbox_api_key,r=o.tooltip,a=o.layers,s=o.initialViewState,c=o.data_sources;this.on_change([i,r],function(){return e.render()}),this.on_change([n,s],function(){return e.updateDeck()}),this.on_change([a],function(){return e._update_layers()}),this.on_change([c],function(){return e._connect_sources(!0)}),this._layer_map={},this._connected=[],this._connect_sources()},e.prototype._update_layers=function(){this._layer_map={},this._update_data(!0)},e.prototype._connect_sources=function(t){var e=this;void 0===t&&(t=!1);for(var o=0,n=this.model.data_sources;o<n.length;o++){var i=n[o];this._connected.indexOf(i)<0&&(this.connect(i.properties.data.change,function(){return e._update_data(!0)}),this._connected.push(i))}this._update_data(t)},e.prototype.initialize=function(){if(t.prototype.initialize.call(this),d.JSONConverter){var e=v.CSVLoader,o=v.Tile3DLoader;v.registerLoaders([o,e]);var n={classes:y(),enumerations:{COORDINATE_SYSTEM:d.COORDINATE_SYSTEM,GL:h.default},constants:{Tile3DLoader:o}};this.jsonConverter=new d.JSONConverter({configuration:n})}},e.prototype._update_data=function(t){void 0===t&&(t=!0);for(var e=0,o=0,n=this.model.layers;o<n.length;o++){var i=n[o],r=void 0;if((e+=1)-1 in this._layer_map)r=this.model.data_sources[this._layer_map[e-1]];else{if("number"!=typeof i.data)continue;this._layer_map[e-1]=i.data,r=this.model.data_sources[i.data]}for(var a=[],s=r.columns(),c=0;c<r.data[s[0]].length;c++){for(var l={},p=0,_=s;p<_.length;p++){var u=_[p],h=r._shapes[u];void 0!==h&&h.length>1&&"number"==typeof h[0]?l[u]=r.data[u].slice(c*h[1],c*h[1]+h[1]):l[u]=r.data[u][c]}a.push(l)}i.data=a}t&&this.updateDeck()},e.prototype._on_click_event=function(t){var e={coordinate:t.coordinate,lngLat:t.lngLat,index:t.index};this.model.clickState=e},e.prototype._on_hover_event=function(t){var e={coordinate:t.coordinate,lngLat:t.lngLat,index:t.index};this.model.hoverState=e},e.prototype._on_viewState_event=function(t){this.model.viewState=t.viewState},e.prototype.getData=function(){var t=this;return r(r({},this.model.data),{layers:this.model.layers,initialViewState:this.model.initialViewState,onViewStateChange:function(e){return t._on_viewState_event(e)},onClick:function(e){return t._on_click_event(e)},onHover:function(e){return t._on_hover_event(e)}})},e.prototype.updateDeck=function(){if(this.deckGL){var t=this.getData();if(d.updateDeck)d.updateDeck(t,this.deckGL);else{var e=this.jsonConverter.convert(t);this.deckGL.setProps(e)}}else this.render()},e.prototype.createDeck=function(t){var e,o=t.mapboxApiKey,n=t.container,i=t.jsonInput,a=t.tooltip;try{var s=this.jsonConverter.convert(i),c=u.makeTooltip(a);e=new d.DeckGL(r(r({},s),{map:f,mapboxApiAccessToken:o,container:n,getTooltip:c}))}catch(t){console.error(t)}return e},e.prototype.render=function(){t.prototype.render.call(this);var e=c.div({class:"deckgl"});_.set_size(e,this.model);var o=this.model.mapbox_api_key,n=this.model.tooltip,i=this.getData();d.createDeck?this.deckGL=d.createDeck({mapboxApiKey:o,container:e,jsonInput:i,tooltip:n}):this.deckGL=this.createDeck({mapboxApiKey:o,container:e,jsonInput:i,tooltip:n}),this.el.appendChild(e)},e.__name__="DeckGLPlotView",e}(_.PanelHTMLBoxView);o.DeckGLPlotView=m;var k=function(t){function e(e){return t.call(this,e)||this}return i(e,t),e.init_DeckGLPlot=function(){this.prototype.default_view=m,this.define({data:[l.Any],data_sources:[l.Array,[]],clickState:[l.Any],hoverState:[l.Any],initialViewState:[l.Any],layers:[l.Array,[]],mapbox_api_key:[l.String],tooltip:[l.Any],viewState:[l.Any]}),this.override({height:400,width:600})},e.__name__="DeckGLPlot",e.__module__="panel.models.deckgl",e}(p.HTMLBox);o.DeckGLPlot=k,k.init_DeckGLPlot()},
"27d3545a25": function _(e,t,n){var i,r,l={fontFamily:'"Helvetica Neue", Helvetica, Arial, sans-serif',display:"flex",flex:"wrap",maxWidth:"500px",flexDirection:"column",zIndex:2};function a(){return document.createElement("div")}function o(e){if(!e.picked)return null;if(e.object===i)return r;var t={html:c(e.object),style:l};return r=t,i=e.object,t}n.getTooltipDefault=o;var s=new Set(["position","index"]);function c(e){var t=a();for(var n in e)if(!s.has(n)){var i=a();i.className="header",i.textContent=n;var r=a();r.className="value",r.textContent=u(e[n]);var l=a();f(l,i,r),l.appendChild(i),l.appendChild(r),t.appendChild(l)}return t.innerHTML}function f(e,t,n){Object.assign(t.style,{fontWeight:700,marginRight:"10px",flex:"1 1 0%"}),Object.assign(n.style,{flex:"none",maxWidth:"250px",overflow:"hidden",whiteSpace:"nowrap",textOverflow:"ellipsis"}),Object.assign(e.style,{display:"flex",flexDirection:"row",justifyContent:"space-between",alignItems:"stretch"})}function u(e){var t;if(Array.isArray(e)&&e.length>4)t="Array<"+e.length+">";else if("string"==typeof e)t=e;else if("number"==typeof e)t=String(e);else try{t=JSON.stringify(e)}catch(e){t="<Non-Serializable Object>"}return t.length>50&&(t=t.slice(0,50)),t}function p(e,t){var n=e;for(var i in t)n=n.replace("{"+i+"}",t[i]);return n}n.tabularize=c,n.toText=u,n.substituteIn=p,n.makeTooltip=function(e){return e?e.html||e.text?function(t){if(!t.picked)return null;var n={style:e.style||l};return e.html?n.html=p(e.html,t.object):n.text=p(e.text,t.object),n}:o:null}},
"093eb75864": function _(E,_,R){_.exports={DEPTH_BUFFER_BIT:256,STENCIL_BUFFER_BIT:1024,COLOR_BUFFER_BIT:16384,POINTS:0,LINES:1,LINE_LOOP:2,LINE_STRIP:3,TRIANGLES:4,TRIANGLE_STRIP:5,TRIANGLE_FAN:6,ZERO:0,ONE:1,SRC_COLOR:768,ONE_MINUS_SRC_COLOR:769,SRC_ALPHA:770,ONE_MINUS_SRC_ALPHA:771,DST_ALPHA:772,ONE_MINUS_DST_ALPHA:773,DST_COLOR:774,ONE_MINUS_DST_COLOR:775,SRC_ALPHA_SATURATE:776,CONSTANT_COLOR:32769,ONE_MINUS_CONSTANT_COLOR:32770,CONSTANT_ALPHA:32771,ONE_MINUS_CONSTANT_ALPHA:32772,FUNC_ADD:32774,FUNC_SUBTRACT:32778,FUNC_REVERSE_SUBTRACT:32779,BLEND_EQUATION:32777,BLEND_EQUATION_RGB:32777,BLEND_EQUATION_ALPHA:34877,BLEND_DST_RGB:32968,BLEND_SRC_RGB:32969,BLEND_DST_ALPHA:32970,BLEND_SRC_ALPHA:32971,BLEND_COLOR:32773,ARRAY_BUFFER_BINDING:34964,ELEMENT_ARRAY_BUFFER_BINDING:34965,LINE_WIDTH:2849,ALIASED_POINT_SIZE_RANGE:33901,ALIASED_LINE_WIDTH_RANGE:33902,CULL_FACE_MODE:2885,FRONT_FACE:2886,DEPTH_RANGE:2928,DEPTH_WRITEMASK:2930,DEPTH_CLEAR_VALUE:2931,DEPTH_FUNC:2932,STENCIL_CLEAR_VALUE:2961,STENCIL_FUNC:2962,STENCIL_FAIL:2964,STENCIL_PASS_DEPTH_FAIL:2965,STENCIL_PASS_DEPTH_PASS:2966,STENCIL_REF:2967,STENCIL_VALUE_MASK:2963,STENCIL_WRITEMASK:2968,STENCIL_BACK_FUNC:34816,STENCIL_BACK_FAIL:34817,STENCIL_BACK_PASS_DEPTH_FAIL:34818,STENCIL_BACK_PASS_DEPTH_PASS:34819,STENCIL_BACK_REF:36003,STENCIL_BACK_VALUE_MASK:36004,STENCIL_BACK_WRITEMASK:36005,VIEWPORT:2978,SCISSOR_BOX:3088,COLOR_CLEAR_VALUE:3106,COLOR_WRITEMASK:3107,UNPACK_ALIGNMENT:3317,PACK_ALIGNMENT:3333,MAX_TEXTURE_SIZE:3379,MAX_VIEWPORT_DIMS:3386,SUBPIXEL_BITS:3408,RED_BITS:3410,GREEN_BITS:3411,BLUE_BITS:3412,ALPHA_BITS:3413,DEPTH_BITS:3414,STENCIL_BITS:3415,POLYGON_OFFSET_UNITS:10752,POLYGON_OFFSET_FACTOR:32824,TEXTURE_BINDING_2D:32873,SAMPLE_BUFFERS:32936,SAMPLES:32937,SAMPLE_COVERAGE_VALUE:32938,SAMPLE_COVERAGE_INVERT:32939,COMPRESSED_TEXTURE_FORMATS:34467,VENDOR:7936,RENDERER:7937,VERSION:7938,IMPLEMENTATION_COLOR_READ_TYPE:35738,IMPLEMENTATION_COLOR_READ_FORMAT:35739,BROWSER_DEFAULT_WEBGL:37444,STATIC_DRAW:35044,STREAM_DRAW:35040,DYNAMIC_DRAW:35048,ARRAY_BUFFER:34962,ELEMENT_ARRAY_BUFFER:34963,BUFFER_SIZE:34660,BUFFER_USAGE:34661,CURRENT_VERTEX_ATTRIB:34342,VERTEX_ATTRIB_ARRAY_ENABLED:34338,VERTEX_ATTRIB_ARRAY_SIZE:34339,VERTEX_ATTRIB_ARRAY_STRIDE:34340,VERTEX_ATTRIB_ARRAY_TYPE:34341,VERTEX_ATTRIB_ARRAY_NORMALIZED:34922,VERTEX_ATTRIB_ARRAY_POINTER:34373,VERTEX_ATTRIB_ARRAY_BUFFER_BINDING:34975,CULL_FACE:2884,FRONT:1028,BACK:1029,FRONT_AND_BACK:1032,BLEND:3042,DEPTH_TEST:2929,DITHER:3024,POLYGON_OFFSET_FILL:32823,SAMPLE_ALPHA_TO_COVERAGE:32926,SAMPLE_COVERAGE:32928,SCISSOR_TEST:3089,STENCIL_TEST:2960,NO_ERROR:0,INVALID_ENUM:1280,INVALID_VALUE:1281,INVALID_OPERATION:1282,OUT_OF_MEMORY:1285,CONTEXT_LOST_WEBGL:37442,CW:2304,CCW:2305,DONT_CARE:4352,FASTEST:4353,NICEST:4354,GENERATE_MIPMAP_HINT:33170,BYTE:5120,UNSIGNED_BYTE:5121,SHORT:5122,UNSIGNED_SHORT:5123,INT:5124,UNSIGNED_INT:5125,FLOAT:5126,DOUBLE:5130,DEPTH_COMPONENT:6402,ALPHA:6406,RGB:6407,RGBA:6408,LUMINANCE:6409,LUMINANCE_ALPHA:6410,UNSIGNED_SHORT_4_4_4_4:32819,UNSIGNED_SHORT_5_5_5_1:32820,UNSIGNED_SHORT_5_6_5:33635,FRAGMENT_SHADER:35632,VERTEX_SHADER:35633,COMPILE_STATUS:35713,DELETE_STATUS:35712,LINK_STATUS:35714,VALIDATE_STATUS:35715,ATTACHED_SHADERS:35717,ACTIVE_ATTRIBUTES:35721,ACTIVE_UNIFORMS:35718,MAX_VERTEX_ATTRIBS:34921,MAX_VERTEX_UNIFORM_VECTORS:36347,MAX_VARYING_VECTORS:36348,MAX_COMBINED_TEXTURE_IMAGE_UNITS:35661,MAX_VERTEX_TEXTURE_IMAGE_UNITS:35660,MAX_TEXTURE_IMAGE_UNITS:34930,MAX_FRAGMENT_UNIFORM_VECTORS:36349,SHADER_TYPE:35663,SHADING_LANGUAGE_VERSION:35724,CURRENT_PROGRAM:35725,NEVER:512,ALWAYS:519,LESS:513,EQUAL:514,LEQUAL:515,GREATER:516,GEQUAL:518,NOTEQUAL:517,KEEP:7680,REPLACE:7681,INCR:7682,DECR:7683,INVERT:5386,INCR_WRAP:34055,DECR_WRAP:34056,NEAREST:9728,LINEAR:9729,NEAREST_MIPMAP_NEAREST:9984,LINEAR_MIPMAP_NEAREST:9985,NEAREST_MIPMAP_LINEAR:9986,LINEAR_MIPMAP_LINEAR:9987,TEXTURE_MAG_FILTER:10240,TEXTURE_MIN_FILTER:10241,TEXTURE_WRAP_S:10242,TEXTURE_WRAP_T:10243,TEXTURE_2D:3553,TEXTURE:5890,TEXTURE_CUBE_MAP:34067,TEXTURE_BINDING_CUBE_MAP:34068,TEXTURE_CUBE_MAP_POSITIVE_X:34069,TEXTURE_CUBE_MAP_NEGATIVE_X:34070,TEXTURE_CUBE_MAP_POSITIVE_Y:34071,TEXTURE_CUBE_MAP_NEGATIVE_Y:34072,TEXTURE_CUBE_MAP_POSITIVE_Z:34073,TEXTURE_CUBE_MAP_NEGATIVE_Z:34074,MAX_CUBE_MAP_TEXTURE_SIZE:34076,TEXTURE0:33984,ACTIVE_TEXTURE:34016,REPEAT:10497,CLAMP_TO_EDGE:33071,MIRRORED_REPEAT:33648,TEXTURE_WIDTH:4096,TEXTURE_HEIGHT:4097,FLOAT_VEC2:35664,FLOAT_VEC3:35665,FLOAT_VEC4:35666,INT_VEC2:35667,INT_VEC3:35668,INT_VEC4:35669,BOOL:35670,BOOL_VEC2:35671,BOOL_VEC3:35672,BOOL_VEC4:35673,FLOAT_MAT2:35674,FLOAT_MAT3:35675,FLOAT_MAT4:35676,SAMPLER_2D:35678,SAMPLER_CUBE:35680,LOW_FLOAT:36336,MEDIUM_FLOAT:36337,HIGH_FLOAT:36338,LOW_INT:36339,MEDIUM_INT:36340,HIGH_INT:36341,FRAMEBUFFER:36160,RENDERBUFFER:36161,RGBA4:32854,RGB5_A1:32855,RGB565:36194,DEPTH_COMPONENT16:33189,STENCIL_INDEX:6401,STENCIL_INDEX8:36168,DEPTH_STENCIL:34041,RENDERBUFFER_WIDTH:36162,RENDERBUFFER_HEIGHT:36163,RENDERBUFFER_INTERNAL_FORMAT:36164,RENDERBUFFER_RED_SIZE:36176,RENDERBUFFER_GREEN_SIZE:36177,RENDERBUFFER_BLUE_SIZE:36178,RENDERBUFFER_ALPHA_SIZE:36179,RENDERBUFFER_DEPTH_SIZE:36180,RENDERBUFFER_STENCIL_SIZE:36181,FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE:36048,FRAMEBUFFER_ATTACHMENT_OBJECT_NAME:36049,FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL:36050,FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE:36051,COLOR_ATTACHMENT0:36064,DEPTH_ATTACHMENT:36096,STENCIL_ATTACHMENT:36128,DEPTH_STENCIL_ATTACHMENT:33306,NONE:0,FRAMEBUFFER_COMPLETE:36053,FRAMEBUFFER_INCOMPLETE_ATTACHMENT:36054,FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:36055,FRAMEBUFFER_INCOMPLETE_DIMENSIONS:36057,FRAMEBUFFER_UNSUPPORTED:36061,FRAMEBUFFER_BINDING:36006,RENDERBUFFER_BINDING:36007,READ_FRAMEBUFFER:36008,DRAW_FRAMEBUFFER:36009,MAX_RENDERBUFFER_SIZE:34024,INVALID_FRAMEBUFFER_OPERATION:1286,UNPACK_FLIP_Y_WEBGL:37440,UNPACK_PREMULTIPLY_ALPHA_WEBGL:37441,UNPACK_COLORSPACE_CONVERSION_WEBGL:37443,READ_BUFFER:3074,UNPACK_ROW_LENGTH:3314,UNPACK_SKIP_ROWS:3315,UNPACK_SKIP_PIXELS:3316,PACK_ROW_LENGTH:3330,PACK_SKIP_ROWS:3331,PACK_SKIP_PIXELS:3332,TEXTURE_BINDING_3D:32874,UNPACK_SKIP_IMAGES:32877,UNPACK_IMAGE_HEIGHT:32878,MAX_3D_TEXTURE_SIZE:32883,MAX_ELEMENTS_VERTICES:33e3,MAX_ELEMENTS_INDICES:33001,MAX_TEXTURE_LOD_BIAS:34045,MAX_FRAGMENT_UNIFORM_COMPONENTS:35657,MAX_VERTEX_UNIFORM_COMPONENTS:35658,MAX_ARRAY_TEXTURE_LAYERS:35071,MIN_PROGRAM_TEXEL_OFFSET:35076,MAX_PROGRAM_TEXEL_OFFSET:35077,MAX_VARYING_COMPONENTS:35659,FRAGMENT_SHADER_DERIVATIVE_HINT:35723,RASTERIZER_DISCARD:35977,VERTEX_ARRAY_BINDING:34229,MAX_VERTEX_OUTPUT_COMPONENTS:37154,MAX_FRAGMENT_INPUT_COMPONENTS:37157,MAX_SERVER_WAIT_TIMEOUT:37137,MAX_ELEMENT_INDEX:36203,RED:6403,RGB8:32849,RGBA8:32856,RGB10_A2:32857,TEXTURE_3D:32879,TEXTURE_WRAP_R:32882,TEXTURE_MIN_LOD:33082,TEXTURE_MAX_LOD:33083,TEXTURE_BASE_LEVEL:33084,TEXTURE_MAX_LEVEL:33085,TEXTURE_COMPARE_MODE:34892,TEXTURE_COMPARE_FUNC:34893,SRGB:35904,SRGB8:35905,SRGB8_ALPHA8:35907,COMPARE_REF_TO_TEXTURE:34894,RGBA32F:34836,RGB32F:34837,RGBA16F:34842,RGB16F:34843,TEXTURE_2D_ARRAY:35866,TEXTURE_BINDING_2D_ARRAY:35869,R11F_G11F_B10F:35898,RGB9_E5:35901,RGBA32UI:36208,RGB32UI:36209,RGBA16UI:36214,RGB16UI:36215,RGBA8UI:36220,RGB8UI:36221,RGBA32I:36226,RGB32I:36227,RGBA16I:36232,RGB16I:36233,RGBA8I:36238,RGB8I:36239,RED_INTEGER:36244,RGB_INTEGER:36248,RGBA_INTEGER:36249,R8:33321,RG8:33323,R16F:33325,R32F:33326,RG16F:33327,RG32F:33328,R8I:33329,R8UI:33330,R16I:33331,R16UI:33332,R32I:33333,R32UI:33334,RG8I:33335,RG8UI:33336,RG16I:33337,RG16UI:33338,RG32I:33339,RG32UI:33340,R8_SNORM:36756,RG8_SNORM:36757,RGB8_SNORM:36758,RGBA8_SNORM:36759,RGB10_A2UI:36975,TEXTURE_IMMUTABLE_FORMAT:37167,TEXTURE_IMMUTABLE_LEVELS:33503,UNSIGNED_INT_2_10_10_10_REV:33640,UNSIGNED_INT_10F_11F_11F_REV:35899,UNSIGNED_INT_5_9_9_9_REV:35902,FLOAT_32_UNSIGNED_INT_24_8_REV:36269,UNSIGNED_INT_24_8:34042,HALF_FLOAT:5131,RG:33319,RG_INTEGER:33320,INT_2_10_10_10_REV:36255,CURRENT_QUERY:34917,QUERY_RESULT:34918,QUERY_RESULT_AVAILABLE:34919,ANY_SAMPLES_PASSED:35887,ANY_SAMPLES_PASSED_CONSERVATIVE:36202,MAX_DRAW_BUFFERS:34852,DRAW_BUFFER0:34853,DRAW_BUFFER1:34854,DRAW_BUFFER2:34855,DRAW_BUFFER3:34856,DRAW_BUFFER4:34857,DRAW_BUFFER5:34858,DRAW_BUFFER6:34859,DRAW_BUFFER7:34860,DRAW_BUFFER8:34861,DRAW_BUFFER9:34862,DRAW_BUFFER10:34863,DRAW_BUFFER11:34864,DRAW_BUFFER12:34865,DRAW_BUFFER13:34866,DRAW_BUFFER14:34867,DRAW_BUFFER15:34868,MAX_COLOR_ATTACHMENTS:36063,COLOR_ATTACHMENT1:36065,COLOR_ATTACHMENT2:36066,COLOR_ATTACHMENT3:36067,COLOR_ATTACHMENT4:36068,COLOR_ATTACHMENT5:36069,COLOR_ATTACHMENT6:36070,COLOR_ATTACHMENT7:36071,COLOR_ATTACHMENT8:36072,COLOR_ATTACHMENT9:36073,COLOR_ATTACHMENT10:36074,COLOR_ATTACHMENT11:36075,COLOR_ATTACHMENT12:36076,COLOR_ATTACHMENT13:36077,COLOR_ATTACHMENT14:36078,COLOR_ATTACHMENT15:36079,SAMPLER_3D:35679,SAMPLER_2D_SHADOW:35682,SAMPLER_2D_ARRAY:36289,SAMPLER_2D_ARRAY_SHADOW:36292,SAMPLER_CUBE_SHADOW:36293,INT_SAMPLER_2D:36298,INT_SAMPLER_3D:36299,INT_SAMPLER_CUBE:36300,INT_SAMPLER_2D_ARRAY:36303,UNSIGNED_INT_SAMPLER_2D:36306,UNSIGNED_INT_SAMPLER_3D:36307,UNSIGNED_INT_SAMPLER_CUBE:36308,UNSIGNED_INT_SAMPLER_2D_ARRAY:36311,MAX_SAMPLES:36183,SAMPLER_BINDING:35097,PIXEL_PACK_BUFFER:35051,PIXEL_UNPACK_BUFFER:35052,PIXEL_PACK_BUFFER_BINDING:35053,PIXEL_UNPACK_BUFFER_BINDING:35055,COPY_READ_BUFFER:36662,COPY_WRITE_BUFFER:36663,COPY_READ_BUFFER_BINDING:36662,COPY_WRITE_BUFFER_BINDING:36663,FLOAT_MAT2x3:35685,FLOAT_MAT2x4:35686,FLOAT_MAT3x2:35687,FLOAT_MAT3x4:35688,FLOAT_MAT4x2:35689,FLOAT_MAT4x3:35690,UNSIGNED_INT_VEC2:36294,UNSIGNED_INT_VEC3:36295,UNSIGNED_INT_VEC4:36296,UNSIGNED_NORMALIZED:35863,SIGNED_NORMALIZED:36764,VERTEX_ATTRIB_ARRAY_INTEGER:35069,VERTEX_ATTRIB_ARRAY_DIVISOR:35070,TRANSFORM_FEEDBACK_BUFFER_MODE:35967,MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS:35968,TRANSFORM_FEEDBACK_VARYINGS:35971,TRANSFORM_FEEDBACK_BUFFER_START:35972,TRANSFORM_FEEDBACK_BUFFER_SIZE:35973,TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN:35976,MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS:35978,MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS:35979,INTERLEAVED_ATTRIBS:35980,SEPARATE_ATTRIBS:35981,TRANSFORM_FEEDBACK_BUFFER:35982,TRANSFORM_FEEDBACK_BUFFER_BINDING:35983,TRANSFORM_FEEDBACK:36386,TRANSFORM_FEEDBACK_PAUSED:36387,TRANSFORM_FEEDBACK_ACTIVE:36388,TRANSFORM_FEEDBACK_BINDING:36389,FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING:33296,FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE:33297,FRAMEBUFFER_ATTACHMENT_RED_SIZE:33298,FRAMEBUFFER_ATTACHMENT_GREEN_SIZE:33299,FRAMEBUFFER_ATTACHMENT_BLUE_SIZE:33300,FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE:33301,FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE:33302,FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE:33303,FRAMEBUFFER_DEFAULT:33304,DEPTH24_STENCIL8:35056,DRAW_FRAMEBUFFER_BINDING:36006,READ_FRAMEBUFFER_BINDING:36010,RENDERBUFFER_SAMPLES:36011,FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER:36052,FRAMEBUFFER_INCOMPLETE_MULTISAMPLE:36182,UNIFORM_BUFFER:35345,UNIFORM_BUFFER_BINDING:35368,UNIFORM_BUFFER_START:35369,UNIFORM_BUFFER_SIZE:35370,MAX_VERTEX_UNIFORM_BLOCKS:35371,MAX_FRAGMENT_UNIFORM_BLOCKS:35373,MAX_COMBINED_UNIFORM_BLOCKS:35374,MAX_UNIFORM_BUFFER_BINDINGS:35375,MAX_UNIFORM_BLOCK_SIZE:35376,MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS:35377,MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS:35379,UNIFORM_BUFFER_OFFSET_ALIGNMENT:35380,ACTIVE_UNIFORM_BLOCKS:35382,UNIFORM_TYPE:35383,UNIFORM_SIZE:35384,UNIFORM_BLOCK_INDEX:35386,UNIFORM_OFFSET:35387,UNIFORM_ARRAY_STRIDE:35388,UNIFORM_MATRIX_STRIDE:35389,UNIFORM_IS_ROW_MAJOR:35390,UNIFORM_BLOCK_BINDING:35391,UNIFORM_BLOCK_DATA_SIZE:35392,UNIFORM_BLOCK_ACTIVE_UNIFORMS:35394,UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES:35395,UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER:35396,UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER:35398,OBJECT_TYPE:37138,SYNC_CONDITION:37139,SYNC_STATUS:37140,SYNC_FLAGS:37141,SYNC_FENCE:37142,SYNC_GPU_COMMANDS_COMPLETE:37143,UNSIGNALED:37144,SIGNALED:37145,ALREADY_SIGNALED:37146,TIMEOUT_EXPIRED:37147,CONDITION_SATISFIED:37148,WAIT_FAILED:37149,SYNC_FLUSH_COMMANDS_BIT:1,COLOR:6144,DEPTH:6145,STENCIL:6146,MIN:32775,MAX:32776,DEPTH_COMPONENT24:33190,STREAM_READ:35041,STREAM_COPY:35042,STATIC_READ:35045,STATIC_COPY:35046,DYNAMIC_READ:35049,DYNAMIC_COPY:35050,DEPTH_COMPONENT32F:36012,DEPTH32F_STENCIL8:36013,INVALID_INDEX:4294967295,TIMEOUT_IGNORED:-1,MAX_CLIENT_WAIT_TIMEOUT_WEBGL:37447,VERTEX_ATTRIB_ARRAY_DIVISOR_ANGLE:35070,UNMASKED_VENDOR_WEBGL:37445,UNMASKED_RENDERER_WEBGL:37446,MAX_TEXTURE_MAX_ANISOTROPY_EXT:34047,TEXTURE_MAX_ANISOTROPY_EXT:34046,COMPRESSED_RGB_S3TC_DXT1_EXT:33776,COMPRESSED_RGBA_S3TC_DXT1_EXT:33777,COMPRESSED_RGBA_S3TC_DXT3_EXT:33778,COMPRESSED_RGBA_S3TC_DXT5_EXT:33779,COMPRESSED_R11_EAC:37488,COMPRESSED_SIGNED_R11_EAC:37489,COMPRESSED_RG11_EAC:37490,COMPRESSED_SIGNED_RG11_EAC:37491,COMPRESSED_RGB8_ETC2:37492,COMPRESSED_RGBA8_ETC2_EAC:37493,COMPRESSED_SRGB8_ETC2:37494,COMPRESSED_SRGB8_ALPHA8_ETC2_EAC:37495,COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2:37496,COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2:37497,COMPRESSED_RGB_PVRTC_4BPPV1_IMG:35840,COMPRESSED_RGBA_PVRTC_4BPPV1_IMG:35842,COMPRESSED_RGB_PVRTC_2BPPV1_IMG:35841,COMPRESSED_RGBA_PVRTC_2BPPV1_IMG:35843,COMPRESSED_RGB_ETC1_WEBGL:36196,COMPRESSED_RGB_ATC_WEBGL:35986,COMPRESSED_RGBA_ATC_EXPLICIT_ALPHA_WEBGL:35986,COMPRESSED_RGBA_ATC_INTERPOLATED_ALPHA_WEBGL:34798,UNSIGNED_INT_24_8_WEBGL:34042,HALF_FLOAT_OES:36193,RGBA32F_EXT:34836,RGB32F_EXT:34837,FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT:33297,UNSIGNED_NORMALIZED_EXT:35863,MIN_EXT:32775,MAX_EXT:32776,SRGB_EXT:35904,SRGB_ALPHA_EXT:35906,SRGB8_ALPHA8_EXT:35907,FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING_EXT:33296,FRAGMENT_SHADER_DERIVATIVE_HINT_OES:35723,COLOR_ATTACHMENT0_WEBGL:36064,COLOR_ATTACHMENT1_WEBGL:36065,COLOR_ATTACHMENT2_WEBGL:36066,COLOR_ATTACHMENT3_WEBGL:36067,COLOR_ATTACHMENT4_WEBGL:36068,COLOR_ATTACHMENT5_WEBGL:36069,COLOR_ATTACHMENT6_WEBGL:36070,COLOR_ATTACHMENT7_WEBGL:36071,COLOR_ATTACHMENT8_WEBGL:36072,COLOR_ATTACHMENT9_WEBGL:36073,COLOR_ATTACHMENT10_WEBGL:36074,COLOR_ATTACHMENT11_WEBGL:36075,COLOR_ATTACHMENT12_WEBGL:36076,COLOR_ATTACHMENT13_WEBGL:36077,COLOR_ATTACHMENT14_WEBGL:36078,COLOR_ATTACHMENT15_WEBGL:36079,DRAW_BUFFER0_WEBGL:34853,DRAW_BUFFER1_WEBGL:34854,DRAW_BUFFER2_WEBGL:34855,DRAW_BUFFER3_WEBGL:34856,DRAW_BUFFER4_WEBGL:34857,DRAW_BUFFER5_WEBGL:34858,DRAW_BUFFER6_WEBGL:34859,DRAW_BUFFER7_WEBGL:34860,DRAW_BUFFER8_WEBGL:34861,DRAW_BUFFER9_WEBGL:34862,DRAW_BUFFER10_WEBGL:34863,DRAW_BUFFER11_WEBGL:34864,DRAW_BUFFER12_WEBGL:34865,DRAW_BUFFER13_WEBGL:34866,DRAW_BUFFER14_WEBGL:34867,DRAW_BUFFER15_WEBGL:34868,MAX_COLOR_ATTACHMENTS_WEBGL:36063,MAX_DRAW_BUFFERS_WEBGL:34852,VERTEX_ARRAY_BINDING_OES:34229,QUERY_COUNTER_BITS_EXT:34916,CURRENT_QUERY_EXT:34917,QUERY_RESULT_EXT:34918,QUERY_RESULT_AVAILABLE_EXT:34919,TIME_ELAPSED_EXT:35007,TIMESTAMP_EXT:36392,GPU_DISJOINT_EXT:36795}},
"70a2bb70ef": function _(t,e,r){var n,o=this&&this.__extends||(n=function(t,e){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])})(t,e)},function(t,e){function r(){this.constructor=t}n(t,e),t.prototype=null===e?Object.create(e):(r.prototype=e.prototype,new r)}),i=t("@bokehjs/models/widgets/markup");var a=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return o(e,t),e.prototype.render=function(){t.prototype.render.call(this);var e,r=(e=this.model.text,(new DOMParser).parseFromString(e,"text/html").documentElement.textContent)||this.model.text;r?(this.markup_el.innerHTML=r,Array.from(this.markup_el.querySelectorAll("script")).forEach(function(t){var e=document.createElement("script");Array.from(t.attributes).forEach(function(t){return e.setAttribute(t.name,t.value)}),e.appendChild(document.createTextNode(t.innerHTML)),t.parentNode&&t.parentNode.replaceChild(e,t)})):this.markup_el.innerHTML=""},e.__name__="HTMLView",e}(t("ec60963462").PanelMarkupView);r.HTMLView=a;var u=function(t){function e(e){return t.call(this,e)||this}return o(e,t),e.init_HTML=function(){this.prototype.default_view=a},e.__name__="HTML",e.__module__="panel.models.markup",e}(i.Markup);r.HTML=u,u.init_HTML()},
"dac8d750fa": function _(e,t,r){var n,o=this&&this.__extends||(n=function(e,t){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(e,t)},function(e,t){function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),i=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var r in e)Object.hasOwnProperty.call(e,r)&&(t[r]=e[r]);return t.default=e,t},a=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}},u=i(e("@bokehjs/core/properties")),s=e("@bokehjs/models/widgets/markup"),p=a(e("5901339020")),l=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return o(t,e),t.prototype.render=function(){e.prototype.render.call(this);var t,r=this.model.text.replace(/(\r\n|\n|\r)/gm,"").replace("'",'"');try{t=window.JSON.parse(r)}catch(e){return void(this.markup_el.innerHTML="<b>Invalid JSON:</b> "+e.toString())}var n={hoverPreviewEnabled:this.model.hover_preview,theme:this.model.theme},o=new p.default(t,this.model.depth,n).render(),i="border-radius: 5px; padding: 10px;";"dark"==this.model.theme?o.style.cssText="background-color: rgb(30, 30, 30);"+i:o.style.cssText=i,this.markup_el.append(o)},t.__name__="JSONView",t}(e("ec60963462").PanelMarkupView);r.JSONView=l;var _=["dark","light"],h=function(e){function t(t){return e.call(this,t)||this}return o(t,e),t.init_JSON=function(){this.prototype.default_view=l,this.define({depth:[u.Number,1],hover_preview:[u.Boolean,!1],theme:[u.Enum(_),"dark"]})},t.__name__="JSON",t.__module__="panel.models.markup",t}(s.Markup);r.JSON=h,h.init_JSON()},
"5901339020": function _(e,t,r){t.exports=function(e){function t(n){if(r[n])return r[n].exports;var o=r[n]={i:n,l:!1,exports:{}};return e[n].call(o.exports,o,o.exports,t),o.l=!0,o.exports}var r={};return t.m=e,t.c=r,t.i=function(e){return e},t.d=function(e,r,n){t.o(e,r)||Object.defineProperty(e,r,{configurable:!1,enumerable:!0,get:n})},t.n=function(e){var r=e&&e.__esModule?function(){return e.default}:function(){return e};return t.d(r,"a",r),r},t.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},t.p="dist",t(t.s=6)}([function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(5),o=r(4),i=(r.n(o),/(^\d{1,4}[\.|\\\/|-]\d{1,2}[\.|\\\/|-]\d{1,4})(\s*(?:0?[1-9]:[0-5]|1(?=[012])\d:[0-5])\d\s*[ap]m)?$/),s=/\d{2}:\d{2}:\d{2} GMT-\d{4}/,a=/\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}.\d{3}Z/,f=window.requestAnimationFrame||function(e){return e(),0},c={hoverPreviewEnabled:!1,hoverPreviewArrayCount:100,hoverPreviewFieldCount:5,animateOpen:!0,animateClose:!0,theme:null,useToJSON:!0,sortPropertiesBy:null},l=function(){function e(e,t,r,n){void 0===t&&(t=1),void 0===r&&(r=c),this.json=e,this.open=t,this.config=r,this.key=n,this._isOpen=null,void 0===this.config.hoverPreviewEnabled&&(this.config.hoverPreviewEnabled=c.hoverPreviewEnabled),void 0===this.config.hoverPreviewArrayCount&&(this.config.hoverPreviewArrayCount=c.hoverPreviewArrayCount),void 0===this.config.hoverPreviewFieldCount&&(this.config.hoverPreviewFieldCount=c.hoverPreviewFieldCount),void 0===this.config.useToJSON&&(this.config.useToJSON=c.useToJSON)}return Object.defineProperty(e.prototype,"isOpen",{get:function(){return null!==this._isOpen?this._isOpen:this.open>0},set:function(e){this._isOpen=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isDate",{get:function(){return this.json instanceof Date||"string"===this.type&&(i.test(this.json)||a.test(this.json)||s.test(this.json))},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isUrl",{get:function(){return"string"===this.type&&0===this.json.indexOf("http")},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isArray",{get:function(){return Array.isArray(this.json)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isObject",{get:function(){return r.i(n.a)(this.json)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isEmptyObject",{get:function(){return!this.keys.length&&!this.isArray},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isEmpty",{get:function(){return this.isEmptyObject||this.keys&&!this.keys.length&&this.isArray},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"useToJSON",{get:function(){return this.config.useToJSON&&"stringifiable"===this.type},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"hasKey",{get:function(){return void 0!==this.key},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"constructorName",{get:function(){return r.i(n.b)(this.json)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"type",{get:function(){return null===this.json?"null":this.config.useToJSON&&this.json&&this.json.toJSON?"stringifiable":typeof this.json},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"keys",{get:function(){if(this.isObject){var e=Object.keys(this.json).map(function(e){return e||'""'});return!this.isArray&&this.config.sortPropertiesBy?e.sort(this.config.sortPropertiesBy):e}return[]},enumerable:!0,configurable:!0}),e.prototype.toggleOpen=function(){this.isOpen=!this.isOpen,this.element&&(this.isOpen?this.appendChildren(this.config.animateOpen):this.removeChildren(this.config.animateClose),this.element.classList.toggle(r.i(n.c)("open")))},e.prototype.openAtDepth=function(e){void 0===e&&(e=1),e<0||(this.open=e,this.isOpen=0!==e,this.element&&(this.removeChildren(!1),0===e?this.element.classList.remove(r.i(n.c)("open")):(this.appendChildren(this.config.animateOpen),this.element.classList.add(r.i(n.c)("open")))))},e.prototype.getInlinepreview=function(){var e=this;if(this.isArray)return this.json.length>this.config.hoverPreviewArrayCount?"Array["+this.json.length+"]":"["+this.json.map(n.d).join(", ")+"]";var t=this.keys,o=t.slice(0,this.config.hoverPreviewFieldCount).map(function(t){return t+":"+r.i(n.d)(e.type,e.json[t])}),i=t.length>=this.config.hoverPreviewFieldCount?"…":"";return"{"+o.join(", ")+i+"}"},e.prototype.render=function(){this.element=r.i(n.e)("div","row");var e=this.isObject?r.i(n.e)("a","toggler-link"):r.i(n.e)("span");if(this.isObject&&!this.useToJSON&&e.appendChild(r.i(n.e)("span","toggler")),this.hasKey&&e.appendChild(r.i(n.e)("span","key",this.key+":")),this.isObject&&!this.useToJSON){var t=r.i(n.e)("span","value"),o=r.i(n.e)("span"),i=r.i(n.e)("span","constructor-name",this.constructorName);if(o.appendChild(i),this.isArray){var s=r.i(n.e)("span");s.appendChild(r.i(n.e)("span","bracket","[")),s.appendChild(r.i(n.e)("span","number",this.json.length)),s.appendChild(r.i(n.e)("span","bracket","]")),o.appendChild(s)}t.appendChild(o),e.appendChild(t)}else{(t=this.isUrl?r.i(n.e)("a"):r.i(n.e)("span")).classList.add(r.i(n.c)(this.type)),this.isDate&&t.classList.add(r.i(n.c)("date")),this.isUrl&&(t.classList.add(r.i(n.c)("url")),t.setAttribute("href",this.json));var a=r.i(n.f)(this.type,this.json,this.useToJSON?this.json.toJSON():this.json);t.appendChild(document.createTextNode(a)),e.appendChild(t)}if(this.isObject&&this.config.hoverPreviewEnabled){var f=r.i(n.e)("span","preview-text");f.appendChild(document.createTextNode(this.getInlinepreview())),e.appendChild(f)}var c=r.i(n.e)("div","children");return this.isObject&&c.classList.add(r.i(n.c)("object")),this.isArray&&c.classList.add(r.i(n.c)("array")),this.isEmpty&&c.classList.add(r.i(n.c)("empty")),this.config&&this.config.theme&&this.element.classList.add(r.i(n.c)(this.config.theme)),this.isOpen&&this.element.classList.add(r.i(n.c)("open")),this.element.appendChild(e),this.element.appendChild(c),this.isObject&&this.isOpen&&this.appendChildren(),this.isObject&&!this.useToJSON&&e.addEventListener("click",this.toggleOpen.bind(this)),this.element},e.prototype.appendChildren=function(t){var o=this;void 0===t&&(t=!1);var i=this.element.querySelector("div."+r.i(n.c)("children"));if(i&&!this.isEmpty)if(t){var s=0,a=function(){var t=o.keys[s],r=new e(o.json[t],o.open-1,o.config,t);i.appendChild(r.render()),(s+=1)<o.keys.length&&(s>10?a():f(a))};f(a)}else this.keys.forEach(function(t){var r=new e(o.json[t],o.open-1,o.config,t);i.appendChild(r.render())})},e.prototype.removeChildren=function(e){void 0===e&&(e=!1);var t=this.element.querySelector("div."+r.i(n.c)("children"));if(e){var o=0,i=function(){t&&t.children.length&&(t.removeChild(t.children[0]),(o+=1)>10?i():f(i))};f(i)}else t&&(t.innerHTML="")},e}();t.default=l},function(e,t,r){(e.exports=r(2)()).push([e.i,'.json-formatter-row {\n  font-family: monospace;\n}\n.json-formatter-row,\n.json-formatter-row a,\n.json-formatter-row a:hover {\n  color: black;\n  text-decoration: none;\n}\n.json-formatter-row .json-formatter-row {\n  margin-left: 1rem;\n}\n.json-formatter-row .json-formatter-children.json-formatter-empty {\n  opacity: 0.5;\n  margin-left: 1rem;\n}\n.json-formatter-row .json-formatter-children.json-formatter-empty:after {\n  display: none;\n}\n.json-formatter-row .json-formatter-children.json-formatter-empty.json-formatter-object:after {\n  content: "No properties";\n}\n.json-formatter-row .json-formatter-children.json-formatter-empty.json-formatter-array:after {\n  content: "[]";\n}\n.json-formatter-row .json-formatter-string,\n.json-formatter-row .json-formatter-stringifiable {\n  color: green;\n  white-space: pre;\n  word-wrap: break-word;\n}\n.json-formatter-row .json-formatter-number {\n  color: blue;\n}\n.json-formatter-row .json-formatter-boolean {\n  color: red;\n}\n.json-formatter-row .json-formatter-null {\n  color: #855A00;\n}\n.json-formatter-row .json-formatter-undefined {\n  color: #ca0b69;\n}\n.json-formatter-row .json-formatter-function {\n  color: #FF20ED;\n}\n.json-formatter-row .json-formatter-date {\n  background-color: rgba(0, 0, 0, 0.05);\n}\n.json-formatter-row .json-formatter-url {\n  text-decoration: underline;\n  color: blue;\n  cursor: pointer;\n}\n.json-formatter-row .json-formatter-bracket {\n  color: blue;\n}\n.json-formatter-row .json-formatter-key {\n  color: #00008B;\n  padding-right: 0.2rem;\n}\n.json-formatter-row .json-formatter-toggler-link {\n  cursor: pointer;\n}\n.json-formatter-row .json-formatter-toggler {\n  line-height: 1.2rem;\n  font-size: 0.7rem;\n  vertical-align: middle;\n  opacity: 0.6;\n  cursor: pointer;\n  padding-right: 0.2rem;\n}\n.json-formatter-row .json-formatter-toggler:after {\n  display: inline-block;\n  transition: transform 100ms ease-in;\n  content: "\\25BA";\n}\n.json-formatter-row > a > .json-formatter-preview-text {\n  opacity: 0;\n  transition: opacity 0.15s ease-in;\n  font-style: italic;\n}\n.json-formatter-row:hover > a > .json-formatter-preview-text {\n  opacity: 0.6;\n}\n.json-formatter-row.json-formatter-open > .json-formatter-toggler-link .json-formatter-toggler:after {\n  transform: rotate(90deg);\n}\n.json-formatter-row.json-formatter-open > .json-formatter-children:after {\n  display: inline-block;\n}\n.json-formatter-row.json-formatter-open > a > .json-formatter-preview-text {\n  display: none;\n}\n.json-formatter-row.json-formatter-open.json-formatter-empty:after {\n  display: block;\n}\n.json-formatter-dark.json-formatter-row {\n  font-family: monospace;\n}\n.json-formatter-dark.json-formatter-row,\n.json-formatter-dark.json-formatter-row a,\n.json-formatter-dark.json-formatter-row a:hover {\n  color: white;\n  text-decoration: none;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-row {\n  margin-left: 1rem;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-children.json-formatter-empty {\n  opacity: 0.5;\n  margin-left: 1rem;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-children.json-formatter-empty:after {\n  display: none;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-children.json-formatter-empty.json-formatter-object:after {\n  content: "No properties";\n}\n.json-formatter-dark.json-formatter-row .json-formatter-children.json-formatter-empty.json-formatter-array:after {\n  content: "[]";\n}\n.json-formatter-dark.json-formatter-row .json-formatter-string,\n.json-formatter-dark.json-formatter-row .json-formatter-stringifiable {\n  color: #31F031;\n  white-space: pre;\n  word-wrap: break-word;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-number {\n  color: #66C2FF;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-boolean {\n  color: #EC4242;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-null {\n  color: #EEC97D;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-undefined {\n  color: #ef8fbe;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-function {\n  color: #FD48CB;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-date {\n  background-color: rgba(255, 255, 255, 0.05);\n}\n.json-formatter-dark.json-formatter-row .json-formatter-url {\n  text-decoration: underline;\n  color: #027BFF;\n  cursor: pointer;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-bracket {\n  color: #9494FF;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-key {\n  color: #23A0DB;\n  padding-right: 0.2rem;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-toggler-link {\n  cursor: pointer;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-toggler {\n  line-height: 1.2rem;\n  font-size: 0.7rem;\n  vertical-align: middle;\n  opacity: 0.6;\n  cursor: pointer;\n  padding-right: 0.2rem;\n}\n.json-formatter-dark.json-formatter-row .json-formatter-toggler:after {\n  display: inline-block;\n  transition: transform 100ms ease-in;\n  content: "\\25BA";\n}\n.json-formatter-dark.json-formatter-row > a > .json-formatter-preview-text {\n  opacity: 0;\n  transition: opacity 0.15s ease-in;\n  font-style: italic;\n}\n.json-formatter-dark.json-formatter-row:hover > a > .json-formatter-preview-text {\n  opacity: 0.6;\n}\n.json-formatter-dark.json-formatter-row.json-formatter-open > .json-formatter-toggler-link .json-formatter-toggler:after {\n  transform: rotate(90deg);\n}\n.json-formatter-dark.json-formatter-row.json-formatter-open > .json-formatter-children:after {\n  display: inline-block;\n}\n.json-formatter-dark.json-formatter-row.json-formatter-open > a > .json-formatter-preview-text {\n  display: none;\n}\n.json-formatter-dark.json-formatter-row.json-formatter-open.json-formatter-empty:after {\n  display: block;\n}\n',""])},function(e,t){e.exports=function(){var e=[];return e.toString=function(){for(var e=[],t=0;t<this.length;t++){var r=this[t];r[2]?e.push("@media "+r[2]+"{"+r[1]+"}"):e.push(r[1])}return e.join("")},e.i=function(t,r){"string"==typeof t&&(t=[[null,t,""]]);for(var n={},o=0;o<this.length;o++){var i=this[o][0];"number"==typeof i&&(n[i]=!0)}for(o=0;o<t.length;o++){var s=t[o];"number"==typeof s[0]&&n[s[0]]||(r&&!s[2]?s[2]=r:r&&(s[2]="("+s[2]+") and ("+r+")"),e.push(s))}},e}},function(e,t){function r(e,t){for(var r=0;r<e.length;r++){var n=e[r],o=c[n.id];if(o){o.refs++;for(var i=0;i<o.parts.length;i++)o.parts[i](n.parts[i]);for(;i<n.parts.length;i++)o.parts.push(a(n.parts[i],t))}else{var s=[];for(i=0;i<n.parts.length;i++)s.push(a(n.parts[i],t));c[n.id]={id:n.id,refs:1,parts:s}}}}function n(e){for(var t=[],r={},n=0;n<e.length;n++){var o=e[n],i=o[0],s={css:o[1],media:o[2],sourceMap:o[3]};r[i]?r[i].parts.push(s):t.push(r[i]={id:i,parts:[s]})}return t}function o(e,t){var r=d(),n=h[h.length-1];if("top"===e.insertAt)n?n.nextSibling?r.insertBefore(t,n.nextSibling):r.appendChild(t):r.insertBefore(t,r.firstChild),h.push(t);else{if("bottom"!==e.insertAt)throw new Error("Invalid value for parameter 'insertAt'. Must be 'top' or 'bottom'.");r.appendChild(t)}}function i(e){e.parentNode.removeChild(e);var t=h.indexOf(e);t>=0&&h.splice(t,1)}function s(e){var t=document.createElement("style");return t.type="text/css",o(e,t),t}function a(e,t){var r,n,a;if(t.singleton){var c=u++;r=m||(m=s(t)),n=f.bind(null,r,c,!1),a=f.bind(null,r,c,!0)}else e.sourceMap&&"function"==typeof URL&&"function"==typeof URL.createObjectURL&&"function"==typeof URL.revokeObjectURL&&"function"==typeof Blob&&"function"==typeof btoa?(r=function(e){var t=document.createElement("link");return t.rel="stylesheet",o(e,t),t}(t),n=function(e,t){var r=t.css,n=t.sourceMap;n&&(r+="\n/*# sourceMappingURL=data:application/json;base64,"+btoa(unescape(encodeURIComponent(JSON.stringify(n))))+" */");var o=new Blob([r],{type:"text/css"}),i=e.href;e.href=URL.createObjectURL(o),i&&URL.revokeObjectURL(i)}.bind(null,r),a=function(){i(r),r.href&&URL.revokeObjectURL(r.href)}):(r=s(t),n=function(e,t){var r=t.css,n=t.media;if(n&&e.setAttribute("media",n),e.styleSheet)e.styleSheet.cssText=r;else{for(;e.firstChild;)e.removeChild(e.firstChild);e.appendChild(document.createTextNode(r))}}.bind(null,r),a=function(){i(r)});return n(e),function(t){if(t){if(t.css===e.css&&t.media===e.media&&t.sourceMap===e.sourceMap)return;n(e=t)}else a()}}function f(e,t,r,n){var o=r?"":n.css;if(e.styleSheet)e.styleSheet.cssText=g(t,o);else{var i=document.createTextNode(o),s=e.childNodes;s[t]&&e.removeChild(s[t]),s.length?e.insertBefore(i,s[t]):e.appendChild(i)}}var c={},l=function(e){var t;return function(){return void 0===t&&(t=e.apply(this,arguments)),t}},p=l(function(){return/msie [6-9]\b/.test(self.navigator.userAgent.toLowerCase())}),d=l(function(){return document.head||document.getElementsByTagName("head")[0]}),m=null,u=0,h=[];e.exports=function(e,t){if("undefined"!=typeof DEBUG&&DEBUG&&"object"!=typeof document)throw new Error("The style-loader cannot be used in a non-browser environment");void 0===(t=t||{}).singleton&&(t.singleton=p()),void 0===t.insertAt&&(t.insertAt="bottom");var o=n(e);return r(o,t),function(e){for(var i=[],s=0;s<o.length;s++){var a=o[s];(f=c[a.id]).refs--,i.push(f)}e&&r(n(e),t);for(s=0;s<i.length;s++){var f;if(0===(f=i[s]).refs){for(var l=0;l<f.parts.length;l++)f.parts[l]();delete c[f.id]}}}};var j,g=(j=[],function(e,t){return j[e]=t,j.filter(Boolean).join("\n")})},function(e,t,r){var n=r(1);"string"==typeof n&&(n=[[e.i,n,""]]),r(3)(n,{}),n.locals&&(e.exports=n.locals)},function(e,t,r){"use strict";function n(e){return!!e&&"object"==typeof e}function o(e){if(void 0===e)return"";if(null===e)return"Object";if("object"==typeof e&&!e.constructor)return"Object";var t=/function ([^(]*)/.exec(e.constructor.toString());return t&&t.length>1?t[1]:""}function i(e,t,r){return"null"===e||"undefined"===e?e:("string"!==e&&"stringifiable"!==e||(r='"'+r.replace('"','"')+'"'),"function"===e?t.toString().replace(/[\r\n]/g,"").replace(/\{.*\}/,"")+"{…}":r)}function s(e){return"json-formatter-"+e}t.a=n,t.b=o,t.f=i,t.d=function(e,t){var r="";return n(t)?(r=o(t),Array.isArray(t)&&(r+="["+t.length+"]")):r=i(e,t,t),r},t.c=s,t.e=function(e,t,r){var n=document.createElement(e);return t&&n.classList.add(s(t)),void 0!==r&&(r instanceof Node?n.appendChild(r):n.appendChild(document.createTextNode(String(r)))),n}},function(e,t,r){e.exports=r(0)}])},
"c81021c8fd": function _(t,e,n){var i,r=this&&this.__extends||(i=function(t,e){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(t,e)},function(t,e){function n(){this.constructor=t}i(t,e),t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)}),o=t("@bokehjs/models/widgets/markup"),a=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return r(e,t),e.prototype.render=function(){t.prototype.render.call(this),this.markup_el.innerHTML=this.model.text,window.renderMathInElement&&window.renderMathInElement(this.el,{delimiters:[{left:"$$",right:"$$",display:!0},{left:"\\[",right:"\\]",display:!0},{left:"$",right:"$",display:!1},{left:"\\(",right:"\\)",display:!1}]})},e.__name__="KaTeXView",e}(t("ec60963462").PanelMarkupView);n.KaTeXView=a;var l=function(t){function e(e){return t.call(this,e)||this}return r(e,t),e.init_KaTeX=function(){this.prototype.default_view=a},e.__name__="KaTeX",e.__module__="panel.models.katex",e}(o.Markup);n.KaTeX=l,l.init_KaTeX()},
"a93ded647d": function _(t,e,n){var i,o=this&&this.__extends||(i=function(t,e){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(t,e)},function(t,e){function n(){this.constructor=t}i(t,e),t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)}),r=t("@bokehjs/models/widgets/markup"),a=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return o(e,t),e.prototype.initialize=function(){t.prototype.initialize.call(this),this._hub=window.MathJax.Hub,this._hub.Config({tex2jax:{inlineMath:[["$","$"],["\\(","\\)"]]}})},e.prototype.render=function(){t.prototype.render.call(this),this._hub&&(this.markup_el.innerHTML=this.model.text,this._hub.Queue(["Typeset",this._hub,this.markup_el]))},e.__name__="MathJaxView",e}(t("ec60963462").PanelMarkupView);n.MathJaxView=a;var u=function(t){function e(e){return t.call(this,e)||this}return o(e,t),e.init_MathJax=function(){this.prototype.default_view=a},e.__name__="MathJax",e.__module__="panel.models.mathjax",e}(r.Markup);n.MathJax=u,u.init_MathJax()},
"98100899bc": function _(t,e,i){var n,o=this&&this.__extends||(n=function(t,e){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i])})(t,e)},function(t,e){function i(){this.constructor=t}n(t,e),t.prototype=null===e?Object.create(e):(i.prototype=e.prototype,new i)}),r=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var i in t)Object.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e.default=t,e})(t("@bokehjs/core/properties")),s=t("@bokehjs/core/dom"),a=t("@bokehjs/models/widgets/widget"),l=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return o(e,t),e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this),this.connect(this.model.change,function(){return e.render()}),this.connect(this.model.properties.value.change,function(){return e.render()}),this.connect(this.model.properties.loop_policy.change,function(){return e.set_loop_state(e.model.loop_policy)})},e.prototype.get_height=function(){return 250},e.prototype.render=function(){var e=this;if(null!=this.sliderEl)return this.sliderEl.style.width="{this.model.width}px",this.sliderEl.min=String(this.model.start),this.sliderEl.max=String(this.model.end),void(this.sliderEl.value=String(this.model.value));t.prototype.render.call(this),this.sliderEl=document.createElement("input"),this.sliderEl.setAttribute("type","range"),this.sliderEl.style.width=this.model.width+"px",this.sliderEl.value=String(this.model.value),this.sliderEl.min=String(this.model.start),this.sliderEl.max=String(this.model.end),this.sliderEl.onchange=function(t){return e.set_frame(parseInt(t.target.value))};var i=s.div();i.style.cssText="margin: 0 auto; display: table; padding: 5px";var n="text-align: center; min-width: 40px; margin: 2px",o=document.createElement("button");o.style.cssText="text-align: center; min-width: 20px",o.appendChild(document.createTextNode("–")),o.onclick=function(){return e.slower()},i.appendChild(o);var r=document.createElement("button");r.style.cssText=n,r.appendChild(document.createTextNode("❚◀◀")),r.onclick=function(){return e.first_frame()},i.appendChild(r);var a=document.createElement("button");a.style.cssText=n,a.appendChild(document.createTextNode("❚◀")),a.onclick=function(){return e.previous_frame()},i.appendChild(a);var l=document.createElement("button");l.style.cssText=n,l.appendChild(document.createTextNode("◀")),l.onclick=function(){return e.reverse_animation()},i.appendChild(l);var d=document.createElement("button");d.style.cssText=n,d.appendChild(document.createTextNode("❚❚")),d.onclick=function(){return e.pause_animation()},i.appendChild(d);var p=document.createElement("button");p.style.cssText=n,p.appendChild(document.createTextNode("▶")),p.onclick=function(){return e.play_animation()},i.appendChild(p);var c=document.createElement("button");c.style.cssText=n,c.appendChild(document.createTextNode("▶❚")),c.onclick=function(){return e.next_frame()},i.appendChild(c);var h=document.createElement("button");h.style.cssText=n,h.appendChild(document.createTextNode("▶▶❚")),h.onclick=function(){return e.last_frame()},i.appendChild(h);var u=document.createElement("button");u.style.cssText="text-align: center; min-width: 20px",u.appendChild(document.createTextNode("+")),u.onclick=function(){return e.faster()},i.appendChild(u),this.loop_state=document.createElement("form"),this.loop_state.style.cssText="margin: 0 auto; display: table";var m=document.createElement("input");m.type="radio",m.value="once",m.name="state";var _=document.createElement("label");_.innerHTML="Once",_.style.cssText="padding: 0 10px 0 5px; user-select:none;";var f=document.createElement("input");f.setAttribute("type","radio"),f.setAttribute("value","loop"),f.setAttribute("name","state");var v=document.createElement("label");v.innerHTML="Loop",v.style.cssText="padding: 0 10px 0 5px; user-select:none;";var y=document.createElement("input");y.setAttribute("type","radio"),y.setAttribute("value","reflect"),y.setAttribute("name","state");var x=document.createElement("label");x.innerHTML="Reflect",x.style.cssText="padding: 0 10px 0 5px; user-select:none;","once"==this.model.loop_policy?m.checked=!0:"loop"==this.model.loop_policy?f.checked=!0:y.checked=!0,this.loop_state.appendChild(m),this.loop_state.appendChild(_),this.loop_state.appendChild(f),this.loop_state.appendChild(v),this.loop_state.appendChild(y),this.loop_state.appendChild(x),this.el.appendChild(this.sliderEl),this.el.appendChild(i),this.el.appendChild(this.loop_state)},e.prototype.set_frame=function(t){this.model.value!=t&&(this.model.value=t),this.sliderEl.value!=String(t)&&(this.sliderEl.value=String(t))},e.prototype.get_loop_state=function(){for(var t=this.loop_state.state,e=0;e<t.length;e++){var i=t[e];if(i.checked)return i.value}return"once"},e.prototype.set_loop_state=function(t){for(var e=this.loop_state.state,i=0;i<e.length;i++){var n=e[i];n.value==t&&(n.checked=!0)}},e.prototype.next_frame=function(){this.set_frame(Math.min(this.model.end,this.model.value+this.model.step))},e.prototype.previous_frame=function(){this.set_frame(Math.max(this.model.start,this.model.value-this.model.step))},e.prototype.first_frame=function(){this.set_frame(this.model.start)},e.prototype.last_frame=function(){this.set_frame(this.model.end)},e.prototype.slower=function(){this.model.interval=Math.round(this.model.interval/.7),this.model.direction>0?this.play_animation():this.model.direction<0&&this.reverse_animation()},e.prototype.faster=function(){this.model.interval=Math.round(.7*this.model.interval),this.model.direction>0?this.play_animation():this.model.direction<0&&this.reverse_animation()},e.prototype.anim_step_forward=function(){if(this.model.value<this.model.end)this.next_frame();else{var t=this.get_loop_state();"loop"==t?this.first_frame():"reflect"==t?(this.last_frame(),this.reverse_animation()):(this.pause_animation(),this.last_frame())}},e.prototype.anim_step_reverse=function(){if(this.model.value>this.model.start)this.previous_frame();else{var t=this.get_loop_state();"loop"==t?this.last_frame():"reflect"==t?(this.first_frame(),this.play_animation()):(this.pause_animation(),this.first_frame())}},e.prototype.pause_animation=function(){this.model.direction=0,this.timer&&(clearInterval(this.timer),this.timer=null)},e.prototype.play_animation=function(){var t=this;this.pause_animation(),this.model.direction=1,this.timer||(this.timer=setInterval(function(){return t.anim_step_forward()},this.model.interval))},e.prototype.reverse_animation=function(){var t=this;this.pause_animation(),this.model.direction=-1,this.timer||(this.timer=setInterval(function(){return t.anim_step_reverse()},this.model.interval))},e.__name__="PlayerView",e}(a.WidgetView);i.PlayerView=l;var d=function(t){function e(e){return t.call(this,e)||this}return o(e,t),e.init_Player=function(){this.prototype.default_view=l,this.define({direction:[r.Number,0],interval:[r.Number,500],start:[r.Number],end:[r.Number],step:[r.Number,1],loop_policy:[r.Any,"once"],value:[r.Any,0]}),this.override({width:400})},e.__name__="Player",e.__module__="panel.models.widgets",e}(a.Widget);i.Player=d,d.init_Player()},
"7d6e800353": function _(t,e,o){var r,n=this&&this.__extends||(r=function(t,e){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)},function(t,e){function o(){this.constructor=t}r(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}),i=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var o in t)Object.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e.default=t,e})(t("@bokehjs/core/properties")),l=t("@bokehjs/core/util/object"),a=t("@bokehjs/core/util/eq"),p=t("@bokehjs/models/layouts/html_box"),s=t("99a25e6992"),u=t("62ba79515f"),c=t("ec60963462"),_=window.Plotly,d=function(t,e,o){var r=Array.isArray(e)?[]:{};if("click"===o||"hover"===o||"selected"===o){var n=[];if(null==e)return null;for(var i=t.data,l=0;l<e.points.length;l++){var a=e.points[l],p={};for(var s in a){var c=a[s];!a.hasOwnProperty(s)||Array.isArray(c)||u.isPlainObject(c)||(p[s]=c)}null!=a&&(a.hasOwnProperty("curveNumber")&&a.hasOwnProperty("pointNumber")&&i[a.curveNumber].hasOwnProperty("customdata")&&(p.customdata=i[a.curveNumber].customdata[a.pointNumber]),a.hasOwnProperty("pointNumbers")&&(p.pointNumbers=a.pointNumbers)),n[l]=p}r.points=n}else if("relayout"===o||"restyle"===o)for(var s in e)e.hasOwnProperty(s)&&(r[s]=e[s]);return e.hasOwnProperty("range")&&(r.range=e.range),e.hasOwnProperty("lassoPoints")&&(r.lassoPoints=e.lassoPoints),r},y=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e._settingViewport=!1,e._plotInitialized=!1,e._reacting=!1,e._relayouting=!1,e._end_relayouting=s.debounce(function(){e._relayouting=!1},2e3,!1),e}return n(e,t),e.prototype.connect_signals=function(){t.prototype.connect_signals.call(this),this.connect(this.model.properties.viewport_update_policy.change,this._updateSetViewportFunction),this.connect(this.model.properties.viewport_update_throttle.change,this._updateSetViewportFunction),this.connect(this.model.properties._render_count.change,this.render),this.connect(this.model.properties.viewport.change,this._updateViewportFromProperty)},e.prototype.render=function(){var e=this;if(t.prototype.render.call(this),window.Plotly){for(var o=[],r=0;r<this.model.data.length;r++)o.push(this._get_trace(r,!1));var n=u.deepCopy(this.model.layout);if(this._relayouting){var i=this.el.layout;Object.keys(i).reduce(function(t,e){"axis"===e.slice(1,5)&&"range"in t&&(n[e].range=t.range)},{})}this._reacting=!0,_.react(this.el,o,n,this.model.config).then(function(){e._updateSetViewportFunction(),e._updateViewportProperty(),e._plotInitialized||(e.el.on("plotly_relayout",function(t){!0!==t._update_from_property&&(e.model.relayout_data=d(e.el,t,"relayout"),e._updateViewportProperty(),e._end_relayouting())}),e.el.on("plotly_relayouting",function(){"mouseup"!==e.model.viewport_update_policy&&(e._relayouting=!0,e._updateViewportProperty())}),e.el.on("plotly_restyle",function(t){e.model.restyle_data=d(e.el,t,"restyle"),e._updateViewportProperty()}),e.el.on("plotly_click",function(t){e.model.click_data=d(e.el,t,"click")}),e.el.on("plotly_hover",function(t){e.model.hover_data=d(e.el,t,"hover")}),e.el.on("plotly_selected",function(t){e.model.selected_data=d(e.el,t,"selected")}),e.el.on("plotly_clickannotation",function(t){delete t.event,delete t.fullAnnotation,e.model.clickannotation_data=t}),e.el.on("plotly_deselect",function(){e.model.selected_data=null}),e.el.on("plotly_unhover",function(){e.model.hover_data=null})),e._plotInitialized=!0,e._reacting=!1})}},e.prototype._get_trace=function(t,e){for(var o=l.clone(this.model.data[t]),r=this.model.data_sources[t],n=0,i=r.columns();n<i.length;n++){var a=i[n],p=r._shapes[a][0],s=r.get_array(a)[0];if(p.length>1){for(var u=[],c=0;c<p[0];c++)u.push(s.slice(c*p[1],(c+1)*p[1]));s=u}for(var _=a.split("."),d=_[_.length-1],y=o,h=0,f=_.slice(0,-1);h<f.length;h++){y=y[f[h]]}e&&1==_.length?y[d]=[s]:y[d]=s}return o},e.prototype._updateViewportFromProperty=function(){var t=this;if(_&&!this._settingViewport&&!this._reacting&&this.model.viewport){var e=this.el._fullLayout;Object.keys(this.model.viewport).reduce(function(o,r){if(a.isEqual(u.get(e,r),o))return!0;var n=u.deepCopy(t.model.viewport);return n._update_from_property=!0,_.relayout(t.el,n),!1},{})}},e.prototype._updateViewportProperty=function(){var t=this.el._fullLayout,e={};for(var o in t)if(t.hasOwnProperty(o)){var r=o.slice(0,5);"xaxis"!==r&&"yaxis"!==r||(e[o+".range"]=u.deepCopy(t[o].range))}a.isEqual(e,this.model.viewport)||this._setViewport(e)},e.prototype._updateSetViewportFunction=function(){var t=this;"continuous"===this.model.viewport_update_policy||"mouseup"===this.model.viewport_update_policy?this._setViewport=function(e){t._settingViewport||(t._settingViewport=!0,t.model.viewport=e,t._settingViewport=!1)}:this._setViewport=u.throttle(function(e){t._settingViewport||(t._settingViewport=!0,t.model.viewport=e,t._settingViewport=!1)},this.model.viewport_update_throttle)},e.__name__="PlotlyPlotView",e}(c.PanelHTMLBoxView);o.PlotlyPlotView=y;var h=function(t){function e(e){return t.call(this,e)||this}return n(e,t),e.init_PlotlyPlot=function(){this.prototype.default_view=y,this.define({data:[i.Array,[]],layout:[i.Any,{}],config:[i.Any,{}],data_sources:[i.Array,[]],relayout_data:[i.Any,{}],restyle_data:[i.Array,[]],click_data:[i.Any,{}],hover_data:[i.Any,{}],clickannotation_data:[i.Any,{}],selected_data:[i.Any,{}],viewport:[i.Any,{}],viewport_update_policy:[i.String,"mouseup"],viewport_update_throttle:[i.Number,200],_render_count:[i.Number,0]})},e.__name__="PlotlyPlot",e.__module__="panel.models.plotly",e}(p.HTMLBox);o.PlotlyPlot=h,h.init_PlotlyPlot()},
"99a25e6992": function _(n,l,u){function t(n,l,u){var t,e,o,a,r;function i(){var c=Date.now()-a;c<l&&c>=0?t=setTimeout(i,l-c):(t=null,u||(r=n.apply(o,e),o=e=null))}null==l&&(l=100);var c=function(){o=this,e=arguments,a=Date.now();var c=u&&!t;return t||(t=setTimeout(i,l)),c&&(r=n.apply(o,e),o=e=null),r};return c.clear=function(){t&&(clearTimeout(t),t=null)},c.flush=function(){t&&(r=n.apply(o,e),o=e=null,clearTimeout(t),t=null)},c}t.debounce=t,l.exports=t},
"62ba79515f": function _(t,r,n){n.get=function(t,r,n){void 0===n&&(n=void 0);var e=function(n){return String.prototype.split.call(r,n).filter(Boolean).reduce(function(t,r){return null!=t?t[r]:t},t)},o=e(/[,[\]]+?/)||e(/[,[\].]+?/);return void 0===o||o===t?n:o},n.throttle=function(t,r){var n=0;return function(){var e=Number(new Date);e-n>=r&&(t(),n=e)}},n.deepCopy=function t(r){var n;if(null==r||"object"!=typeof r)return r;if(r instanceof Array){n=[];for(var e=0,o=r.length;e<o;e++)n[e]=t(r[e]);return n}if(r instanceof Object){var i={};for(var u in r){var c=u;r.hasOwnProperty(c)&&(i[c]=t(r[c]))}return i}throw new Error("Unable to copy obj! Its type isn't supported.")},n.isPlainObject=function(t){return"[object Object]"===Object.prototype.toString.call(t)}},
"d9b3a262de": function _(t,e,o){var s,i=this&&this.__extends||(s=function(t,e){return(s=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)},function(t,e){function o(){this.constructor=t}s(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}),n=this&&this.__assign||function(){return(n=Object.assign||function(t){for(var e,o=1,s=arguments.length;o<s;o++)for(var i in e=arguments[o])Object.prototype.hasOwnProperty.call(e,i)&&(t[i]=e[i]);return t}).apply(this,arguments)},r=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var o in t)Object.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e.default=t,e})(t("@bokehjs/core/properties")),c=t("@bokehjs/models/layouts/html_box"),l=t("ec60963462"),h=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return i(e,t),e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this);var o=function(){e.render(),e.root.compute_layout()};this.connect(this.model.properties.height.change,o),this.connect(this.model.properties.width.change,o),this.connect(this.model.properties.height_policy.change,o),this.connect(this.model.properties.width_policy.change,o),this.connect(this.model.properties.sizing_mode.change,o),this.connect(this.model.properties.active.change,function(){return e.setCSS()}),this.connect(this.model.properties.bar_color.change,function(){return e.setCSS()}),this.connect(this.model.properties.css_classes.change,function(){return e.setCSS()}),this.connect(this.model.properties.value.change,function(){return e.setValue()}),this.connect(this.model.properties.max.change,function(){return e.setMax()})},e.prototype.render=function(){t.prototype.render.call(this);var e=n(n({},this.model.style),{display:"inline-block"});for(var o in this.progressEl=document.createElement("progress"),this.setValue(),this.setMax(),l.set_size(this.progressEl,this.model),this.setCSS(),e)this.progressEl.style.setProperty(o,e[o]);this.el.appendChild(this.progressEl)},e.prototype.setCSS=function(){var t=this.model.css_classes.join(" ")+" "+this.model.bar_color;this.model.active&&(t+=" active"),this.progressEl.className=t},e.prototype.setValue=function(){null!=this.model.value&&(this.progressEl.value=this.model.value)},e.prototype.setMax=function(){null!=this.model.max&&(this.progressEl.max=this.model.max)},e.prototype._update_layout=function(){var t=void 0!==this._prev_sizing_mode&&this._prev_sizing_mode!==this.model.sizing_mode;this._prev_sizing_mode=this.model.sizing_mode,this.layout=new l.CachedVariadicBox(this.el,this.model.sizing_mode,t),this.layout.set_sizing(this.box_sizing())},e.__name__="ProgressView",e}(c.HTMLBoxView);o.ProgressView=h;var a=function(t){function e(e){return t.call(this,e)||this}return i(e,t),e.init_Progress=function(){this.prototype.default_view=h,this.define({active:[r.Boolean,!0],bar_color:[r.String,"primary"],style:[r.Any,{}],max:[r.Number,100],value:[r.Number,null]})},e.__name__="Progress",e.__module__="panel.models.widgets",e}(c.HTMLBox);o.Progress=a,a.init_Progress()},
"4b4afba86a": function _(t,e,n){var o,i=this&&this.__extends||(o=function(t,e){return(o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(t,e)},function(t,e){function n(){this.constructor=t}o(t,e),t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)}),r=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var n in t)Object.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e.default=t,e})(t("@bokehjs/core/properties")),s=t("@bokehjs/core/view"),a=t("@bokehjs/core/util/array"),c=t("@bokehjs/model"),_=t("@bokehjs/protocol/receiver");var h=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return i(e,t),e.prototype.renderTo=function(){},e.__name__="StateView",e}(s.View);n.StateView=h;var p=function(t){function e(e){var n=t.call(this,e)||this;return n._receiver=new _.Receiver,n._cache={},n}return i(e,t),e.prototype.apply_state=function(t){this._receiver.consume(t.header),this._receiver.consume(t.metadata),this._receiver.consume(t.content),this._receiver.message&&this.document&&this.document.apply_json_patch(this._receiver.message.content)},e.prototype._receive_json=function(t,e){var n=JSON.parse(t);this._cache[e]=n;for(var o=this.state,i=0,r=this.values;i<r.length;i++){o=o[r[i]]}o===e?this.apply_state(n):this._cache[o]&&this.apply_state(this._cache[o])},e.prototype.set_state=function(t,e){var n=this,o=a.copy(this.values);o[this.widgets[t.id]]=e;for(var i,r,s,c=this.state,_=0,h=o;_<h.length;_++){var p=h[_];c=c[p]}this.values=o,this.json?this._cache[c]?this.apply_state(this._cache[c]):(i=c,r=function(t){return n._receive_json(t,c)},(s=new XMLHttpRequest).overrideMimeType("application/json"),s.open("GET",i,!0),s.onreadystatechange=function(){4==s.readyState&&200==s.status&&r(s.responseText)},s.send(null)):this.apply_state(c)},e.init_State=function(){this.prototype.default_view=h,this.define({json:[r.Boolean,!1],state:[r.Any,{}],widgets:[r.Any,{}],values:[r.Any,[]]})},e.__name__="State",e.__module__="panel.models.state",e}(c.Model);n.State=p,p.init_State()},
"14b669e6fc": function _(t,e,o){var n,a=this&&this.__extends||(n=function(t,e){return(n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)},function(t,e){function o(){this.constructor=t}n(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}),s=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var o in t)Object.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e.default=t,e})(t("@bokehjs/core/properties")),i=t("@bokehjs/models/layouts/html_box"),r=function(t){function e(){return null!==t&&t.apply(this,arguments)||this}return a(e,t),e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this),this.connect(this.model.properties.data.change,this._plot),this.connect(this.model.properties.data_sources.change,function(){return e._connect_sources()}),this._connected=[],this._connect_sources()},e.prototype._connect_sources=function(){for(var t in this.model.data_sources){var e=this.model.data_sources[t];this._connected.indexOf(t)<0&&(this.connect(e.properties.data.change,this._plot),this._connected.push(t))}},e.prototype._fetch_datasets=function(){var t={};for(var e in this.model.data_sources){for(var o=this.model.data_sources[e],n=[],a=o.columns(),s=0;s<o.data[a[0]].length;s++){for(var i={},r=0,c=a;r<c.length;r++){var d=c[r];i[d]=o.data[d][s]}n.push(i)}t[e]=n}return t},e.prototype.render=function(){t.prototype.render.call(this),this._plot()},e.prototype._plot=function(){if(this.model.data&&window.vegaEmbed){if(this.model.data_sources&&Object.keys(this.model.data_sources).length>0){var t=this._fetch_datasets();if("data"in t&&(this.model.data.data.values=t.data,delete t.data),void 0!==this.model.data.data)for(var e=0,o=this.model.data.data;e<o.length;e++){var n=o[e];n.name in t&&(n.values=t[n.name],delete t[n.name])}this.model.data.datasets=t}window.vegaEmbed(this.el,this.model.data,{actions:!1})}},e.__name__="VegaPlotView",e}(i.HTMLBoxView);o.VegaPlotView=r;var c=function(t){function e(e){return t.call(this,e)||this}return a(e,t),e.init_VegaPlot=function(){this.prototype.default_view=r,this.define({data:[s.Any],data_sources:[s.Any]})},e.__name__="VegaPlot",e.__module__="panel.models.vega",e}(i.HTMLBox);o.VegaPlot=c,c.init_VegaPlot()},
"71a2bbec38": function _(e,t,o){var i,n=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var o in t)t.hasOwnProperty(o)&&(e[o]=t[o])})(e,t)},function(e,t){function o(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(o.prototype=t.prototype,new o)}),l=(this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var o in e)Object.hasOwnProperty.call(e,o)&&(t[o]=e[o]);return t.default=e,t})(e("@bokehjs/core/properties")),s=e("@bokehjs/models/layouts/html_box"),d=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return n(t,e),t.prototype.initialize=function(){e.prototype.initialize.call(this),this._blocked=!1,this._setting=!1,this._time=Date.now()},t.prototype.connect_signals=function(){var t=this;e.prototype.connect_signals.call(this),this.connect(this.model.properties.loop.change,function(){return t.set_loop()}),this.connect(this.model.properties.paused.change,function(){return t.set_paused()}),this.connect(this.model.properties.time.change,function(){return t.set_time()}),this.connect(this.model.properties.value.change,function(){return t.set_value()}),this.connect(this.model.properties.volume.change,function(){return t.set_volume()})},t.prototype.render=function(){var t=this;e.prototype.render.call(this),this.videoEl=document.createElement("video"),this.model.sizing_mode&&"fixed"!==this.model.sizing_mode||(this.model.height&&(this.videoEl.height=this.model.height),this.model.width&&(this.videoEl.width=this.model.width)),this.videoEl.style.objectFit="fill",this.videoEl.style.minWidth="100%",this.videoEl.style.minHeight="100%",this.videoEl.controls=!0,this.videoEl.src=this.model.value,this.videoEl.currentTime=this.model.time,this.videoEl.loop=this.model.loop,null!=this.model.volume?this.videoEl.volume=this.model.volume/100:this.model.volume=100*this.videoEl.volume,this.videoEl.onpause=function(){return t.model.paused=!0},this.videoEl.onplay=function(){return t.model.paused=!1},this.videoEl.ontimeupdate=function(){return t.update_time(t)},this.videoEl.onvolumechange=function(){return t.update_volume(t)},this.el.appendChild(this.videoEl),this.model.paused||this.videoEl.play()},t.prototype.update_time=function(e){e._setting?e._setting=!1:Date.now()-e._time<e.model.throttle||(e._blocked=!0,e.model.time=e.videoEl.currentTime,e._time=Date.now())},t.prototype.update_volume=function(e){e._setting?e._setting=!1:(e._blocked=!0,e.model.volume=100*e.videoEl.volume)},t.prototype.set_loop=function(){this.videoEl.loop=this.model.loop},t.prototype.set_paused=function(){!this.videoEl.paused&&this.model.paused&&this.videoEl.pause(),this.videoEl.paused&&!this.model.paused&&this.videoEl.play()},t.prototype.set_volume=function(){this._blocked?this._blocked=!1:(this._setting=!0,null!=this.model.volume&&(this.videoEl.volume=this.model.volume/100))},t.prototype.set_time=function(){this._blocked?this._blocked=!1:(this._setting=!0,this.videoEl.currentTime=this.model.time)},t.prototype.set_value=function(){this.videoEl.src=this.model.value},t.__name__="VideoView",t}(e("ec60963462").PanelHTMLBoxView);o.VideoView=d;var h=function(e){function t(t){return e.call(this,t)||this}return n(t,e),t.init_Video=function(){this.prototype.default_view=d,this.define({loop:[l.Boolean,!1],paused:[l.Boolean,!0],time:[l.Number,0],throttle:[l.Number,250],value:[l.Any,""],volume:[l.Number,null]})},t.__name__="Video",t.__module__="panel.models.widgets",t}(s.HTMLBox);o.Video=h,h.init_Video()},
"76bc93d621": function _(t,e,i){var o,n=this&&this.__extends||(o=function(t,e){return(o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i])})(t,e)},function(t,e){function i(){this.constructor=t}o(t,e),t.prototype=null===e?Object.create(e):(i.prototype=e.prototype,new i)}),s=(this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var i in t)Object.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e.default=t,e})(t("@bokehjs/core/properties")),r=t("@bokehjs/models/layouts/html_box"),h=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e.constraints={audio:!1,video:!0},e}return n(e,t),e.prototype.initialize=function(){t.prototype.initialize.call(this),null!==this.model.timeout&&this.set_timeout()},e.prototype.connect_signals=function(){var e=this;t.prototype.connect_signals.call(this),this.connect(this.model.properties.timeout.change,function(){return e.set_timeout()}),this.connect(this.model.properties.snapshot.change,function(){return e.snapshot()}),this.connect(this.model.properties.paused.change,function(){return e.pause()})},e.prototype.pause=function(){this.model.paused&&(null!=this.timer&&(clearInterval(this.timer),this.timer=null),this.videoEl.pause()),this.set_timeout()},e.prototype.set_timeout=function(){var t=this;this.timer&&(clearInterval(this.timer),this.timer=null),this.model.timeout>0&&(this.timer=setInterval(function(){return t.snapshot()},this.model.timeout))},e.prototype.snapshot=function(){this.canvasEl.width=this.videoEl.videoWidth,this.canvasEl.height=this.videoEl.videoHeight;var t=this.canvasEl.getContext("2d");t&&t.drawImage(this.videoEl,0,0,this.canvasEl.width,this.canvasEl.height),this.model.value=this.canvasEl.toDataURL("image/"+this.model.format,.95)},e.prototype.remove=function(){t.prototype.remove.call(this),this.timer&&(clearInterval(this.timer),this.timer=null)},e.prototype.render=function(){var e=this;t.prototype.render.call(this),this.videoEl||(this.videoEl=document.createElement("video"),this.model.sizing_mode&&"fixed"!==this.model.sizing_mode||(this.model.height&&(this.videoEl.height=this.model.height),this.model.width&&(this.videoEl.width=this.model.width)),this.videoEl.style.objectFit="fill",this.videoEl.style.minWidth="100%",this.videoEl.style.minHeight="100%",this.canvasEl=document.createElement("canvas"),this.el.appendChild(this.videoEl),navigator.mediaDevices.getUserMedia&&navigator.mediaDevices.getUserMedia(this.constraints).then(function(t){e.videoEl.srcObject=t,e.model.paused||e.videoEl.play()}).catch(console.error))},e.__name__="VideoStreamView",e}(t("ec60963462").PanelHTMLBoxView);i.VideoStreamView=h;var a=function(t){function e(e){return t.call(this,e)||this}return n(e,t),e.init_VideoStream=function(){this.prototype.default_view=h,this.define({format:[s.String,"png"],paused:[s.Boolean,!1],snapshot:[s.Boolean,!1],timeout:[s.Number,0],value:[s.Any]}),this.override({height:240,width:320})},e.__name__="VideoStream",e.__module__="panel.models.widgets",e}(r.HTMLBox);i.VideoStream=a,a.init_VideoStream()},
"63070bc9ce": function _(V,e,o){var l=V("e04073341c");o.VTKPlot=l.VTKPlot;var K=V("51dfc8cb0e");o.VTKVolumePlot=K.VTKVolumePlot;var T=V("5bc27423fe");o.VTKAxes=T.VTKAxes},
"e04073341c": function _(e,t,n){var i,r=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},function(e,t){function n(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}),o=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var n in e)Object.hasOwnProperty.call(e,n)&&(t[n]=e[n]);return t.default=e,t},a=e("@bokehjs/core/dom"),s=o(e("@bokehjs/core/properties")),d=e("@bokehjs/core/util/object"),_=e("@bokehjs/models/layouts/html_box"),c=e("3755bf9cce"),l=e("f35231aba1"),h=function(e){function t(){var t=null!==e&&e.apply(this,arguments)||this;return t._setting=!1,t._axes_initialized=!1,t}return r(t,e),t.prototype.connect_signals=function(){var t=this;e.prototype.connect_signals.call(this),this.connect(this.model.properties.data.change,function(){t.invalidate_render()}),this.connect(this.model.properties.camera.change,function(){return t._set_camera_state()}),this.connect(this.model.properties.orientation_widget.change,function(){t._orientation_widget_visbility(t.model.orientation_widget)}),this.connect(this.model.properties.axes.change,function(){t._delete_axes(),t.model.axes&&t._set_axes(),t._vtk_renwin.getRenderWindow().render()}),this.el.addEventListener("mouseenter",function(){var e=t._vtk_renwin.getInteractor();t.model.enable_keybindings&&(document.querySelector("body").addEventListener("keypress",e.handleKeyPress),document.querySelector("body").addEventListener("keydown",e.handleKeyDown),document.querySelector("body").addEventListener("keyup",e.handleKeyUp))}),this.el.addEventListener("mouseleave",function(){var e=t._vtk_renwin.getInteractor();document.querySelector("body").removeEventListener("keypress",e.handleKeyPress),document.querySelector("body").removeEventListener("keydown",e.handleKeyDown),document.querySelector("body").removeEventListener("keyup",e.handleKeyUp)})},t.prototype.render=function(){var t=this;e.prototype.render.call(this),this.model.renderer_el=this._vtk_renwin,this._orientationWidget=null,this._axes=null,this._axes_initialized=!1,this._plot(),this._vtk_renwin.getRenderer().getActiveCamera().onModified(function(){return t._get_camera_state()})},t.prototype.after_layout=function(){this._axes_initialized||(this._render_axes_canvas(),this._axes_initialized=!0)},t.prototype._create_orientation_widget=function(){var e=this,t=l.vtkns.AxesActor.newInstance(),n=l.vtkns.OrientationMarkerWidget.newInstance({actor:t,interactor:this._vtk_renwin.getInteractor()});n.setEnabled(!0),n.setViewportCorner(l.vtkns.OrientationMarkerWidget.Corners.BOTTOM_RIGHT),n.setViewportSize(.15),n.setMinPixelSize(100),n.setMaxPixelSize(300),this._orientationWidget=n;var i=l.vtkns.WidgetManager.newInstance();i.setRenderer(n.getRenderer());var r=l.vtkns.InteractiveOrientationWidget.newInstance();r.placeWidget(t.getBounds()),r.setBounds(t.getBounds()),r.setPlaceFactor(1);var o=i.addWidget(r);this._widgetManager=i,o.onOrientationChange(function(t){var n=t.direction,i=e._vtk_renwin.getRenderer().getActiveCamera(),r=i.getFocalPoint(),o=i.getPosition(),a=i.getViewUp(),s=Math.sqrt(Math.pow(o[0]-r[0],2)+Math.pow(o[1]-r[1],2)+Math.pow(o[2]-r[2],2));i.setPosition(r[0]+n[0]*s,r[1]+n[1]*s,r[2]+n[2]*s),n[0]&&i.setViewUp(l.majorAxis(a,1,2)),n[1]&&i.setViewUp(l.majorAxis(a,0,2)),n[2]&&i.setViewUp(l.majorAxis(a,0,1)),e._orientationWidget.updateMarkerOrientation(),e._vtk_renwin.getRenderer().resetCameraClippingRange(),e._vtk_renwin.getRenderWindow().render()}),this._orientation_widget_visbility(this.model.orientation_widget)},t.prototype._render_axes_canvas=function(){var e=this,t=this._vtk_container.getElementsByTagName("canvas");if(1!=t.length)throw Error("Error at initialization of the 3D scene, container should have one and only one canvas");t[0].classList.add("scene3d-canvas");var n=a.canvas({style:{position:"absolute",top:"0",left:"0",width:"100%",height:"100%"}});n.classList.add("axes-canvas"),this._vtk_container.appendChild(n),this._vtk_renwin.setResizeCallback(function(){var t=e._vtk_container.getBoundingClientRect(),i=Math.floor(t.width*window.devicePixelRatio),r=Math.floor(t.height*window.devicePixelRatio);n.setAttribute("width",i.toFixed()),n.setAttribute("height",r.toFixed())})},t.prototype._orientation_widget_visbility=function(e){this._orientationWidget.setEnabled(e),e?this._widgetManager.enablePicking():this._widgetManager.disablePicking(),this._orientationWidget.updateMarkerOrientation(),this._vtk_renwin.getRenderWindow().render()},t.prototype._get_camera_state=function(){if(!this._setting){this._setting=!0;var e=d.clone(this._vtk_renwin.getRenderer().getActiveCamera().get());delete e.classHierarchy,delete e.vtkObject,delete e.vtkCamera,delete e.viewPlaneNormal,this.model.camera=e,this._setting=!1}},t.prototype._set_camera_state=function(){if(!this._setting){this._setting=!0;try{this._vtk_renwin.getRenderer().getActiveCamera().set(this.model.camera)}finally{this._setting=!1}null!=this._orientationWidget&&this._orientationWidget.updateMarkerOrientation(),this._vtk_renwin.getRenderer().resetCameraClippingRange(),this._vtk_renwin.getRenderWindow().render()}},t.prototype._delete_axes=function(){var e=this;if(null!=this._axes){Object.keys(this._axes).forEach(function(t){return e._vtk_renwin.getRenderer().removeActor(e._axes[t])});var t=this._vtk_renwin.getContainer().getElementsByClassName("axes-canvas")[0],n=t.getContext("2d");n&&n.clearRect(0,0,t.clientWidth*window.devicePixelRatio,t.clientHeight*window.devicePixelRatio),this._axes=null}},t.prototype._set_axes=function(){if(this.model.axes){var e=this._vtk_renwin.getContainer().getElementsByClassName("axes-canvas")[0],t=this.model.axes.create_axes(e),n=t.psActor,i=t.axesActor,r=t.gridActor;this._axes={psActor:n,axesActor:i,gridActor:r},this._vtk_renwin.getRenderer().addActor(n),this._vtk_renwin.getRenderer().addActor(i),this._vtk_renwin.getRenderer().addActor(r)}},t.prototype._plot=function(){var e=this;if(this.model.data)var t=l.vtkns.DataAccessHelper.get("zip",{zipContent:atob(this.model.data),callback:function(n){var i=l.vtkns.HttpSceneLoader.newInstance({renderer:e._vtk_renwin.getRenderer(),dataAccessHelper:t}),r=l.vtk.macro.debounce(function(){null==e._orientationWidget&&e._create_orientation_widget(),null==e._axes&&e.model.axes&&e._set_axes(),e._set_camera_state()},100);i.setUrl("index.json"),i.onReady(r)}});else this._vtk_renwin.getRenderWindow().render()},t.__name__="VTKPlotView",t}(c.VTKHTMLBoxView);n.VTKPlotView=h;var g=function(e){function t(t){var n=e.call(this,t)||this;n.renderer_el=null,n.outline=l.vtkns.OutlineFilter.newInstance();var i=l.vtkns.Mapper.newInstance();return i.setInputConnection(n.outline.getOutputPort()),n.outline_actor=l.vtkns.Actor.newInstance(),n.outline_actor.setMapper(i),n}return r(t,e),t.prototype.getActors=function(){return this.renderer_el.getRenderer().getActors()},t.init_VTKPlot=function(){this.prototype.default_view=h,this.define({axes:[s.Instance],camera:[s.Any],data:[s.String],enable_keybindings:[s.Boolean,!1],orientation_widget:[s.Boolean,!1]}),this.override({height:300,width:300})},t.__name__="VTKPlot",t.__module__="panel.models.vtk",t}(_.HTMLBox);n.VTKPlot=g,g.init_VTKPlot()},
"3755bf9cce": function _(e,t,n){var o,r=this&&this.__extends||(o=function(e,t){return(o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},function(e,t){function n(){this.constructor=e}o(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}),i=e("ec60963462"),_=e("@bokehjs/core/dom"),s=e("f35231aba1"),c=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),t.prototype.render=function(){e.prototype.render.call(this),this._vtk_container=_.div(),i.set_size(this._vtk_container,this.model),this.el.appendChild(this._vtk_container),this._vtk_renwin=s.vtkns.FullScreenRenderWindow.newInstance({rootContainer:this.el,container:this._vtk_container}),this._remove_default_key_binding()},t.prototype.after_layout=function(){e.prototype.after_layout.call(this),this._vtk_renwin.resize()},t.prototype._remove_default_key_binding=function(){var e=this._vtk_renwin.getInteractor();document.querySelector("body").removeEventListener("keypress",e.handleKeyPress),document.querySelector("body").removeEventListener("keydown",e.handleKeyDown),document.querySelector("body").removeEventListener("keyup",e.handleKeyUp)},t.__name__="VTKHTMLBoxView",t}(i.PanelHTMLBoxView);n.VTKHTMLBoxView=c},
"f35231aba1": function _(e,t,n){var r=e("@bokehjs/core/util/serialization");function a(e){for(var t=new ArrayBuffer(e.length),n=new Uint8Array(t),r=0,a=e.length;r<a;r++)n[r]=e.charCodeAt(r);return t}n.vtk=window.vtk,n.vtkns={},n.vtk&&(n.vtkns.DataArray=n.vtk.Common.Core.vtkDataArray,n.vtkns.ImageData=n.vtk.Common.DataModel.vtkImageData,n.vtkns.OutlineFilter=n.vtk.Filters.General.vtkOutlineFilter,n.vtkns.CubeSource=n.vtk.Filters.Sources.vtkCubeSource,n.vtkns.LineSource=n.vtk.Filters.Sources.vtkLineSource,n.vtkns.PlaneSource=n.vtk.Filters.Sources.vtkPlaneSource,n.vtkns.PointSource=n.vtk.Filters.Sources.vtkPointSource,n.vtkns.OrientationMarkerWidget=n.vtk.Interaction.Widgets.vtkOrientationMarkerWidget,n.vtkns.DataAccessHelper=n.vtk.IO.Core.DataAccessHelper,n.vtkns.HttpSceneLoader=n.vtk.IO.Core.vtkHttpSceneLoader,n.vtkns.ImageSlice=n.vtk.Rendering.Core.vtkImageSlice,n.vtkns.Actor=n.vtk.Rendering.Core.vtkActor,n.vtkns.AxesActor=n.vtk.Rendering.Core.vtkAxesActor,n.vtkns.Mapper=n.vtk.Rendering.Core.vtkMapper,n.vtkns.ImageMapper=n.vtk.Rendering.Core.vtkImageMapper,n.vtkns.SphereMapper=n.vtk.Rendering.Core.vtkSphereMapper,n.vtkns.WidgetManager=n.vtk.Widgets.Core.vtkWidgetManager,n.vtkns.InteractiveOrientationWidget=n.vtk.Widgets.Widgets3D.vtkInteractiveOrientationWidget,n.vtkns.PixelSpaceCallbackMapper=n.vtk.Rendering.Core.vtkPixelSpaceCallbackMapper,n.vtkns.FullScreenRenderWindow=n.vtk.Rendering.Misc.vtkFullScreenRenderWindow,n.vtkns.VolumeController=n.vtk.Interaction.UI.vtkVolumeController,n.vtkns.Volume=n.vtk.Rendering.Core.vtkVolume,n.vtkns.VolumeMapper=n.vtk.Rendering.Core.vtkVolumeMapper,n.vtkns.ColorTransferFunction=n.vtk.Rendering.Core.vtkColorTransferFunction,n.vtkns.PiecewiseFunction=n.vtk.Common.DataModel.vtkPiecewiseFunction,n.vtkns.BoundingBox=n.vtk.Common.DataModel.vtkBoundingBox),n.hexToRGB=function(e){return[parseInt(e.slice(1,3),16)/255,parseInt(e.slice(3,5),16)/255,parseInt(e.slice(5,7),16)/255]},n.data2VTKImageData=function(e){var t=n.vtkns.ImageData.newInstance({spacing:e.spacing});t.setDimensions(e.dims),t.setOrigin(null!=e.origin?e.origin:e.dims.map(function(e){return e/2}));var o=n.vtkns.DataArray.newInstance({name:"scalars",numberOfComponents:1,values:new r.ARRAY_TYPES[e.dtype](a(atob(e.buffer)))});return t.getPointData().setScalars(o),t},n.majorAxis=function(e,t,n){var r=[0,0,0],a=Math.abs(e[t])>Math.abs(e[n])?t:n,o=e[a]>0?1:-1;return r[a]=o,r},n.cartesian_product=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];return e.reduce(function(e,t){return e.flatMap(function(e){return t.map(function(t){return[].concat(e,t)})})})}},
"51dfc8cb0e": function _(e,t,n){var r,i=this&&this.__extends||(r=function(e,t){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},function(e,t){function n(){this.constructor=e}r(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}),o=(this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var n in e)Object.hasOwnProperty.call(e,n)&&(t[n]=e[n]);return t.default=e,t})(e("@bokehjs/core/properties")),s=e("@bokehjs/models/layouts/html_box"),a=e("3755bf9cce"),l=e("f35231aba1"),c=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return i(t,e),t.prototype.connect_signals=function(){var t=this;e.prototype.connect_signals.call(this),this.connect(this.model.properties.data.change,function(){t.invalidate_render()}),this.connect(this.model.properties.colormap.change,function(){t.colormap_slector.value=t.model.colormap;var e=new Event("change");t.colormap_slector.dispatchEvent(e)}),this.connect(this.model.properties.shadow.change,function(){t.shadow_selector.value=t.model.shadow?"1":"0";var e=new Event("change");t.shadow_selector.dispatchEvent(e)}),this.connect(this.model.properties.sampling.change,function(){t.sampling_slider.value=t.model.sampling.toFixed(2);var e=new Event("input");t.sampling_slider.dispatchEvent(e)}),this.connect(this.model.properties.edge_gradient.change,function(){t.edge_gradient_slider.value=t.model.edge_gradient.toFixed(2);var e=new Event("input");t.edge_gradient_slider.dispatchEvent(e)}),this.connect(this.model.properties.rescale.change,function(){t._controllerWidget.setRescaleColorMap(t.model.rescale),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.ambient.change,function(){t.volume.getProperty().setAmbient(t.model.ambient),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.diffuse.change,function(){t.volume.getProperty().setDiffuse(t.model.diffuse),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.specular.change,function(){t.volume.getProperty().setSpecular(t.model.specular),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.specular_power.change,function(){t.volume.getProperty().setSpecularPower(t.model.specular_power),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.display_volume.change,function(){t._set_volume_visbility(t.model.display_volume),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.display_slices.change,function(){t._set_slices_visbility(t.model.display_slices),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.slice_i.change,function(){t.image_actor_i.getMapper().setISlice(t.model.slice_i),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.slice_j.change,function(){t.image_actor_j.getMapper().setJSlice(t.model.slice_j),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.slice_k.change,function(){t.image_actor_k.getMapper().setKSlice(t.model.slice_k),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.render_background.change,function(){var e;(e=t._vtk_renwin.getRenderer()).setBackground.apply(e,l.hexToRGB(t.model.render_background)),t._vtk_renwin.getRenderWindow().render()}),this.connect(this.model.properties.interpolation.change,function(){t._set_interpolation(t.model.interpolation),t._vtk_renwin.getRenderWindow().render()})},Object.defineProperty(t.prototype,"volume",{get:function(){return this._controllerWidget.getActor()},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"image_actor_i",{get:function(){return this._vtk_renwin.getRenderer().getActors()[0]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"image_actor_j",{get:function(){return this._vtk_renwin.getRenderer().getActors()[1]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"image_actor_k",{get:function(){return this._vtk_renwin.getRenderer().getActors()[2]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"shadow_selector",{get:function(){return this.el.querySelector(".js-shadow")},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"edge_gradient_slider",{get:function(){return this.el.querySelector(".js-edge")},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"sampling_slider",{get:function(){return this.el.querySelector(".js-spacing")},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"colormap_slector",{get:function(){return this.el.querySelector(".js-color-preset")},enumerable:!0,configurable:!0}),t.prototype._set_interpolation=function(e){"fast_linear"==e?(this.volume.getProperty().setInterpolationTypeToFastLinear(),this.image_actor_i.getProperty().setInterpolationTypeToLinear()):"linear"==e?(this.volume.getProperty().setInterpolationTypeToLinear(),this.image_actor_i.getProperty().setInterpolationTypeToLinear()):(this.volume.getProperty().setInterpolationTypeToNearest(),this.image_actor_i.getProperty().setInterpolationTypeToNearest())},t.prototype.render=function(){var t;e.prototype.render.call(this),this._controllerWidget=l.vtkns.VolumeController.newInstance({size:[400,150],rescaleColorMap:this.model.rescale}),this._vtk_image_data=l.data2VTKImageData(this.model.data),this._controllerWidget.setContainer(this.el),this._vtk_renwin.getRenderWindow().getInteractor(),this._vtk_renwin.getRenderWindow().getInteractor().setDesiredUpdateRate(45),this._plot_volume(),this._connect_controls(),this._plot_slices(),this._set_volume_visbility(this.model.display_volume),this._set_slices_visbility(this.model.display_slices),(t=this._vtk_renwin.getRenderer()).setBackground.apply(t,l.hexToRGB(this.model.render_background)),this._set_interpolation(this.model.interpolation),this._vtk_renwin.getRenderer().resetCamera()},t.prototype._connect_controls=function(){var e=this;this.colormap_slector.addEventListener("change",function(){e.model.colormap=e.colormap_slector.value}),this.model.colormap?this.model.properties.colormap.change.emit():this.model.colormap=this.colormap_slector.value,this.shadow_selector.addEventListener("change",function(){e.model.shadow=!!Number(e.shadow_selector.value)}),(this.model.shadow=!!Number(this.shadow_selector.value))&&this.model.properties.shadow.change.emit(),this.sampling_slider.addEventListener("input",function(){var t=Number(e.sampling_slider.value);Math.abs(e.model.sampling-t)>=.005&&(e.model.sampling=t)}),Math.abs(this.model.sampling-Number(this.shadow_selector.value))>=.005&&this.model.properties.sampling.change.emit(),this.edge_gradient_slider.addEventListener("input",function(){var t=Number(e.edge_gradient_slider.value);Math.abs(e.model.edge_gradient-t)>=.005&&(e.model.edge_gradient=t)}),Math.abs(this.model.edge_gradient-Number(this.edge_gradient_slider.value))>=.005&&this.model.properties.edge_gradient.change.emit()},t.prototype._plot_volume=function(){var e=this._vtk_image_data,t=l.vtkns.Volume.newInstance(),n=l.vtkns.VolumeMapper.newInstance();t.setMapper(n),n.setInputData(e);var r=(e.getPointData().getScalars()||e.getPointData().getArrays()[0]).getRange(),i=l.vtkns.ColorTransferFunction.newInstance(),o=l.vtkns.PiecewiseFunction.newInstance(),s=.7*Math.sqrt(e.getSpacing().map(function(e){return e*e}).reduce(function(e,t){return e+t},0));n.setSampleDistance(s),t.getProperty().setRGBTransferFunction(0,i),t.getProperty().setScalarOpacity(0,o),t.getProperty().setInterpolationTypeToFastLinear(),t.getProperty().setScalarOpacityUnitDistance(0,l.vtkns.BoundingBox.getDiagonalLength(e.getBounds())/Math.max.apply(Math,e.getDimensions())),t.getProperty().setGradientOpacityMinimumValue(0,0),t.getProperty().setGradientOpacityMaximumValue(0,.05*(r[1]-r[0])),t.getProperty().setShade(this.model.shadow),t.getProperty().setUseGradientOpacity(0,!0),t.getProperty().setGradientOpacityMinimumOpacity(0,0),t.getProperty().setGradientOpacityMaximumOpacity(0,1),t.getProperty().setAmbient(this.model.ambient),t.getProperty().setDiffuse(this.model.diffuse),t.getProperty().setSpecular(this.model.specular),t.getProperty().setSpecularPower(this.model.specular_power),this._vtk_renwin.getRenderer().addVolume(t),this._controllerWidget.setupContent(this._vtk_renwin.getRenderWindow(),t,!0)},t.prototype._plot_slices=function(){var e=this._vtk_image_data,t=l.vtkns.ImageSlice.newInstance(),n=l.vtkns.ImageSlice.newInstance(),r=l.vtkns.ImageSlice.newInstance(),i=l.vtkns.ImageMapper.newInstance(),o=l.vtkns.ImageMapper.newInstance(),s=l.vtkns.ImageMapper.newInstance();i.setInputData(e),i.setISlice(this.model.slice_i),t.setMapper(i),o.setInputData(e),o.setJSlice(this.model.slice_j),n.setMapper(o),s.setInputData(e),s.setKSlice(this.model.slice_k),r.setMapper(s);var a=l.vtkns.PiecewiseFunction.newInstance();a.removeAllPoints(),a.addPoint(0,1);var c=this.volume.getProperty().getRGBTransferFunction(0),p=t.getProperty();n.setProperty(p),r.setProperty(p),p.setRGBTransferFunction(c),p.setScalarOpacity(a);var d=this._vtk_renwin.getRenderer();d.addActor(t),d.addActor(n),d.addActor(r)},t.prototype._set_volume_visbility=function(e){this.volume.setVisibility(e)},t.prototype._set_slices_visbility=function(e){this._vtk_renwin.getRenderer().getActors().map(function(t){return t.setVisibility(e)})},t.__name__="VTKVolumePlotView",t}(a.VTKHTMLBoxView);n.VTKVolumePlotView=c;var p=function(e){function t(t){return e.call(this,t)||this}return i(t,e),t.init_VTKVolumePlot=function(){this.prototype.default_view=c,this.define({data:[o.Instance],shadow:[o.Boolean,!0],sampling:[o.Number,.4],edge_gradient:[o.Number,.2],colormap:[o.String],rescale:[o.Boolean,!1],ambient:[o.Number,.2],diffuse:[o.Number,.7],specular:[o.Number,.3],specular_power:[o.Number,8],slice_i:[o.Int,0],slice_j:[o.Int,0],slice_k:[o.Int,0],display_volume:[o.Boolean,!0],display_slices:[o.Boolean,!1],render_background:[o.String,"#52576e"],interpolation:[o.Any,"fast_linear"]}),this.override({height:300,width:300})},t.__name__="VTKVolumePlot",t.__module__="panel.models.vtk",t}(s.HTMLBox);n.VTKVolumePlot=p,p.init_VTKVolumePlot()},
"5bc27423fe": function _(t,e,i){var s,n=this&&this.__extends||(s=function(t,e){return(s=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i])})(t,e)},function(t,e){function i(){this.constructor=t}s(t,e),t.prototype=null===e?Object.create(e):(i.prototype=e.prototype,new i)}),r=this&&this.__importStar||function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var i in t)Object.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e.default=t,e},a=t("3f31df8362"),c=t("@bokehjs/model"),o=r(t("@bokehjs/core/properties")),l=t("f35231aba1"),h=function(t){function e(e){return t.call(this,e)||this}return n(e,t),e.init_VTKAxes=function(){this.define({origin:[o.Array],xticker:[o.Instance],yticker:[o.Instance],zticker:[o.Instance],digits:[o.Number,1],show_grid:[o.Boolean,!0],grid_opacity:[o.Number,.1],axes_opacity:[o.Number,1],fontsize:[o.Number,12]})},Object.defineProperty(e.prototype,"xticks",{get:function(){return this.xticker.ticks},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"yticks",{get:function(){return this.yticker.ticks},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"zticks",{get:function(){return this.zticker.ticks},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"xlabels",{get:function(){var t=this;return this.xticker.labels?this.xticker.labels:this.xticks.map(function(e){return e.toFixed(t.digits)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"ylabels",{get:function(){var t=this;return this.yticker.labels?this.yticker.labels:this.yticks.map(function(e){return e.toFixed(t.digits)})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"zlabels",{get:function(){var t=this;return this.zticker.labels?this.zticker.labels:this.zticks.map(function(e){return e.toFixed(t.digits)})},enumerable:!0,configurable:!0}),e.prototype._make_grid_lines=function(t,e,i){for(var s=[],n=0;n<t-1;n++)for(var r=0;r<e-1;r++){var a=n*e+r+i,c=[5,a,n*e+r+1+i,(n+1)*e+r+1+i,(n+1)*e+r+i,a];s.push(c)}return s},e.prototype._create_grid_axes=function(){var t=[];t.push(l.cartesian_product(this.xticks,this.yticks,[this.origin[2]])),t.push(l.cartesian_product([this.origin[0]],this.yticks,this.zticks)),t.push(l.cartesian_product(this.xticks,[this.origin[1]],this.zticks));var e=[],i=0;e.push(this._make_grid_lines(this.xticks.length,this.yticks.length,i)),i+=this.xticks.length*this.yticks.length,e.push(this._make_grid_lines(this.yticks.length,this.zticks.length,i)),i+=this.yticks.length*this.zticks.length,e.push(this._make_grid_lines(this.xticks.length,this.zticks.length,i));var s=l.vtk({vtkClass:"vtkPolyData",points:{vtkClass:"vtkPoints",dataType:"Float32Array",numberOfComponents:3,values:t.flat(2)},lines:{vtkClass:"vtkCellArray",dataType:"Uint32Array",values:e.flat(2)}}),n=l.vtkns.Mapper.newInstance(),r=l.vtkns.Actor.newInstance();return n.setInputData(s),r.setMapper(n),r.getProperty().setOpacity(this.grid_opacity),r.setVisibility(this.show_grid),r},e.prototype.create_axes=function(t){var e=this,i=[this.xticks,this.yticks,this.zticks].map(function(t,i){var s=null;switch(i){case 0:s=l.cartesian_product(t,[e.origin[1]],[e.origin[2]]);break;case 1:s=l.cartesian_product([e.origin[0]],t,[e.origin[2]]);break;case 2:s=l.cartesian_product([e.origin[0]],[e.origin[1]],t)}return s}).flat(2),s=l.vtk({vtkClass:"vtkPolyData",points:{vtkClass:"vtkPoints",dataType:"Float32Array",numberOfComponents:3,values:i},lines:{vtkClass:"vtkCellArray",dataType:"Uint32Array",values:[2,0,this.xticks.length-1,2,this.xticks.length,this.xticks.length+this.yticks.length-1,2,this.xticks.length+this.yticks.length,this.xticks.length+this.yticks.length+this.zticks.length-1]}}),n=l.vtkns.PixelSpaceCallbackMapper.newInstance();n.setInputData(s),n.setUseZValues(!0),n.setCallback(function(i,s,r){var c=t.getContext("2d");if(c){var o={height:t.clientHeight*window.devicePixelRatio,width:t.clientWidth*window.devicePixelRatio},l=n.getInputData().getPoints(),h=s.getViewMatrix();a.mat4.transpose(h,h);var p=s.getProjectionMatrix(r,-1,1);a.mat4.transpose(p,p),c.clearRect(0,0,o.width,o.height),i.forEach(function(t,i){var s=l.getPoint(i),n=a.vec3.fromValues(s[0],s[1],s[2]);if(a.vec3.transformMat4(n,n,h),n[2]+=.05,a.vec3.transformMat4(n,n,p),n[2]-.001<t[3]){c.font="30px serif",c.textAlign="center",c.textBaseline="alphabetic",c.fillText(".",t[0],o.height-t[1]+2),c.font=e.fontsize*window.devicePixelRatio+"px serif",c.textAlign="right",c.textBaseline="top";var r=void 0;r=i<e.xticks.length?e.xlabels[i]:i>=e.xticks.length&&i<e.xticks.length+e.yticks.length?e.ylabels[i-e.xticks.length]:e.zlabels[i-(e.xticks.length+e.yticks.length)],c.fillText(""+r,t[0],o.height-t[1])}})}});var r=l.vtkns.Actor.newInstance();r.setMapper(n);var c=l.vtkns.Mapper.newInstance();c.setInputData(s);var o=l.vtkns.Actor.newInstance();return o.setMapper(c),o.getProperty().setOpacity(this.axes_opacity),{psActor:r,axesActor:o,gridActor:this._create_grid_axes()}},e.__name__="VTKAxes",e.__module__="panel.models.vtk",e}(c.Model);i.VTKAxes=h,h.init_VTKAxes()},
"3f31df8362": function _(e,a,t){t.vec4=t.vec3=t.vec2=t.quat2=t.quat=t.mat4=t.mat3=t.mat2d=t.mat2=t.glMatrix=void 0;var r=p(e("c6b4e451bc"));t.glMatrix=r;var c=p(e("de7a8760b2"));t.mat2=c;var f=p(e("19c4f7f3f1"));t.mat2d=f;var v=p(e("4b4956d3f5"));t.mat3=v;var d=p(e("04eeb2ead8"));t.mat4=d;var o=p(e("fb0a790f46"));t.quat=o;var i=p(e("43b2ef2f0a"));t.quat2=i;var n=p(e("7aa5d7ae2d"));t.vec2=n;var b=p(e("9aff2264cd"));t.vec3=b;var u=p(e("2c797465df"));function p(e){if(e&&e.__esModule)return e;var a={};if(null!=e)for(var t in e)if(Object.prototype.hasOwnProperty.call(e,t)){var r=Object.defineProperty&&Object.getOwnPropertyDescriptor?Object.getOwnPropertyDescriptor(e,t):{};r.get||r.set?Object.defineProperty(a,t,r):a[t]=e[t]}return a.default=e,a}t.vec4=u},
"c6b4e451bc": function _(a,t,r){r.setMatrixArrayType=function(a){r.ARRAY_TYPE=o=a},r.toRadian=function(a){return a*A},r.equals=function(a,t){return Math.abs(a-t)<=n*Math.max(1,Math.abs(a),Math.abs(t))},r.RANDOM=r.ARRAY_TYPE=r.EPSILON=void 0;var n=1e-6;r.EPSILON=n;var o="undefined"!=typeof Float32Array?Float32Array:Array;r.ARRAY_TYPE=o;var h=Math.random;r.RANDOM=h;var A=Math.PI/180;Math.hypot||(Math.hypot=function(){for(var a=0,t=arguments.length;t--;)a+=arguments[t]*arguments[t];return Math.sqrt(a)})},
"de7a8760b2": function _(t,n,r){r.create=function(){var t=new a.ARRAY_TYPE(4);a.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0);return t[0]=1,t[3]=1,t},r.clone=function(t){var n=new a.ARRAY_TYPE(4);return n[0]=t[0],n[1]=t[1],n[2]=t[2],n[3]=t[3],n},r.copy=function(t,n){return t[0]=n[0],t[1]=n[1],t[2]=n[2],t[3]=n[3],t},r.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t},r.fromValues=function(t,n,r,e){var u=new a.ARRAY_TYPE(4);return u[0]=t,u[1]=n,u[2]=r,u[3]=e,u},r.set=function(t,n,r,a,e){return t[0]=n,t[1]=r,t[2]=a,t[3]=e,t},r.transpose=function(t,n){if(t===n){var r=n[1];t[1]=n[2],t[2]=r}else t[0]=n[0],t[1]=n[2],t[2]=n[1],t[3]=n[3];return t},r.invert=function(t,n){var r=n[0],a=n[1],e=n[2],u=n[3],o=r*u-e*a;if(!o)return null;return o=1/o,t[0]=u*o,t[1]=-a*o,t[2]=-e*o,t[3]=r*o,t},r.adjoint=function(t,n){var r=n[0];return t[0]=n[3],t[1]=-n[1],t[2]=-n[2],t[3]=r,t},r.determinant=function(t){return t[0]*t[3]-t[2]*t[1]},r.multiply=e,r.rotate=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=Math.sin(r),c=Math.cos(r);return t[0]=a*c+u*i,t[1]=e*c+o*i,t[2]=a*-i+u*c,t[3]=e*-i+o*c,t},r.scale=function(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=r[0],c=r[1];return t[0]=a*i,t[1]=e*i,t[2]=u*c,t[3]=o*c,t},r.fromRotation=function(t,n){var r=Math.sin(n),a=Math.cos(n);return t[0]=a,t[1]=r,t[2]=-r,t[3]=a,t},r.fromScaling=function(t,n){return t[0]=n[0],t[1]=0,t[2]=0,t[3]=n[1],t},r.str=function(t){return"mat2("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},r.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3])},r.LDU=function(t,n,r,a){return t[2]=a[2]/a[0],r[0]=a[0],r[1]=a[1],r[3]=a[3]-t[2]*r[1],[t,n,r]},r.add=function(t,n,r){return t[0]=n[0]+r[0],t[1]=n[1]+r[1],t[2]=n[2]+r[2],t[3]=n[3]+r[3],t},r.subtract=u,r.exactEquals=function(t,n){return t[0]===n[0]&&t[1]===n[1]&&t[2]===n[2]&&t[3]===n[3]},r.equals=function(t,n){var r=t[0],e=t[1],u=t[2],o=t[3],i=n[0],c=n[1],f=n[2],s=n[3];return Math.abs(r-i)<=a.EPSILON*Math.max(1,Math.abs(r),Math.abs(i))&&Math.abs(e-c)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(c))&&Math.abs(u-f)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(f))&&Math.abs(o-s)<=a.EPSILON*Math.max(1,Math.abs(o),Math.abs(s))},r.multiplyScalar=function(t,n,r){return t[0]=n[0]*r,t[1]=n[1]*r,t[2]=n[2]*r,t[3]=n[3]*r,t},r.multiplyScalarAndAdd=function(t,n,r,a){return t[0]=n[0]+r[0]*a,t[1]=n[1]+r[1]*a,t[2]=n[2]+r[2]*a,t[3]=n[3]+r[3]*a,t},r.sub=r.mul=void 0;var a=function(t){if(t&&t.__esModule)return t;var n={};if(null!=t)for(var r in t)if(Object.prototype.hasOwnProperty.call(t,r)){var a=Object.defineProperty&&Object.getOwnPropertyDescriptor?Object.getOwnPropertyDescriptor(t,r):{};a.get||a.set?Object.defineProperty(n,r,a):n[r]=t[r]}return n.default=t,n}(t("c6b4e451bc"));function e(t,n,r){var a=n[0],e=n[1],u=n[2],o=n[3],i=r[0],c=r[1],f=r[2],s=r[3];return t[0]=a*i+u*c,t[1]=e*i+o*c,t[2]=a*f+u*s,t[3]=e*f+o*s,t}function u(t,n,r){return t[0]=n[0]-r[0],t[1]=n[1]-r[1],t[2]=n[2]-r[2],t[3]=n[3]-r[3],t}var o=e;r.mul=o;var i=u;r.sub=i},
"19c4f7f3f1": function _(t,r,n){n.create=function(){var t=new a.ARRAY_TYPE(6);a.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[4]=0,t[5]=0);return t[0]=1,t[3]=1,t},n.clone=function(t){var r=new a.ARRAY_TYPE(6);return r[0]=t[0],r[1]=t[1],r[2]=t[2],r[3]=t[3],r[4]=t[4],r[5]=t[5],r},n.copy=function(t,r){return t[0]=r[0],t[1]=r[1],t[2]=r[2],t[3]=r[3],t[4]=r[4],t[5]=r[5],t},n.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t},n.fromValues=function(t,r,n,e,u,o){var i=new a.ARRAY_TYPE(6);return i[0]=t,i[1]=r,i[2]=n,i[3]=e,i[4]=u,i[5]=o,i},n.set=function(t,r,n,a,e,u,o){return t[0]=r,t[1]=n,t[2]=a,t[3]=e,t[4]=u,t[5]=o,t},n.invert=function(t,r){var n=r[0],a=r[1],e=r[2],u=r[3],o=r[4],i=r[5],c=n*u-a*e;if(!c)return null;return c=1/c,t[0]=u*c,t[1]=-a*c,t[2]=-e*c,t[3]=n*c,t[4]=(e*i-u*o)*c,t[5]=(a*o-n*i)*c,t},n.determinant=function(t){return t[0]*t[3]-t[1]*t[2]},n.multiply=e,n.rotate=function(t,r,n){var a=r[0],e=r[1],u=r[2],o=r[3],i=r[4],c=r[5],f=Math.sin(n),s=Math.cos(n);return t[0]=a*s+u*f,t[1]=e*s+o*f,t[2]=a*-f+u*s,t[3]=e*-f+o*s,t[4]=i,t[5]=c,t},n.scale=function(t,r,n){var a=r[0],e=r[1],u=r[2],o=r[3],i=r[4],c=r[5],f=n[0],s=n[1];return t[0]=a*f,t[1]=e*f,t[2]=u*s,t[3]=o*s,t[4]=i,t[5]=c,t},n.translate=function(t,r,n){var a=r[0],e=r[1],u=r[2],o=r[3],i=r[4],c=r[5],f=n[0],s=n[1];return t[0]=a,t[1]=e,t[2]=u,t[3]=o,t[4]=a*f+u*s+i,t[5]=e*f+o*s+c,t},n.fromRotation=function(t,r){var n=Math.sin(r),a=Math.cos(r);return t[0]=a,t[1]=n,t[2]=-n,t[3]=a,t[4]=0,t[5]=0,t},n.fromScaling=function(t,r){return t[0]=r[0],t[1]=0,t[2]=0,t[3]=r[1],t[4]=0,t[5]=0,t},n.fromTranslation=function(t,r){return t[0]=1,t[1]=0,t[2]=0,t[3]=1,t[4]=r[0],t[5]=r[1],t},n.str=function(t){return"mat2d("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+")"},n.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3],t[4],t[5],1)},n.add=function(t,r,n){return t[0]=r[0]+n[0],t[1]=r[1]+n[1],t[2]=r[2]+n[2],t[3]=r[3]+n[3],t[4]=r[4]+n[4],t[5]=r[5]+n[5],t},n.subtract=u,n.multiplyScalar=function(t,r,n){return t[0]=r[0]*n,t[1]=r[1]*n,t[2]=r[2]*n,t[3]=r[3]*n,t[4]=r[4]*n,t[5]=r[5]*n,t},n.multiplyScalarAndAdd=function(t,r,n,a){return t[0]=r[0]+n[0]*a,t[1]=r[1]+n[1]*a,t[2]=r[2]+n[2]*a,t[3]=r[3]+n[3]*a,t[4]=r[4]+n[4]*a,t[5]=r[5]+n[5]*a,t},n.exactEquals=function(t,r){return t[0]===r[0]&&t[1]===r[1]&&t[2]===r[2]&&t[3]===r[3]&&t[4]===r[4]&&t[5]===r[5]},n.equals=function(t,r){var n=t[0],e=t[1],u=t[2],o=t[3],i=t[4],c=t[5],f=r[0],s=r[1],h=r[2],M=r[3],b=r[4],l=r[5];return Math.abs(n-f)<=a.EPSILON*Math.max(1,Math.abs(n),Math.abs(f))&&Math.abs(e-s)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(s))&&Math.abs(u-h)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(h))&&Math.abs(o-M)<=a.EPSILON*Math.max(1,Math.abs(o),Math.abs(M))&&Math.abs(i-b)<=a.EPSILON*Math.max(1,Math.abs(i),Math.abs(b))&&Math.abs(c-l)<=a.EPSILON*Math.max(1,Math.abs(c),Math.abs(l))},n.sub=n.mul=void 0;var a=function(t){if(t&&t.__esModule)return t;var r={};if(null!=t)for(var n in t)if(Object.prototype.hasOwnProperty.call(t,n)){var a=Object.defineProperty&&Object.getOwnPropertyDescriptor?Object.getOwnPropertyDescriptor(t,n):{};a.get||a.set?Object.defineProperty(r,n,a):r[n]=t[n]}return r.default=t,r}(t("c6b4e451bc"));function e(t,r,n){var a=r[0],e=r[1],u=r[2],o=r[3],i=r[4],c=r[5],f=n[0],s=n[1],h=n[2],M=n[3],b=n[4],l=n[5];return t[0]=a*f+u*s,t[1]=e*f+o*s,t[2]=a*h+u*M,t[3]=e*h+o*M,t[4]=a*b+u*l+i,t[5]=e*b+o*l+c,t}function u(t,r,n){return t[0]=r[0]-n[0],t[1]=r[1]-n[1],t[2]=r[2]-n[2],t[3]=r[3]-n[3],t[4]=r[4]-n[4],t[5]=r[5]-n[5],t}var o=e;n.mul=o;var i=u;n.sub=i},
"4b4956d3f5": function _(t,a,r){r.create=function(){var t=new n.ARRAY_TYPE(9);n.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[5]=0,t[6]=0,t[7]=0);return t[0]=1,t[4]=1,t[8]=1,t},r.fromMat4=function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[4],t[4]=a[5],t[5]=a[6],t[6]=a[8],t[7]=a[9],t[8]=a[10],t},r.clone=function(t){var a=new n.ARRAY_TYPE(9);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a[4]=t[4],a[5]=t[5],a[6]=t[6],a[7]=t[7],a[8]=t[8],a},r.copy=function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t[8]=a[8],t},r.fromValues=function(t,a,r,u,e,o,i,c,f){var s=new n.ARRAY_TYPE(9);return s[0]=t,s[1]=a,s[2]=r,s[3]=u,s[4]=e,s[5]=o,s[6]=i,s[7]=c,s[8]=f,s},r.set=function(t,a,r,n,u,e,o,i,c,f){return t[0]=a,t[1]=r,t[2]=n,t[3]=u,t[4]=e,t[5]=o,t[6]=i,t[7]=c,t[8]=f,t},r.identity=function(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},r.transpose=function(t,a){if(t===a){var r=a[1],n=a[2],u=a[5];t[1]=a[3],t[2]=a[6],t[3]=r,t[5]=a[7],t[6]=n,t[7]=u}else t[0]=a[0],t[1]=a[3],t[2]=a[6],t[3]=a[1],t[4]=a[4],t[5]=a[7],t[6]=a[2],t[7]=a[5],t[8]=a[8];return t},r.invert=function(t,a){var r=a[0],n=a[1],u=a[2],e=a[3],o=a[4],i=a[5],c=a[6],f=a[7],s=a[8],M=s*o-i*f,h=-s*e+i*c,b=f*e-o*c,l=r*M+n*h+u*b;if(!l)return null;return l=1/l,t[0]=M*l,t[1]=(-s*n+u*f)*l,t[2]=(i*n-u*o)*l,t[3]=h*l,t[4]=(s*r-u*c)*l,t[5]=(-i*r+u*e)*l,t[6]=b*l,t[7]=(-f*r+n*c)*l,t[8]=(o*r-n*e)*l,t},r.adjoint=function(t,a){var r=a[0],n=a[1],u=a[2],e=a[3],o=a[4],i=a[5],c=a[6],f=a[7],s=a[8];return t[0]=o*s-i*f,t[1]=u*f-n*s,t[2]=n*i-u*o,t[3]=i*c-e*s,t[4]=r*s-u*c,t[5]=u*e-r*i,t[6]=e*f-o*c,t[7]=n*c-r*f,t[8]=r*o-n*e,t},r.determinant=function(t){var a=t[0],r=t[1],n=t[2],u=t[3],e=t[4],o=t[5],i=t[6],c=t[7],f=t[8];return a*(f*e-o*c)+r*(-f*u+o*i)+n*(c*u-e*i)},r.multiply=u,r.translate=function(t,a,r){var n=a[0],u=a[1],e=a[2],o=a[3],i=a[4],c=a[5],f=a[6],s=a[7],M=a[8],h=r[0],b=r[1];return t[0]=n,t[1]=u,t[2]=e,t[3]=o,t[4]=i,t[5]=c,t[6]=h*n+b*o+f,t[7]=h*u+b*i+s,t[8]=h*e+b*c+M,t},r.rotate=function(t,a,r){var n=a[0],u=a[1],e=a[2],o=a[3],i=a[4],c=a[5],f=a[6],s=a[7],M=a[8],h=Math.sin(r),b=Math.cos(r);return t[0]=b*n+h*o,t[1]=b*u+h*i,t[2]=b*e+h*c,t[3]=b*o-h*n,t[4]=b*i-h*u,t[5]=b*c-h*e,t[6]=f,t[7]=s,t[8]=M,t},r.scale=function(t,a,r){var n=r[0],u=r[1];return t[0]=n*a[0],t[1]=n*a[1],t[2]=n*a[2],t[3]=u*a[3],t[4]=u*a[4],t[5]=u*a[5],t[6]=a[6],t[7]=a[7],t[8]=a[8],t},r.fromTranslation=function(t,a){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=1,t[5]=0,t[6]=a[0],t[7]=a[1],t[8]=1,t},r.fromRotation=function(t,a){var r=Math.sin(a),n=Math.cos(a);return t[0]=n,t[1]=r,t[2]=0,t[3]=-r,t[4]=n,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},r.fromScaling=function(t,a){return t[0]=a[0],t[1]=0,t[2]=0,t[3]=0,t[4]=a[1],t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},r.fromMat2d=function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=0,t[3]=a[2],t[4]=a[3],t[5]=0,t[6]=a[4],t[7]=a[5],t[8]=1,t},r.fromQuat=function(t,a){var r=a[0],n=a[1],u=a[2],e=a[3],o=r+r,i=n+n,c=u+u,f=r*o,s=n*o,M=n*i,h=u*o,b=u*i,l=u*c,m=e*o,v=e*i,P=e*c;return t[0]=1-M-l,t[3]=s-P,t[6]=h+v,t[1]=s+P,t[4]=1-f-l,t[7]=b-m,t[2]=h-v,t[5]=b+m,t[8]=1-f-M,t},r.normalFromMat4=function(t,a){var r=a[0],n=a[1],u=a[2],e=a[3],o=a[4],i=a[5],c=a[6],f=a[7],s=a[8],M=a[9],h=a[10],b=a[11],l=a[12],m=a[13],v=a[14],P=a[15],O=r*i-n*o,p=r*c-u*o,d=r*f-e*o,E=n*c-u*i,y=n*f-e*i,S=u*f-e*c,A=s*m-M*l,x=s*v-h*l,I=s*P-b*l,L=M*v-h*m,N=M*P-b*m,R=h*P-b*v,Y=O*R-p*N+d*L+E*I-y*x+S*A;if(!Y)return null;return Y=1/Y,t[0]=(i*R-c*N+f*L)*Y,t[1]=(c*I-o*R-f*x)*Y,t[2]=(o*N-i*I+f*A)*Y,t[3]=(u*N-n*R-e*L)*Y,t[4]=(r*R-u*I+e*x)*Y,t[5]=(n*I-r*N-e*A)*Y,t[6]=(m*S-v*y+P*E)*Y,t[7]=(v*d-l*S-P*p)*Y,t[8]=(l*y-m*d+P*O)*Y,t},r.projection=function(t,a,r){return t[0]=2/a,t[1]=0,t[2]=0,t[3]=0,t[4]=-2/r,t[5]=0,t[6]=-1,t[7]=1,t[8]=1,t},r.str=function(t){return"mat3("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+")"},r.frob=function(t){return Math.hypot(t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8])},r.add=function(t,a,r){return t[0]=a[0]+r[0],t[1]=a[1]+r[1],t[2]=a[2]+r[2],t[3]=a[3]+r[3],t[4]=a[4]+r[4],t[5]=a[5]+r[5],t[6]=a[6]+r[6],t[7]=a[7]+r[7],t[8]=a[8]+r[8],t},r.subtract=e,r.multiplyScalar=function(t,a,r){return t[0]=a[0]*r,t[1]=a[1]*r,t[2]=a[2]*r,t[3]=a[3]*r,t[4]=a[4]*r,t[5]=a[5]*r,t[6]=a[6]*r,t[7]=a[7]*r,t[8]=a[8]*r,t},r.multiplyScalarAndAdd=function(t,a,r,n){return t[0]=a[0]+r[0]*n,t[1]=a[1]+r[1]*n,t[2]=a[2]+r[2]*n,t[3]=a[3]+r[3]*n,t[4]=a[4]+r[4]*n,t[5]=a[5]+r[5]*n,t[6]=a[6]+r[6]*n,t[7]=a[7]+r[7]*n,t[8]=a[8]+r[8]*n,t},r.exactEquals=function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]&&t[4]===a[4]&&t[5]===a[5]&&t[6]===a[6]&&t[7]===a[7]&&t[8]===a[8]},r.equals=function(t,a){var r=t[0],u=t[1],e=t[2],o=t[3],i=t[4],c=t[5],f=t[6],s=t[7],M=t[8],h=a[0],b=a[1],l=a[2],m=a[3],v=a[4],P=a[5],O=a[6],p=a[7],d=a[8];return Math.abs(r-h)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(h))&&Math.abs(u-b)<=n.EPSILON*Math.max(1,Math.abs(u),Math.abs(b))&&Math.abs(e-l)<=n.EPSILON*Math.max(1,Math.abs(e),Math.abs(l))&&Math.abs(o-m)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(m))&&Math.abs(i-v)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(v))&&Math.abs(c-P)<=n.EPSILON*Math.max(1,Math.abs(c),Math.abs(P))&&Math.abs(f-O)<=n.EPSILON*Math.max(1,Math.abs(f),Math.abs(O))&&Math.abs(s-p)<=n.EPSILON*Math.max(1,Math.abs(s),Math.abs(p))&&Math.abs(M-d)<=n.EPSILON*Math.max(1,Math.abs(M),Math.abs(d))},r.sub=r.mul=void 0;var n=function(t){if(t&&t.__esModule)return t;var a={};if(null!=t)for(var r in t)if(Object.prototype.hasOwnProperty.call(t,r)){var n=Object.defineProperty&&Object.getOwnPropertyDescriptor?Object.getOwnPropertyDescriptor(t,r):{};n.get||n.set?Object.defineProperty(a,r,n):a[r]=t[r]}return a.default=t,a}(t("c6b4e451bc"));function u(t,a,r){var n=a[0],u=a[1],e=a[2],o=a[3],i=a[4],c=a[5],f=a[6],s=a[7],M=a[8],h=r[0],b=r[1],l=r[2],m=r[3],v=r[4],P=r[5],O=r[6],p=r[7],d=r[8];return t[0]=h*n+b*o+l*f,t[1]=h*u+b*i+l*s,t[2]=h*e+b*c+l*M,t[3]=m*n+v*o+P*f,t[4]=m*u+v*i+P*s,t[5]=m*e+v*c+P*M,t[6]=O*n+p*o+d*f,t[7]=O*u+p*i+d*s,t[8]=O*e+p*c+d*M,t}function e(t,a,r){return t[0]=a[0]-r[0],t[1]=a[1]-r[1],t[2]=a[2]-r[2],t[3]=a[3]-r[3],t[4]=a[4]-r[4],t[5]=a[5]-r[5],t[6]=a[6]-r[6],t[7]=a[7]-r[7],t[8]=a[8]-r[8],t}var o=u;r.mul=o;var i=e;r.sub=i},
"04eeb2ead8": function _(t,a,r){r.create=function(){var t=new n.ARRAY_TYPE(16);n.ARRAY_TYPE!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=0,t[12]=0,t[13]=0,t[14]=0);return t[0]=1,t[5]=1,t[10]=1,t[15]=1,t},r.clone=function(t){var a=new n.ARRAY_TYPE(16);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a[4]=t[4],a[5]=t[5],a[6]=t[6],a[7]=t[7],a[8]=t[8],a[9]=t[9],a[10]=t[10],a[11]=t[11],a[12]=t[12],a[13]=t[13],a[14]=t[14],a[15]=t[15],a},r.copy=function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t[8]=a[8],t[9]=a[9],t[10]=a[10],t[11]=a[11],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15],t},r.fromValues=function(t,a,r,e,o,u,h,M,s,i,c,f,b,l,v,m){var P=new n.ARRAY_TYPE(16);return P[0]=t,P[1]=a,P[2]=r,P[3]=e,P[4]=o,P[5]=u,P[6]=h,P[7]=M,P[8]=s,P[9]=i,P[10]=c,P[11]=f,P[12]=b,P[13]=l,P[14]=v,P[15]=m,P},r.set=function(t,a,r,n,e,o,u,h,M,s,i,c,f,b,l,v,m){return t[0]=a,t[1]=r,t[2]=n,t[3]=e,t[4]=o,t[5]=u,t[6]=h,t[7]=M,t[8]=s,t[9]=i,t[10]=c,t[11]=f,t[12]=b,t[13]=l,t[14]=v,t[15]=m,t},r.identity=e,r.transpose=function(t,a){if(t===a){var r=a[1],n=a[2],e=a[3],o=a[6],u=a[7],h=a[11];t[1]=a[4],t[2]=a[8],t[3]=a[12],t[4]=r,t[6]=a[9],t[7]=a[13],t[8]=n,t[9]=o,t[11]=a[14],t[12]=e,t[13]=u,t[14]=h}else t[0]=a[0],t[1]=a[4],t[2]=a[8],t[3]=a[12],t[4]=a[1],t[5]=a[5],t[6]=a[9],t[7]=a[13],t[8]=a[2],t[9]=a[6],t[10]=a[10],t[11]=a[14],t[12]=a[3],t[13]=a[7],t[14]=a[11],t[15]=a[15];return t},r.invert=function(t,a){var r=a[0],n=a[1],e=a[2],o=a[3],u=a[4],h=a[5],M=a[6],s=a[7],i=a[8],c=a[9],f=a[10],b=a[11],l=a[12],v=a[13],m=a[14],P=a[15],O=r*h-n*u,p=r*M-e*u,E=r*s-o*u,S=n*M-e*h,I=n*s-o*h,y=e*s-o*M,L=i*v-c*l,N=i*m-f*l,R=i*P-b*l,x=c*m-f*v,A=c*P-b*v,d=f*P-b*m,g=O*d-p*A+E*x+S*R-I*N+y*L;if(!g)return null;return g=1/g,t[0]=(h*d-M*A+s*x)*g,t[1]=(e*A-n*d-o*x)*g,t[2]=(v*y-m*I+P*S)*g,t[3]=(f*I-c*y-b*S)*g,t[4]=(M*R-u*d-s*N)*g,t[5]=(r*d-e*R+o*N)*g,t[6]=(m*E-l*y-P*p)*g,t[7]=(i*y-f*E+b*p)*g,t[8]=(u*A-h*R+s*L)*g,t[9]=(n*R-r*A-o*L)*g,t[10]=(l*I-v*E+P*O)*g,t[11]=(c*E-i*I-b*O)*g,t[12]=(h*N-u*x-M*L)*g,t[13]=(r*x-n*N+e*L)*g,t[14]=(v*p-l*S-m*O)*g,t[15]=(i*S-c*p+f*O)*g,t},r.adjoint=function(t,a){var r=a[0],n=a[1],e=a[2],o=a[3],u=a[4],h=a[5],M=a[6],s=a[7],i=a[8],c=a[9],f=a[10],b=a[11],l=a[12],v=a[13],m=a[14],P=a[15];return t[0]=h*(f*P-b*m)-c*(M*P-s*m)+v*(M*b-s*f),t[1]=-(n*(f*P-b*m)-c*(e*P-o*m)+v*(e*b-o*f)),t[2]=n*(M*P-s*m)-h*(e*P-o*m)+v*(e*s-o*M),t[3]=-(n*(M*b-s*f)-h*(e*b-o*f)+c*(e*s-o*M)),t[4]=-(u*(f*P-b*m)-i*(M*P-s*m)+l*(M*b-s*f)),t[5]=r*(f*P-b*m)-i*(e*P-o*m)+l*(e*b-o*f),t[6]=-(r*(M*P-s*m)-u*(e*P-o*m)+l*(e*s-o*M)),t[7]=r*(M*b-s*f)-u*(e*b-o*f)+i*(e*s-o*M),t[8]=u*(c*P-b*v)-i*(h*P-s*v)+l*(h*b-s*c),t[9]=-(r*(c*P-b*v)-i*(n*P-o*v)+l*(n*b-o*c)),t[10]=r*(h*P-s*v)-u*(n*P-o*v)+l*(n*s-o*h),t[11]=-(r*(h*b-s*c)-u*(n*b-o*c)+i*(n*s-o*h)),t[12]=-(u*(c*m-f*v)-i*(h*m-M*v)+l*(h*f-M*c)),t[13]=r*(c*m-f*v)-i*(n*m-e*v)+l*(n*f-e*c),t[14]=-(r*(h*m-M*v)-u*(n*m-e*v)+l*(n*M-e*h)),t[15]=r*(h*f-M*c)-u*(n*f-e*c)+i*(n*M-e*h),t},r.determinant=function(t){var a=t[0],r=t[1],n=t[2],e=t[3],o=t[4],u=t[5],h=t[6],M=t[7],s=t[8],i=t[9],c=t[10],f=t[11],b=t[12],l=t[13],v=t[14],m=t[15];return(a*u-r*o)*(c*m-f*v)-(a*h-n*o)*(i*m-f*l)+(a*M-e*o)*(i*v-c*l)+(r*h-n*u)*(s*m-f*b)-(r*M-e*u)*(s*v-c*b)+(n*M-e*h)*(s*l-i*b)},r.multiply=o,r.translate=function(t,a,r){var n,e,o,u,h,M,s,i,c,f,b,l,v=r[0],m=r[1],P=r[2];a===t?(t[12]=a[0]*v+a[4]*m+a[8]*P+a[12],t[13]=a[1]*v+a[5]*m+a[9]*P+a[13],t[14]=a[2]*v+a[6]*m+a[10]*P+a[14],t[15]=a[3]*v+a[7]*m+a[11]*P+a[15]):(n=a[0],e=a[1],o=a[2],u=a[3],h=a[4],M=a[5],s=a[6],i=a[7],c=a[8],f=a[9],b=a[10],l=a[11],t[0]=n,t[1]=e,t[2]=o,t[3]=u,t[4]=h,t[5]=M,t[6]=s,t[7]=i,t[8]=c,t[9]=f,t[10]=b,t[11]=l,t[12]=n*v+h*m+c*P+a[12],t[13]=e*v+M*m+f*P+a[13],t[14]=o*v+s*m+b*P+a[14],t[15]=u*v+i*m+l*P+a[15]);return t},r.scale=function(t,a,r){var n=r[0],e=r[1],o=r[2];return t[0]=a[0]*n,t[1]=a[1]*n,t[2]=a[2]*n,t[3]=a[3]*n,t[4]=a[4]*e,t[5]=a[5]*e,t[6]=a[6]*e,t[7]=a[7]*e,t[8]=a[8]*o,t[9]=a[9]*o,t[10]=a[10]*o,t[11]=a[11]*o,t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15],t},r.rotate=function(t,a,r,e){var o,u,h,M,s,i,c,f,b,l,v,m,P,O,p,E,S,I,y,L,N,R,x,A,d=e[0],g=e[1],Y=e[2],T=Math.hypot(d,g,Y);if(T<n.EPSILON)return null;d*=T=1/T,g*=T,Y*=T,o=Math.sin(r),u=Math.cos(r),h=1-u,M=a[0],s=a[1],i=a[2],c=a[3],f=a[4],b=a[5],l=a[6],v=a[7],m=a[8],P=a[9],O=a[10],p=a[11],E=d*d*h+u,S=g*d*h+Y*o,I=Y*d*h-g*o,y=d*g*h-Y*o,L=g*g*h+u,N=Y*g*h+d*o,R=d*Y*h+g*o,x=g*Y*h-d*o,A=Y*Y*h+u,t[0]=M*E+f*S+m*I,t[1]=s*E+b*S+P*I,t[2]=i*E+l*S+O*I,t[3]=c*E+v*S+p*I,t[4]=M*y+f*L+m*N,t[5]=s*y+b*L+P*N,t[6]=i*y+l*L+O*N,t[7]=c*y+v*L+p*N,t[8]=M*R+f*x+m*A,t[9]=s*R+b*x+P*A,t[10]=i*R+l*x+O*A,t[11]=c*R+v*x+p*A,a!==t&&(t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]);return t},r.rotateX=function(t,a,r){var n=Math.sin(r),e=Math.cos(r),o=a[4],u=a[5],h=a[6],M=a[7],s=a[8],i=a[9],c=a[10],f=a[11];a!==t&&(t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]);return t[4]=o*e+s*n,t[5]=u*e+i*n,t[6]=h*e+c*n,t[7]=M*e+f*n,t[8]=s*e-o*n,t[9]=i*e-u*n,t[10]=c*e-h*n,t[11]=f*e-M*n,t},r.rotateY=function(t,a,r){var n=Math.sin(r),e=Math.cos(r),o=a[0],u=a[1],h=a[2],M=a[3],s=a[8],i=a[9],c=a[10],f=a[11];a!==t&&(t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]);return t[0]=o*e-s*n,t[1]=u*e-i*n,t[2]=h*e-c*n,t[3]=M*e-f*n,t[8]=o*n+s*e,t[9]=u*n+i*e,t[10]=h*n+c*e,t[11]=M*n+f*e,t},r.rotateZ=function(t,a,r){var n=Math.sin(r),e=Math.cos(r),o=a[0],u=a[1],h=a[2],M=a[3],s=a[4],i=a[5],c=a[6],f=a[7];a!==t&&(t[8]=a[8],t[9]=a[9],t[10]=a[10],t[11]=a[11],t[12]=a[12],t[13]=a[13],t[14]=a[14],t[15]=a[15]);return t[0]=o*e+s*n,t[1]=u*e+i*n,t[2]=h*e+c*n,t[3]=M*e+f*n,t[4]=s*e-o*n,t[5]=i*e-u*n,t[6]=c*e-h*n,t[7]=f*e-M*n,t},r.fromTranslation=function(t,a){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=a[0],t[13]=a[1],t[14]=a[2],t[15]=1,t},r.fromScaling=function(t,a){return t[0]=a[0],t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=a[1],t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=a[2],t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},r.fromRotation=function(t,a,r){var e,o,u,h=r[0],M=r[1],s=r[2],i=Math.hypot(h,M,s);if(i<n.EPSILON)return null;return h*=i=1/i,M*=i,s*=i,e=Math.sin(a),o=Math.cos(a),u=1-o,t[0]=h*h*u+o,t[1]=M*h*u+s*e,t[2]=s*h*u-M*e,t[3]=0,t[4]=h*M*u-s*e,t[5]=M*M*u+o,t[6]=s*M*u+h*e,t[7]=0,t[8]=h*s*u+M*e,t[9]=M*s*u-h*e,t[10]=s*s*u+o,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},r.fromXRotation=function(t,a){var r=Math.sin(a),n=Math.cos(a);return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=n,t[6]=r,t[7]=0,t[8]=0,t[9]=-r,t[10]=n,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},r.fromYRotation=function(t,a){var r=Math.sin(a),n=Math.cos(a);return t[0]=n,t[1]=0,t[2]=-r,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=r,t[9]=0,t[10]=n,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},r.fromZRotation=function(t,a){var r=Math.sin(a),n=Math.cos(a);return t[0]=n,t[1]=r,t[2]=0,t[3]=0,t[4]=-r,t[5]=n,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},r.fromRotationTranslation=u,r.fromQuat2=function(t,a){var r=new n.ARRAY_TYPE(3),e=-a[0],o=-a[1],h=-a[2],M=a[3],s=a[4],i=a[5],c=a[6],f=a[7],b=e*e+o*o+h*h+M*M;b>0?(r[0]=2*(s*M+f*e+i*h-c*o)/b,r[1]=2*(i*M+f*o+c*e-s*h)/b,r[2]=2*(c*M+f*h+s*o-i*e)/b):(r[0]=2*(s*M+f*e+i*h-c*o),r[1]=2*(i*M+f*o+c*e-s*h),r[2]=2*(c*M+f*h+s*o-i*e));return u(t,a,r),t},r.getTranslation=function(t,a){return t[0]=a[12],t[1]=a[13],t[2]=a[14],t},r.getScaling=h,r.getRotation=function(t,a){var r=new n.ARRAY_TYPE(3);h(r,a);var e=1/r[0],o=1/r[1],u=1/r[2],M=a[0]*e,s=a[1]*o,i=a[2]*u,c=a[4]*e,f=a[5]*o,b=a[6]*u,l=a[8]*e,v=a[9]*o,m=a[10]*u,P=M+f+m,O=0;P>0?(O=2*Math.sqrt(P+1),t[3]=.25*O,t[0]=(b-v)/O,t[1]=(l-i)/O,t[2]=(s-c)/O):M>f&&M>m?(O=2*Math.sqrt(1+M-f-m),t[3]=(b-v)/O,t[0]=.25*O,t[1]=(s+c)/O,t[2]=(l+i)/O):f>m?(O=2*Math.sqrt(1+f-M-m),t[3]=(l-i)/O,t[0]=(s+c)/O,t[1]=.25*O,t[2]=(b+v)/O):(O=2*Math.sqrt(1+m-M-f),t[3]=(s-c)/O,t[0]=(l+i)/O,t[1]=(b+v)/O,t[2]=.25*O);return t},r.fromRotationTranslationScale=function(t,a,r,n){var e=a[0],o=a[1],u=a[2],h=a[3],M=e+e,s=o+o,i=u+u,c=e*M,f=e*s,b=e*i,l=o*s,v=o*i,m=u*i,P=h*M,O=h*s,p=h*i,E=n[0],S=n[1],I=n[2];return t[0]=(1-(l+m))*E,t[1]=(f+p)*E,t[2]=(b-O)*E,t[3]=0,t[4]=(f-p)*S,t[5]=(1-(c+m))*S,t[6]=(v+P)*S,t[7]=0,t[8]=(b+O)*I,t[9]=(v-P)*I,t[10]=(1-(c+l))*I,t[11]=0,t[12]=r[0],t[13]=r[1],t[14]=r[2],t[15]=1,t},r.fromRotationTranslationScaleOrigin=function(t,a,r,n,e){var o=a[0],u=a[1],h=a[2],M=a[3],s=o+o,i=u+u,c=h+h,f=o*s,b=o*i,l=o*c,v=u*i,m=u*c,P=h*c,O=M*s,p=M*i,E=M*c,S=n[0],I=n[1],y=n[2],L=e[0],N=e[1],R=e[2],x=(1-(v+P))*S,A=(b+E)*S,d=(l-p)*S,g=(b-E)*I,Y=(1-(f+P))*I,T=(m+O)*I,w=(l+p)*y,_=(m-O)*y,q=(1-(f+v))*y;return t[0]=x,t[1]=A,t[2]=d,t[3]=0,t[4]=g,t[5]=Y,t[6]=T,t[7]=0,t[8]=w,t[9]=_,t[10]=q,t[11]=0,t[12]=r[0]+L-(x*L+g*N+w*R),t[13]=r[1]+N-(A*L+Y*N+_*R),t[14]=r[2]+R-(d*L+T*N+q*R),t[15]=1,t},r.fromQuat=function(t,a){var r=a[0],n=a[1],e=a[2],o=a[3],u=r+r,h=n+n,M=e+e,s=r*u,i=n*u,c=n*h,f=e*u,b=e*h,l=e*M,v=o*u,m=o*h,P=o*M;return t[0]=1-c-l,t[1]=i+P,t[2]=f-m,t[3]=0,t[4]=i-P,t[5]=1-s-l,t[6]=b+v,t[7]=0,t[8]=f+m,t[9]=b-v,t[10]=1-s-c,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t},r.frustum=function(t,a,r,n,e,o,u){var h=1/(r-a),M=1/(e-n),s=1/(o-u);return t[0]=2*o*h,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=2*o*M,t[6]=0,t[7]=0,t[8]=(r+a)*h,t[9]=(e+n)*M,t[10]=(u+o)*s,t[11]=-1,t[12]=0,t[13]=0,t[14]=u*o*2*s,t[15]=0,t},r.perspective=function(t,a,r,n,e){var o,u=1/Math.tan(a/2);t[0]=u/r,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=u,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=-1,t[12]=0,t[13]=0,t[15]=0,null!=e&&e!==1/0?(o=1/(n-e),t[10]=(e+n)*o,t[14]=2*e*n*o):(t[10]=-1,t[14]=-2*n);return t},r.perspectiveFromFieldOfView=function(t,a,r,n){var e=Math.tan(a.upDegrees*Math.PI/180),o=Math.tan(a.downDegrees*Math.PI/180),u=Math.tan(a.leftDegrees*Math.PI/180),h=Math.tan(a.rightDegrees*Math.PI/180),M=2/(u+h),s=2/(e+o);return t[0]=M,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=s,t[6]=0,t[7]=0,t[8]=-(u-h)*M*.5,t[9]=(e-o)*s*.5,t[10]=n/(r-n),t[11]=-1,t[12]=0,t[13]=0,t[14]=n*r/(r-n),t[15]=0,t},r.ortho=function(t,a,r,n,e,o,u){var h=1/(a-r),M=1/(n-e),s=1/(o-u);return t[0]=-2*h,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=-2*M,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=2*s,t[11]=0,t[12]=(a+r)*h,t[13]=(e+n)*M,t[14]=(u+o)*s,t[15]=1,t},r.lookAt=function(t,a,r,o){var u,h,M,s,i,c,f,b,l,v,m=a[0],P=a[1],O=a[2],p=o[0],E=o[1],S=o[2],I=r[0],y=r[1],L=r[2];if(Math.abs(m-I)<n.EPSILON&&Math.abs(P-y)<n.EPSILON&&Math.abs(O-L)<n.EPSILON)return e(t);f=m-I,b=P-y,l=O-L,v=1/Math.hypot(f,b,l),u=E*(l*=v)-S*(b*=v),h=S*(f*=v)-p*l,M=p*b-E*f,(v=Math.hypot(u,h,M))?(u*=v=1/v,h*=v,M*=v):(u=0,h=0,M=0);s=b*M-l*h,i=l*u-f*M,c=f*h-b*u,(v=Math.hypot(s,i,c))?(s*=v=1/v,i*=v,c*=v):(s=0,i=0,c=0);return t[0]=u,t[1]=s,t[2]=f,t[3]=0,t[4]=h,t[5]=i,t[6]=b,t[7]=0,t[8]=M,t[9]=c,t[10]=l,t[11]=0,t[12]=-(u*m+h*P+M*O),t[13]=-(s*m+i*P+c*O),t[14]=-(f*m+b*P+l*O),t[15]=1,t},r.targetTo=function(t,a,r,n){var e=a[0],o=a[1],u=a[2],h=n[0],M=n[1],s=n[2],i=e-r[0],c=o-r[1],f=u-r[2],b=i*i+c*c+f*f;b>0&&(b=1/Math.sqrt(b),i*=b,c*=b,f*=b);var l=M*f-s*c,v=s*i-h*f,m=h*c-M*i;(b=l*l+v*v+m*m)>0&&(b=1/Math.sqrt(b),l*=b,v*=b,m*=b);return t[0]=l,t[1]=v,t[2]=m,t[3]=0,t[4]=c*m-f*v,t[5]=f*l-i*m,t[6]=i*v-c*l,t[7]=0,t[8]=i,t[9]=c,t[10]=f,t[11]=0,t[12]=e,t[13]=o,t[14]=u,t[15]=1,t},r.str=function(t){return"mat4("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+", "+t[8]+", "+t[9]+", "+t[10]+", "+t[11]+", "+t[12]+", "+t[13]+", "+t[14]+", "+t[15]+")"},r.frob=function(t){return Math.hypot(t[0],t[1],t[3],t[4],t[5],t[6],t[7],t[8],t[9],t[10],t[11],t[12],t[13],t[14],t[15])},r.add=function(t,a,r){return t[0]=a[0]+r[0],t[1]=a[1]+r[1],t[2]=a[2]+r[2],t[3]=a[3]+r[3],t[4]=a[4]+r[4],t[5]=a[5]+r[5],t[6]=a[6]+r[6],t[7]=a[7]+r[7],t[8]=a[8]+r[8],t[9]=a[9]+r[9],t[10]=a[10]+r[10],t[11]=a[11]+r[11],t[12]=a[12]+r[12],t[13]=a[13]+r[13],t[14]=a[14]+r[14],t[15]=a[15]+r[15],t},r.subtract=M,r.multiplyScalar=function(t,a,r){return t[0]=a[0]*r,t[1]=a[1]*r,t[2]=a[2]*r,t[3]=a[3]*r,t[4]=a[4]*r,t[5]=a[5]*r,t[6]=a[6]*r,t[7]=a[7]*r,t[8]=a[8]*r,t[9]=a[9]*r,t[10]=a[10]*r,t[11]=a[11]*r,t[12]=a[12]*r,t[13]=a[13]*r,t[14]=a[14]*r,t[15]=a[15]*r,t},r.multiplyScalarAndAdd=function(t,a,r,n){return t[0]=a[0]+r[0]*n,t[1]=a[1]+r[1]*n,t[2]=a[2]+r[2]*n,t[3]=a[3]+r[3]*n,t[4]=a[4]+r[4]*n,t[5]=a[5]+r[5]*n,t[6]=a[6]+r[6]*n,t[7]=a[7]+r[7]*n,t[8]=a[8]+r[8]*n,t[9]=a[9]+r[9]*n,t[10]=a[10]+r[10]*n,t[11]=a[11]+r[11]*n,t[12]=a[12]+r[12]*n,t[13]=a[13]+r[13]*n,t[14]=a[14]+r[14]*n,t[15]=a[15]+r[15]*n,t},r.exactEquals=function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]&&t[4]===a[4]&&t[5]===a[5]&&t[6]===a[6]&&t[7]===a[7]&&t[8]===a[8]&&t[9]===a[9]&&t[10]===a[10]&&t[11]===a[11]&&t[12]===a[12]&&t[13]===a[13]&&t[14]===a[14]&&t[15]===a[15]},r.equals=function(t,a){var r=t[0],e=t[1],o=t[2],u=t[3],h=t[4],M=t[5],s=t[6],i=t[7],c=t[8],f=t[9],b=t[10],l=t[11],v=t[12],m=t[13],P=t[14],O=t[15],p=a[0],E=a[1],S=a[2],I=a[3],y=a[4],L=a[5],N=a[6],R=a[7],x=a[8],A=a[9],d=a[10],g=a[11],Y=a[12],T=a[13],w=a[14],_=a[15];return Math.abs(r-p)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(p))&&Math.abs(e-E)<=n.EPSILON*Math.max(1,Math.abs(e),Math.abs(E))&&Math.abs(o-S)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(S))&&Math.abs(u-I)<=n.EPSILON*Math.max(1,Math.abs(u),Math.abs(I))&&Math.abs(h-y)<=n.EPSILON*Math.max(1,Math.abs(h),Math.abs(y))&&Math.abs(M-L)<=n.EPSILON*Math.max(1,Math.abs(M),Math.abs(L))&&Math.abs(s-N)<=n.EPSILON*Math.max(1,Math.abs(s),Math.abs(N))&&Math.abs(i-R)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(R))&&Math.abs(c-x)<=n.EPSILON*Math.max(1,Math.abs(c),Math.abs(x))&&Math.abs(f-A)<=n.EPSILON*Math.max(1,Math.abs(f),Math.abs(A))&&Math.abs(b-d)<=n.EPSILON*Math.max(1,Math.abs(b),Math.abs(d))&&Math.abs(l-g)<=n.EPSILON*Math.max(1,Math.abs(l),Math.abs(g))&&Math.abs(v-Y)<=n.EPSILON*Math.max(1,Math.abs(v),Math.abs(Y))&&Math.abs(m-T)<=n.EPSILON*Math.max(1,Math.abs(m),Math.abs(T))&&Math.abs(P-w)<=n.EPSILON*Math.max(1,Math.abs(P),Math.abs(w))&&Math.abs(O-_)<=n.EPSILON*Math.max(1,Math.abs(O),Math.abs(_))},r.sub=r.mul=void 0;var n=function(t){if(t&&t.__esModule)return t;var a={};if(null!=t)for(var r in t)if(Object.prototype.hasOwnProperty.call(t,r)){var n=Object.defineProperty&&Object.getOwnPropertyDescriptor?Object.getOwnPropertyDescriptor(t,r):{};n.get||n.set?Object.defineProperty(a,r,n):a[r]=t[r]}return a.default=t,a}(t("c6b4e451bc"));function e(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}function o(t,a,r){var n=a[0],e=a[1],o=a[2],u=a[3],h=a[4],M=a[5],s=a[6],i=a[7],c=a[8],f=a[9],b=a[10],l=a[11],v=a[12],m=a[13],P=a[14],O=a[15],p=r[0],E=r[1],S=r[2],I=r[3];return t[0]=p*n+E*h+S*c+I*v,t[1]=p*e+E*M+S*f+I*m,t[2]=p*o+E*s+S*b+I*P,t[3]=p*u+E*i+S*l+I*O,p=r[4],E=r[5],S=r[6],I=r[7],t[4]=p*n+E*h+S*c+I*v,t[5]=p*e+E*M+S*f+I*m,t[6]=p*o+E*s+S*b+I*P,t[7]=p*u+E*i+S*l+I*O,p=r[8],E=r[9],S=r[10],I=r[11],t[8]=p*n+E*h+S*c+I*v,t[9]=p*e+E*M+S*f+I*m,t[10]=p*o+E*s+S*b+I*P,t[11]=p*u+E*i+S*l+I*O,p=r[12],E=r[13],S=r[14],I=r[15],t[12]=p*n+E*h+S*c+I*v,t[13]=p*e+E*M+S*f+I*m,t[14]=p*o+E*s+S*b+I*P,t[15]=p*u+E*i+S*l+I*O,t}function u(t,a,r){var n=a[0],e=a[1],o=a[2],u=a[3],h=n+n,M=e+e,s=o+o,i=n*h,c=n*M,f=n*s,b=e*M,l=e*s,v=o*s,m=u*h,P=u*M,O=u*s;return t[0]=1-(b+v),t[1]=c+O,t[2]=f-P,t[3]=0,t[4]=c-O,t[5]=1-(i+v),t[6]=l+m,t[7]=0,t[8]=f+P,t[9]=l-m,t[10]=1-(i+b),t[11]=0,t[12]=r[0],t[13]=r[1],t[14]=r[2],t[15]=1,t}function h(t,a){var r=a[0],n=a[1],e=a[2],o=a[4],u=a[5],h=a[6],M=a[8],s=a[9],i=a[10];return t[0]=Math.hypot(r,n,e),t[1]=Math.hypot(o,u,h),t[2]=Math.hypot(M,s,i),t}function M(t,a,r){return t[0]=a[0]-r[0],t[1]=a[1]-r[1],t[2]=a[2]-r[2],t[3]=a[3]-r[3],t[4]=a[4]-r[4],t[5]=a[5]-r[5],t[6]=a[6]-r[6],t[7]=a[7]-r[7],t[8]=a[8]-r[8],t[9]=a[9]-r[9],t[10]=a[10]-r[10],t[11]=a[11]-r[11],t[12]=a[12]-r[12],t[13]=a[13]-r[13],t[14]=a[14]-r[14],t[15]=a[15]-r[15],t}var s=o;r.mul=s;var i=M;r.sub=i},
"fb0a790f46": function _(t,r,a){a.create=c,a.identity=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t},a.setAxisAngle=i,a.getAxisAngle=function(t,r){var a=2*Math.acos(r[3]),e=Math.sin(a/2);e>n.EPSILON?(t[0]=r[0]/e,t[1]=r[1]/e,t[2]=r[2]/e):(t[0]=1,t[1]=0,t[2]=0);return a},a.getAngle=function(t,r){var a=O(t,r);return Math.acos(2*a*a-1)},a.multiply=l,a.rotateX=function(t,r,a){a*=.5;var n=r[0],e=r[1],o=r[2],s=r[3],u=Math.sin(a),c=Math.cos(a);return t[0]=n*c+s*u,t[1]=e*c+o*u,t[2]=o*c-e*u,t[3]=s*c-n*u,t},a.rotateY=function(t,r,a){a*=.5;var n=r[0],e=r[1],o=r[2],s=r[3],u=Math.sin(a),c=Math.cos(a);return t[0]=n*c-o*u,t[1]=e*c+s*u,t[2]=o*c+n*u,t[3]=s*c-e*u,t},a.rotateZ=function(t,r,a){a*=.5;var n=r[0],e=r[1],o=r[2],s=r[3],u=Math.sin(a),c=Math.cos(a);return t[0]=n*c+e*u,t[1]=e*c-n*u,t[2]=o*c+s*u,t[3]=s*c-o*u,t},a.calculateW=function(t,r){var a=r[0],n=r[1],e=r[2];return t[0]=a,t[1]=n,t[2]=e,t[3]=Math.sqrt(Math.abs(1-a*a-n*n-e*e)),t},a.exp=h,a.ln=M,a.pow=function(t,r,a){return M(t,r),P(t,t,a),h(t,t),t},a.slerp=v,a.random=function(t){var r=n.RANDOM(),a=n.RANDOM(),e=n.RANDOM(),o=Math.sqrt(1-r),s=Math.sqrt(r);return t[0]=o*Math.sin(2*Math.PI*a),t[1]=o*Math.cos(2*Math.PI*a),t[2]=s*Math.sin(2*Math.PI*e),t[3]=s*Math.cos(2*Math.PI*e),t},a.invert=function(t,r){var a=r[0],n=r[1],e=r[2],o=r[3],s=a*a+n*n+e*e+o*o,u=s?1/s:0;return t[0]=-a*u,t[1]=-n*u,t[2]=-e*u,t[3]=o*u,t},a.conjugate=function(t,r){return t[0]=-r[0],t[1]=-r[1],t[2]=-r[2],t[3]=r[3],t},a.fromMat3=f,a.fromEuler=function(t,r,a,n){var e=.5*Math.PI/180;r*=e,a*=e,n*=e;var o=Math.sin(r),s=Math.cos(r),u=Math.sin(a),c=Math.cos(a),i=Math.sin(n),l=Math.cos(n);return t[0]=o*c*l-s*u*i,t[1]=s*u*l+o*c*i,t[2]=s*c*i-o*u*l,t[3]=s*c*l+o*u*i,t},a.str=function(t){return"quat("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},a.setAxes=a.sqlerp=a.rotationTo=a.equals=a.exactEquals=a.normalize=a.sqrLen=a.squaredLength=a.len=a.length=a.lerp=a.dot=a.scale=a.mul=a.add=a.set=a.copy=a.fromValues=a.clone=void 0;var n=u(t("c6b4e451bc")),e=u(t("4b4956d3f5")),o=u(t("9aff2264cd")),s=u(t("2c797465df"));function u(t){if(t&&t.__esModule)return t;var r={};if(null!=t)for(var a in t)if(Object.prototype.hasOwnProperty.call(t,a)){var n=Object.defineProperty&&Object.getOwnPropertyDescriptor?Object.getOwnPropertyDescriptor(t,a):{};n.get||n.set?Object.defineProperty(r,a,n):r[a]=t[a]}return r.default=t,r}function c(){var t=new n.ARRAY_TYPE(4);return n.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t[3]=1,t}function i(t,r,a){a*=.5;var n=Math.sin(a);return t[0]=n*r[0],t[1]=n*r[1],t[2]=n*r[2],t[3]=Math.cos(a),t}function l(t,r,a){var n=r[0],e=r[1],o=r[2],s=r[3],u=a[0],c=a[1],i=a[2],l=a[3];return t[0]=n*l+s*u+e*i-o*c,t[1]=e*l+s*c+o*u-n*i,t[2]=o*l+s*i+n*c-e*u,t[3]=s*l-n*u-e*c-o*i,t}function h(t,r){var a=r[0],n=r[1],e=r[2],o=r[3],s=Math.sqrt(a*a+n*n+e*e),u=Math.exp(o),c=s>0?u*Math.sin(s)/s:0;return t[0]=a*c,t[1]=n*c,t[2]=e*c,t[3]=u*Math.cos(s),t}function M(t,r){var a=r[0],n=r[1],e=r[2],o=r[3],s=Math.sqrt(a*a+n*n+e*e),u=s>0?Math.atan2(s,o)/s:0;return t[0]=a*u,t[1]=n*u,t[2]=e*u,t[3]=.5*Math.log(a*a+n*n+e*e+o*o),t}function v(t,r,a,e){var o,s,u,c,i,l=r[0],h=r[1],M=r[2],v=r[3],f=a[0],d=a[1],p=a[2],q=a[3];return(s=l*f+h*d+M*p+v*q)<0&&(s=-s,f=-f,d=-d,p=-p,q=-q),1-s>n.EPSILON?(o=Math.acos(s),u=Math.sin(o),c=Math.sin((1-e)*o)/u,i=Math.sin(e*o)/u):(c=1-e,i=e),t[0]=c*l+i*f,t[1]=c*h+i*d,t[2]=c*M+i*p,t[3]=c*v+i*q,t}function f(t,r){var a,n=r[0]+r[4]+r[8];if(n>0)a=Math.sqrt(n+1),t[3]=.5*a,a=.5/a,t[0]=(r[5]-r[7])*a,t[1]=(r[6]-r[2])*a,t[2]=(r[1]-r[3])*a;else{var e=0;r[4]>r[0]&&(e=1),r[8]>r[3*e+e]&&(e=2);var o=(e+1)%3,s=(e+2)%3;a=Math.sqrt(r[3*e+e]-r[3*o+o]-r[3*s+s]+1),t[e]=.5*a,a=.5/a,t[3]=(r[3*o+s]-r[3*s+o])*a,t[o]=(r[3*o+e]+r[3*e+o])*a,t[s]=(r[3*s+e]+r[3*e+s])*a}return t}var d=s.clone;a.clone=d;var p=s.fromValues;a.fromValues=p;var q=s.copy;a.copy=q;var g=s.set;a.set=g;var m=s.add;a.add=m;var A=l;a.mul=A;var P=s.scale;a.scale=P;var O=s.dot;a.dot=O;var y=s.lerp;a.lerp=y;var b=s.length;a.length=b;var x=b;a.len=x;var E=s.squaredLength;a.squaredLength=E;var I=E;a.sqrLen=I;var L=s.normalize;a.normalize=L;var R=s.exactEquals;a.exactEquals=R;var j=s.equals;a.equals=j;var w,D,N,V=(w=o.create(),D=o.fromValues(1,0,0),N=o.fromValues(0,1,0),function(t,r,a){var n=o.dot(r,a);return n<-.999999?(o.cross(w,D,r),o.len(w)<1e-6&&o.cross(w,N,r),o.normalize(w,w),i(t,w,Math.PI),t):n>.999999?(t[0]=0,t[1]=0,t[2]=0,t[3]=1,t):(o.cross(w,r,a),t[0]=w[0],t[1]=w[1],t[2]=w[2],t[3]=1+n,L(t,t))});a.rotationTo=V;var Y,_,z=(Y=c(),_=c(),function(t,r,a,n,e,o){return v(Y,r,e,o),v(_,a,n,o),v(t,Y,_,2*o*(1-o)),t});a.sqlerp=z;var T,S=(T=e.create(),function(t,r,a,n){return T[0]=a[0],T[3]=a[1],T[6]=a[2],T[1]=n[0],T[4]=n[1],T[7]=n[2],T[2]=-r[0],T[5]=-r[1],T[8]=-r[2],L(t,f(t,T))});a.setAxes=S},
"9aff2264cd": function _(t,r,n){n.create=e,n.clone=function(t){var r=new a.ARRAY_TYPE(3);return r[0]=t[0],r[1]=t[1],r[2]=t[2],r},n.length=u,n.fromValues=o,n.copy=function(t,r){return t[0]=r[0],t[1]=r[1],t[2]=r[2],t},n.set=function(t,r,n,a){return t[0]=r,t[1]=n,t[2]=a,t},n.add=function(t,r,n){return t[0]=r[0]+n[0],t[1]=r[1]+n[1],t[2]=r[2]+n[2],t},n.subtract=i,n.multiply=c,n.divide=f,n.ceil=function(t,r){return t[0]=Math.ceil(r[0]),t[1]=Math.ceil(r[1]),t[2]=Math.ceil(r[2]),t},n.floor=function(t,r){return t[0]=Math.floor(r[0]),t[1]=Math.floor(r[1]),t[2]=Math.floor(r[2]),t},n.min=function(t,r,n){return t[0]=Math.min(r[0],n[0]),t[1]=Math.min(r[1],n[1]),t[2]=Math.min(r[2],n[2]),t},n.max=function(t,r,n){return t[0]=Math.max(r[0],n[0]),t[1]=Math.max(r[1],n[1]),t[2]=Math.max(r[2],n[2]),t},n.round=function(t,r){return t[0]=Math.round(r[0]),t[1]=Math.round(r[1]),t[2]=Math.round(r[2]),t},n.scale=function(t,r,n){return t[0]=r[0]*n,t[1]=r[1]*n,t[2]=r[2]*n,t},n.scaleAndAdd=function(t,r,n,a){return t[0]=r[0]+n[0]*a,t[1]=r[1]+n[1]*a,t[2]=r[2]+n[2]*a,t},n.distance=h,n.squaredDistance=s,n.squaredLength=M,n.negate=function(t,r){return t[0]=-r[0],t[1]=-r[1],t[2]=-r[2],t},n.inverse=function(t,r){return t[0]=1/r[0],t[1]=1/r[1],t[2]=1/r[2],t},n.normalize=v,n.dot=l,n.cross=function(t,r,n){var a=r[0],e=r[1],u=r[2],o=n[0],i=n[1],c=n[2];return t[0]=e*c-u*i,t[1]=u*o-a*c,t[2]=a*i-e*o,t},n.lerp=function(t,r,n,a){var e=r[0],u=r[1],o=r[2];return t[0]=e+a*(n[0]-e),t[1]=u+a*(n[1]-u),t[2]=o+a*(n[2]-o),t},n.hermite=function(t,r,n,a,e,u){var o=u*u,i=o*(2*u-3)+1,c=o*(u-2)+u,f=o*(u-1),h=o*(3-2*u);return t[0]=r[0]*i+n[0]*c+a[0]*f+e[0]*h,t[1]=r[1]*i+n[1]*c+a[1]*f+e[1]*h,t[2]=r[2]*i+n[2]*c+a[2]*f+e[2]*h,t},n.bezier=function(t,r,n,a,e,u){var o=1-u,i=o*o,c=u*u,f=i*o,h=3*u*i,s=3*c*o,M=c*u;return t[0]=r[0]*f+n[0]*h+a[0]*s+e[0]*M,t[1]=r[1]*f+n[1]*h+a[1]*s+e[1]*M,t[2]=r[2]*f+n[2]*h+a[2]*s+e[2]*M,t},n.random=function(t,r){r=r||1;var n=2*a.RANDOM()*Math.PI,e=2*a.RANDOM()-1,u=Math.sqrt(1-e*e)*r;return t[0]=Math.cos(n)*u,t[1]=Math.sin(n)*u,t[2]=e*r,t},n.transformMat4=function(t,r,n){var a=r[0],e=r[1],u=r[2],o=n[3]*a+n[7]*e+n[11]*u+n[15];return o=o||1,t[0]=(n[0]*a+n[4]*e+n[8]*u+n[12])/o,t[1]=(n[1]*a+n[5]*e+n[9]*u+n[13])/o,t[2]=(n[2]*a+n[6]*e+n[10]*u+n[14])/o,t},n.transformMat3=function(t,r,n){var a=r[0],e=r[1],u=r[2];return t[0]=a*n[0]+e*n[3]+u*n[6],t[1]=a*n[1]+e*n[4]+u*n[7],t[2]=a*n[2]+e*n[5]+u*n[8],t},n.transformQuat=function(t,r,n){var a=n[0],e=n[1],u=n[2],o=n[3],i=r[0],c=r[1],f=r[2],h=e*f-u*c,s=u*i-a*f,M=a*c-e*i,v=e*M-u*s,l=u*h-a*M,d=a*s-e*h,m=2*o;return h*=m,s*=m,M*=m,v*=2,l*=2,d*=2,t[0]=i+h+v,t[1]=c+s+l,t[2]=f+M+d,t},n.rotateX=function(t,r,n,a){var e=[],u=[];return e[0]=r[0]-n[0],e[1]=r[1]-n[1],e[2]=r[2]-n[2],u[0]=e[0],u[1]=e[1]*Math.cos(a)-e[2]*Math.sin(a),u[2]=e[1]*Math.sin(a)+e[2]*Math.cos(a),t[0]=u[0]+n[0],t[1]=u[1]+n[1],t[2]=u[2]+n[2],t},n.rotateY=function(t,r,n,a){var e=[],u=[];return e[0]=r[0]-n[0],e[1]=r[1]-n[1],e[2]=r[2]-n[2],u[0]=e[2]*Math.sin(a)+e[0]*Math.cos(a),u[1]=e[1],u[2]=e[2]*Math.cos(a)-e[0]*Math.sin(a),t[0]=u[0]+n[0],t[1]=u[1]+n[1],t[2]=u[2]+n[2],t},n.rotateZ=function(t,r,n,a){var e=[],u=[];return e[0]=r[0]-n[0],e[1]=r[1]-n[1],e[2]=r[2]-n[2],u[0]=e[0]*Math.cos(a)-e[1]*Math.sin(a),u[1]=e[0]*Math.sin(a)+e[1]*Math.cos(a),u[2]=e[2],t[0]=u[0]+n[0],t[1]=u[1]+n[1],t[2]=u[2]+n[2],t},n.angle=function(t,r){var n=o(t[0],t[1],t[2]),a=o(r[0],r[1],r[2]);v(n,n),v(a,a);var e=l(n,a);return e>1?0:e<-1?Math.PI:Math.acos(e)},n.zero=function(t){return t[0]=0,t[1]=0,t[2]=0,t},n.str=function(t){return"vec3("+t[0]+", "+t[1]+", "+t[2]+")"},n.exactEquals=function(t,r){return t[0]===r[0]&&t[1]===r[1]&&t[2]===r[2]},n.equals=function(t,r){var n=t[0],e=t[1],u=t[2],o=r[0],i=r[1],c=r[2];return Math.abs(n-o)<=a.EPSILON*Math.max(1,Math.abs(n),Math.abs(o))&&Math.abs(e-i)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(i))&&Math.abs(u-c)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(c))},n.forEach=n.sqrLen=n.len=n.sqrDist=n.dist=n.div=n.mul=n.sub=void 0;var a=function(t){if(t&&t.__esModule)return t;var r={};if(null!=t)for(var n in t)if(Object.prototype.hasOwnProperty.call(t,n)){var a=Object.defineProperty&&Object.getOwnPropertyDescriptor?Object.getOwnPropertyDescriptor(t,n):{};a.get||a.set?Object.defineProperty(r,n,a):r[n]=t[n]}return r.default=t,r}(t("c6b4e451bc"));function e(){var t=new a.ARRAY_TYPE(3);return a.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0),t}function u(t){var r=t[0],n=t[1],a=t[2];return Math.hypot(r,n,a)}function o(t,r,n){var e=new a.ARRAY_TYPE(3);return e[0]=t,e[1]=r,e[2]=n,e}function i(t,r,n){return t[0]=r[0]-n[0],t[1]=r[1]-n[1],t[2]=r[2]-n[2],t}function c(t,r,n){return t[0]=r[0]*n[0],t[1]=r[1]*n[1],t[2]=r[2]*n[2],t}function f(t,r,n){return t[0]=r[0]/n[0],t[1]=r[1]/n[1],t[2]=r[2]/n[2],t}function h(t,r){var n=r[0]-t[0],a=r[1]-t[1],e=r[2]-t[2];return Math.hypot(n,a,e)}function s(t,r){var n=r[0]-t[0],a=r[1]-t[1],e=r[2]-t[2];return n*n+a*a+e*e}function M(t){var r=t[0],n=t[1],a=t[2];return r*r+n*n+a*a}function v(t,r){var n=r[0],a=r[1],e=r[2],u=n*n+a*a+e*e;return u>0&&(u=1/Math.sqrt(u)),t[0]=r[0]*u,t[1]=r[1]*u,t[2]=r[2]*u,t}function l(t,r){return t[0]*r[0]+t[1]*r[1]+t[2]*r[2]}var d=i;n.sub=d;var m=c;n.mul=m;var b=f;n.div=b;var p=h;n.dist=p;var P=s;n.sqrDist=P;var A=u;n.len=A;var O=M;n.sqrLen=O;var y,q=(y=e(),function(t,r,n,a,e,u){var o,i;for(r||(r=3),n||(n=0),i=a?Math.min(a*r+n,t.length):t.length,o=n;o<i;o+=r)y[0]=t[o],y[1]=t[o+1],y[2]=t[o+2],e(y,y,u),t[o]=y[0],t[o+1]=y[1],t[o+2]=y[2];return t});n.forEach=q},
"2c797465df": function _(t,r,n){n.create=e,n.clone=function(t){var r=new a.ARRAY_TYPE(4);return r[0]=t[0],r[1]=t[1],r[2]=t[2],r[3]=t[3],r},n.fromValues=function(t,r,n,e){var u=new a.ARRAY_TYPE(4);return u[0]=t,u[1]=r,u[2]=n,u[3]=e,u},n.copy=function(t,r){return t[0]=r[0],t[1]=r[1],t[2]=r[2],t[3]=r[3],t},n.set=function(t,r,n,a,e){return t[0]=r,t[1]=n,t[2]=a,t[3]=e,t},n.add=function(t,r,n){return t[0]=r[0]+n[0],t[1]=r[1]+n[1],t[2]=r[2]+n[2],t[3]=r[3]+n[3],t},n.subtract=u,n.multiply=o,n.divide=i,n.ceil=function(t,r){return t[0]=Math.ceil(r[0]),t[1]=Math.ceil(r[1]),t[2]=Math.ceil(r[2]),t[3]=Math.ceil(r[3]),t},n.floor=function(t,r){return t[0]=Math.floor(r[0]),t[1]=Math.floor(r[1]),t[2]=Math.floor(r[2]),t[3]=Math.floor(r[3]),t},n.min=function(t,r,n){return t[0]=Math.min(r[0],n[0]),t[1]=Math.min(r[1],n[1]),t[2]=Math.min(r[2],n[2]),t[3]=Math.min(r[3],n[3]),t},n.max=function(t,r,n){return t[0]=Math.max(r[0],n[0]),t[1]=Math.max(r[1],n[1]),t[2]=Math.max(r[2],n[2]),t[3]=Math.max(r[3],n[3]),t},n.round=function(t,r){return t[0]=Math.round(r[0]),t[1]=Math.round(r[1]),t[2]=Math.round(r[2]),t[3]=Math.round(r[3]),t},n.scale=function(t,r,n){return t[0]=r[0]*n,t[1]=r[1]*n,t[2]=r[2]*n,t[3]=r[3]*n,t},n.scaleAndAdd=function(t,r,n,a){return t[0]=r[0]+n[0]*a,t[1]=r[1]+n[1]*a,t[2]=r[2]+n[2]*a,t[3]=r[3]+n[3]*a,t},n.distance=c,n.squaredDistance=f,n.length=h,n.squaredLength=M,n.negate=function(t,r){return t[0]=-r[0],t[1]=-r[1],t[2]=-r[2],t[3]=-r[3],t},n.inverse=function(t,r){return t[0]=1/r[0],t[1]=1/r[1],t[2]=1/r[2],t[3]=1/r[3],t},n.normalize=function(t,r){var n=r[0],a=r[1],e=r[2],u=r[3],o=n*n+a*a+e*e+u*u;o>0&&(o=1/Math.sqrt(o));return t[0]=n*o,t[1]=a*o,t[2]=e*o,t[3]=u*o,t},n.dot=function(t,r){return t[0]*r[0]+t[1]*r[1]+t[2]*r[2]+t[3]*r[3]},n.cross=function(t,r,n,a){var e=n[0]*a[1]-n[1]*a[0],u=n[0]*a[2]-n[2]*a[0],o=n[0]*a[3]-n[3]*a[0],i=n[1]*a[2]-n[2]*a[1],c=n[1]*a[3]-n[3]*a[1],f=n[2]*a[3]-n[3]*a[2],h=r[0],M=r[1],s=r[2],l=r[3];return t[0]=M*f-s*c+l*i,t[1]=-h*f+s*o-l*u,t[2]=h*c-M*o+l*e,t[3]=-h*i+M*u-s*e,t},n.lerp=function(t,r,n,a){var e=r[0],u=r[1],o=r[2],i=r[3];return t[0]=e+a*(n[0]-e),t[1]=u+a*(n[1]-u),t[2]=o+a*(n[2]-o),t[3]=i+a*(n[3]-i),t},n.random=function(t,r){var n,e,u,o,i,c;r=r||1;do{n=2*a.RANDOM()-1,e=2*a.RANDOM()-1,i=n*n+e*e}while(i>=1);do{u=2*a.RANDOM()-1,o=2*a.RANDOM()-1,c=u*u+o*o}while(c>=1);var f=Math.sqrt((1-i)/c);return t[0]=r*n,t[1]=r*e,t[2]=r*u*f,t[3]=r*o*f,t},n.transformMat4=function(t,r,n){var a=r[0],e=r[1],u=r[2],o=r[3];return t[0]=n[0]*a+n[4]*e+n[8]*u+n[12]*o,t[1]=n[1]*a+n[5]*e+n[9]*u+n[13]*o,t[2]=n[2]*a+n[6]*e+n[10]*u+n[14]*o,t[3]=n[3]*a+n[7]*e+n[11]*u+n[15]*o,t},n.transformQuat=function(t,r,n){var a=r[0],e=r[1],u=r[2],o=n[0],i=n[1],c=n[2],f=n[3],h=f*a+i*u-c*e,M=f*e+c*a-o*u,s=f*u+o*e-i*a,l=-o*a-i*e-c*u;return t[0]=h*f+l*-o+M*-c-s*-i,t[1]=M*f+l*-i+s*-o-h*-c,t[2]=s*f+l*-c+h*-i-M*-o,t[3]=r[3],t},n.zero=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=0,t},n.str=function(t){return"vec4("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+")"},n.exactEquals=function(t,r){return t[0]===r[0]&&t[1]===r[1]&&t[2]===r[2]&&t[3]===r[3]},n.equals=function(t,r){var n=t[0],e=t[1],u=t[2],o=t[3],i=r[0],c=r[1],f=r[2],h=r[3];return Math.abs(n-i)<=a.EPSILON*Math.max(1,Math.abs(n),Math.abs(i))&&Math.abs(e-c)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(c))&&Math.abs(u-f)<=a.EPSILON*Math.max(1,Math.abs(u),Math.abs(f))&&Math.abs(o-h)<=a.EPSILON*Math.max(1,Math.abs(o),Math.abs(h))},n.forEach=n.sqrLen=n.len=n.sqrDist=n.dist=n.div=n.mul=n.sub=void 0;var a=function(t){if(t&&t.__esModule)return t;var r={};if(null!=t)for(var n in t)if(Object.prototype.hasOwnProperty.call(t,n)){var a=Object.defineProperty&&Object.getOwnPropertyDescriptor?Object.getOwnPropertyDescriptor(t,n):{};a.get||a.set?Object.defineProperty(r,n,a):r[n]=t[n]}return r.default=t,r}(t("c6b4e451bc"));function e(){var t=new a.ARRAY_TYPE(4);return a.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[3]=0),t}function u(t,r,n){return t[0]=r[0]-n[0],t[1]=r[1]-n[1],t[2]=r[2]-n[2],t[3]=r[3]-n[3],t}function o(t,r,n){return t[0]=r[0]*n[0],t[1]=r[1]*n[1],t[2]=r[2]*n[2],t[3]=r[3]*n[3],t}function i(t,r,n){return t[0]=r[0]/n[0],t[1]=r[1]/n[1],t[2]=r[2]/n[2],t[3]=r[3]/n[3],t}function c(t,r){var n=r[0]-t[0],a=r[1]-t[1],e=r[2]-t[2],u=r[3]-t[3];return Math.hypot(n,a,e,u)}function f(t,r){var n=r[0]-t[0],a=r[1]-t[1],e=r[2]-t[2],u=r[3]-t[3];return n*n+a*a+e*e+u*u}function h(t){var r=t[0],n=t[1],a=t[2],e=t[3];return Math.hypot(r,n,a,e)}function M(t){var r=t[0],n=t[1],a=t[2],e=t[3];return r*r+n*n+a*a+e*e}var s=u;n.sub=s;var l=o;n.mul=l;var v=i;n.div=v;var d=c;n.dist=d;var m=f;n.sqrDist=m;var b=h;n.len=b;var O=M;n.sqrLen=O;var A,p=(A=e(),function(t,r,n,a,e,u){var o,i;for(r||(r=4),n||(n=0),i=a?Math.min(a*r+n,t.length):t.length,o=n;o<i;o+=r)A[0]=t[o],A[1]=t[o+1],A[2]=t[o+2],A[3]=t[o+3],e(A,A,u),t[o]=A[0],t[o+1]=A[1],t[o+2]=A[2],t[o+3]=A[3];return t});n.forEach=p},
"43b2ef2f0a": function _(t,a,r){r.create=function(){var t=new n.ARRAY_TYPE(8);n.ARRAY_TYPE!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[4]=0,t[5]=0,t[6]=0,t[7]=0);return t[3]=1,t},r.clone=function(t){var a=new n.ARRAY_TYPE(8);return a[0]=t[0],a[1]=t[1],a[2]=t[2],a[3]=t[3],a[4]=t[4],a[5]=t[5],a[6]=t[6],a[7]=t[7],a},r.fromValues=function(t,a,r,e,u,o,i,s){var c=new n.ARRAY_TYPE(8);return c[0]=t,c[1]=a,c[2]=r,c[3]=e,c[4]=u,c[5]=o,c[6]=i,c[7]=s,c},r.fromRotationTranslationValues=function(t,a,r,e,u,o,i){var s=new n.ARRAY_TYPE(8);s[0]=t,s[1]=a,s[2]=r,s[3]=e;var c=.5*u,f=.5*o,h=.5*i;return s[4]=c*e+f*r-h*a,s[5]=f*e+h*t-c*r,s[6]=h*e+c*a-f*t,s[7]=-c*t-f*a-h*r,s},r.fromRotationTranslation=i,r.fromTranslation=function(t,a){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t[4]=.5*a[0],t[5]=.5*a[1],t[6]=.5*a[2],t[7]=0,t},r.fromRotation=function(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=0,t[5]=0,t[6]=0,t[7]=0,t},r.fromMat4=function(t,a){var r=e.create();u.getRotation(r,a);var o=new n.ARRAY_TYPE(3);return u.getTranslation(o,a),i(t,r,o),t},r.copy=s,r.identity=function(t){return t[0]=0,t[1]=0,t[2]=0,t[3]=1,t[4]=0,t[5]=0,t[6]=0,t[7]=0,t},r.set=function(t,a,r,n,e,u,o,i,s){return t[0]=a,t[1]=r,t[2]=n,t[3]=e,t[4]=u,t[5]=o,t[6]=i,t[7]=s,t},r.getDual=function(t,a){return t[0]=a[4],t[1]=a[5],t[2]=a[6],t[3]=a[7],t},r.setDual=function(t,a){return t[4]=a[0],t[5]=a[1],t[6]=a[2],t[7]=a[3],t},r.getTranslation=function(t,a){var r=a[4],n=a[5],e=a[6],u=a[7],o=-a[0],i=-a[1],s=-a[2],c=a[3];return t[0]=2*(r*c+u*o+n*s-e*i),t[1]=2*(n*c+u*i+e*o-r*s),t[2]=2*(e*c+u*s+r*i-n*o),t},r.translate=function(t,a,r){var n=a[0],e=a[1],u=a[2],o=a[3],i=.5*r[0],s=.5*r[1],c=.5*r[2],f=a[4],h=a[5],M=a[6],v=a[7];return t[0]=n,t[1]=e,t[2]=u,t[3]=o,t[4]=o*i+e*c-u*s+f,t[5]=o*s+u*i-n*c+h,t[6]=o*c+n*s-e*i+M,t[7]=-n*i-e*s-u*c+v,t},r.rotateX=function(t,a,r){var n=-a[0],u=-a[1],o=-a[2],i=a[3],s=a[4],c=a[5],f=a[6],h=a[7],M=s*i+h*n+c*o-f*u,v=c*i+h*u+f*n-s*o,l=f*i+h*o+s*u-c*n,b=h*i-s*n-c*u-f*o;return e.rotateX(t,a,r),n=t[0],u=t[1],o=t[2],i=t[3],t[4]=M*i+b*n+v*o-l*u,t[5]=v*i+b*u+l*n-M*o,t[6]=l*i+b*o+M*u-v*n,t[7]=b*i-M*n-v*u-l*o,t},r.rotateY=function(t,a,r){var n=-a[0],u=-a[1],o=-a[2],i=a[3],s=a[4],c=a[5],f=a[6],h=a[7],M=s*i+h*n+c*o-f*u,v=c*i+h*u+f*n-s*o,l=f*i+h*o+s*u-c*n,b=h*i-s*n-c*u-f*o;return e.rotateY(t,a,r),n=t[0],u=t[1],o=t[2],i=t[3],t[4]=M*i+b*n+v*o-l*u,t[5]=v*i+b*u+l*n-M*o,t[6]=l*i+b*o+M*u-v*n,t[7]=b*i-M*n-v*u-l*o,t},r.rotateZ=function(t,a,r){var n=-a[0],u=-a[1],o=-a[2],i=a[3],s=a[4],c=a[5],f=a[6],h=a[7],M=s*i+h*n+c*o-f*u,v=c*i+h*u+f*n-s*o,l=f*i+h*o+s*u-c*n,b=h*i-s*n-c*u-f*o;return e.rotateZ(t,a,r),n=t[0],u=t[1],o=t[2],i=t[3],t[4]=M*i+b*n+v*o-l*u,t[5]=v*i+b*u+l*n-M*o,t[6]=l*i+b*o+M*u-v*n,t[7]=b*i-M*n-v*u-l*o,t},r.rotateByQuatAppend=function(t,a,r){var n=r[0],e=r[1],u=r[2],o=r[3],i=a[0],s=a[1],c=a[2],f=a[3];return t[0]=i*o+f*n+s*u-c*e,t[1]=s*o+f*e+c*n-i*u,t[2]=c*o+f*u+i*e-s*n,t[3]=f*o-i*n-s*e-c*u,i=a[4],s=a[5],c=a[6],f=a[7],t[4]=i*o+f*n+s*u-c*e,t[5]=s*o+f*e+c*n-i*u,t[6]=c*o+f*u+i*e-s*n,t[7]=f*o-i*n-s*e-c*u,t},r.rotateByQuatPrepend=function(t,a,r){var n=a[0],e=a[1],u=a[2],o=a[3],i=r[0],s=r[1],c=r[2],f=r[3];return t[0]=n*f+o*i+e*c-u*s,t[1]=e*f+o*s+u*i-n*c,t[2]=u*f+o*c+n*s-e*i,t[3]=o*f-n*i-e*s-u*c,i=r[4],s=r[5],c=r[6],f=r[7],t[4]=n*f+o*i+e*c-u*s,t[5]=e*f+o*s+u*i-n*c,t[6]=u*f+o*c+n*s-e*i,t[7]=o*f-n*i-e*s-u*c,t},r.rotateAroundAxis=function(t,a,r,e){if(Math.abs(e)<n.EPSILON)return s(t,a);var u=Math.hypot(r[0],r[1],r[2]);e*=.5;var o=Math.sin(e),i=o*r[0]/u,c=o*r[1]/u,f=o*r[2]/u,h=Math.cos(e),M=a[0],v=a[1],l=a[2],b=a[3];t[0]=M*h+b*i+v*f-l*c,t[1]=v*h+b*c+l*i-M*f,t[2]=l*h+b*f+M*c-v*i,t[3]=b*h-M*i-v*c-l*f;var P=a[4],R=a[5],d=a[6],m=a[7];return t[4]=P*h+m*i+R*f-d*c,t[5]=R*h+m*c+d*i-P*f,t[6]=d*h+m*f+P*c-R*i,t[7]=m*h-P*i-R*c-d*f,t},r.add=function(t,a,r){return t[0]=a[0]+r[0],t[1]=a[1]+r[1],t[2]=a[2]+r[2],t[3]=a[3]+r[3],t[4]=a[4]+r[4],t[5]=a[5]+r[5],t[6]=a[6]+r[6],t[7]=a[7]+r[7],t},r.multiply=h,r.scale=function(t,a,r){return t[0]=a[0]*r,t[1]=a[1]*r,t[2]=a[2]*r,t[3]=a[3]*r,t[4]=a[4]*r,t[5]=a[5]*r,t[6]=a[6]*r,t[7]=a[7]*r,t},r.lerp=function(t,a,r,n){var e=1-n;v(a,r)<0&&(n=-n);return t[0]=a[0]*e+r[0]*n,t[1]=a[1]*e+r[1]*n,t[2]=a[2]*e+r[2]*n,t[3]=a[3]*e+r[3]*n,t[4]=a[4]*e+r[4]*n,t[5]=a[5]*e+r[5]*n,t[6]=a[6]*e+r[6]*n,t[7]=a[7]*e+r[7]*n,t},r.invert=function(t,a){var r=P(a);return t[0]=-a[0]/r,t[1]=-a[1]/r,t[2]=-a[2]/r,t[3]=a[3]/r,t[4]=-a[4]/r,t[5]=-a[5]/r,t[6]=-a[6]/r,t[7]=a[7]/r,t},r.conjugate=function(t,a){return t[0]=-a[0],t[1]=-a[1],t[2]=-a[2],t[3]=a[3],t[4]=-a[4],t[5]=-a[5],t[6]=-a[6],t[7]=a[7],t},r.normalize=function(t,a){var r=P(a);if(r>0){r=Math.sqrt(r);var n=a[0]/r,e=a[1]/r,u=a[2]/r,o=a[3]/r,i=a[4],s=a[5],c=a[6],f=a[7],h=n*i+e*s+u*c+o*f;t[0]=n,t[1]=e,t[2]=u,t[3]=o,t[4]=(i-n*h)/r,t[5]=(s-e*h)/r,t[6]=(c-u*h)/r,t[7]=(f-o*h)/r}return t},r.str=function(t){return"quat2("+t[0]+", "+t[1]+", "+t[2]+", "+t[3]+", "+t[4]+", "+t[5]+", "+t[6]+", "+t[7]+")"},r.exactEquals=function(t,a){return t[0]===a[0]&&t[1]===a[1]&&t[2]===a[2]&&t[3]===a[3]&&t[4]===a[4]&&t[5]===a[5]&&t[6]===a[6]&&t[7]===a[7]},r.equals=function(t,a){var r=t[0],e=t[1],u=t[2],o=t[3],i=t[4],s=t[5],c=t[6],f=t[7],h=a[0],M=a[1],v=a[2],l=a[3],b=a[4],P=a[5],R=a[6],d=a[7];return Math.abs(r-h)<=n.EPSILON*Math.max(1,Math.abs(r),Math.abs(h))&&Math.abs(e-M)<=n.EPSILON*Math.max(1,Math.abs(e),Math.abs(M))&&Math.abs(u-v)<=n.EPSILON*Math.max(1,Math.abs(u),Math.abs(v))&&Math.abs(o-l)<=n.EPSILON*Math.max(1,Math.abs(o),Math.abs(l))&&Math.abs(i-b)<=n.EPSILON*Math.max(1,Math.abs(i),Math.abs(b))&&Math.abs(s-P)<=n.EPSILON*Math.max(1,Math.abs(s),Math.abs(P))&&Math.abs(c-R)<=n.EPSILON*Math.max(1,Math.abs(c),Math.abs(R))&&Math.abs(f-d)<=n.EPSILON*Math.max(1,Math.abs(f),Math.abs(d))},r.sqrLen=r.squaredLength=r.len=r.length=r.dot=r.mul=r.setReal=r.getReal=void 0;var n=o(t("c6b4e451bc")),e=o(t("fb0a790f46")),u=o(t("04eeb2ead8"));function o(t){if(t&&t.__esModule)return t;var a={};if(null!=t)for(var r in t)if(Object.prototype.hasOwnProperty.call(t,r)){var n=Object.defineProperty&&Object.getOwnPropertyDescriptor?Object.getOwnPropertyDescriptor(t,r):{};n.get||n.set?Object.defineProperty(a,r,n):a[r]=t[r]}return a.default=t,a}function i(t,a,r){var n=.5*r[0],e=.5*r[1],u=.5*r[2],o=a[0],i=a[1],s=a[2],c=a[3];return t[0]=o,t[1]=i,t[2]=s,t[3]=c,t[4]=n*c+e*s-u*i,t[5]=e*c+u*o-n*s,t[6]=u*c+n*i-e*o,t[7]=-n*o-e*i-u*s,t}function s(t,a){return t[0]=a[0],t[1]=a[1],t[2]=a[2],t[3]=a[3],t[4]=a[4],t[5]=a[5],t[6]=a[6],t[7]=a[7],t}var c=e.copy;r.getReal=c;var f=e.copy;function h(t,a,r){var n=a[0],e=a[1],u=a[2],o=a[3],i=r[4],s=r[5],c=r[6],f=r[7],h=a[4],M=a[5],v=a[6],l=a[7],b=r[0],P=r[1],R=r[2],d=r[3];return t[0]=n*d+o*b+e*R-u*P,t[1]=e*d+o*P+u*b-n*R,t[2]=u*d+o*R+n*P-e*b,t[3]=o*d-n*b-e*P-u*R,t[4]=n*f+o*i+e*c-u*s+h*d+l*b+M*R-v*P,t[5]=e*f+o*s+u*i-n*c+M*d+l*P+v*b-h*R,t[6]=u*f+o*c+n*s-e*i+v*d+l*R+h*P-M*b,t[7]=o*f-n*i-e*s-u*c+l*d-h*b-M*P-v*R,t}r.setReal=f;var M=h;r.mul=M;var v=e.dot;r.dot=v;var l=e.length;r.length=l;var b=l;r.len=b;var P=e.squaredLength;r.squaredLength=P;var R=P;r.sqrLen=R},
"7aa5d7ae2d": function _(r,t,n){n.create=e,n.clone=function(r){var t=new a.ARRAY_TYPE(2);return t[0]=r[0],t[1]=r[1],t},n.fromValues=function(r,t){var n=new a.ARRAY_TYPE(2);return n[0]=r,n[1]=t,n},n.copy=function(r,t){return r[0]=t[0],r[1]=t[1],r},n.set=function(r,t,n){return r[0]=t,r[1]=n,r},n.add=function(r,t,n){return r[0]=t[0]+n[0],r[1]=t[1]+n[1],r},n.subtract=u,n.multiply=o,n.divide=i,n.ceil=function(r,t){return r[0]=Math.ceil(t[0]),r[1]=Math.ceil(t[1]),r},n.floor=function(r,t){return r[0]=Math.floor(t[0]),r[1]=Math.floor(t[1]),r},n.min=function(r,t,n){return r[0]=Math.min(t[0],n[0]),r[1]=Math.min(t[1],n[1]),r},n.max=function(r,t,n){return r[0]=Math.max(t[0],n[0]),r[1]=Math.max(t[1],n[1]),r},n.round=function(r,t){return r[0]=Math.round(t[0]),r[1]=Math.round(t[1]),r},n.scale=function(r,t,n){return r[0]=t[0]*n,r[1]=t[1]*n,r},n.scaleAndAdd=function(r,t,n,a){return r[0]=t[0]+n[0]*a,r[1]=t[1]+n[1]*a,r},n.distance=c,n.squaredDistance=f,n.length=s,n.squaredLength=h,n.negate=function(r,t){return r[0]=-t[0],r[1]=-t[1],r},n.inverse=function(r,t){return r[0]=1/t[0],r[1]=1/t[1],r},n.normalize=function(r,t){var n=t[0],a=t[1],e=n*n+a*a;e>0&&(e=1/Math.sqrt(e));return r[0]=t[0]*e,r[1]=t[1]*e,r},n.dot=function(r,t){return r[0]*t[0]+r[1]*t[1]},n.cross=function(r,t,n){var a=t[0]*n[1]-t[1]*n[0];return r[0]=r[1]=0,r[2]=a,r},n.lerp=function(r,t,n,a){var e=t[0],u=t[1];return r[0]=e+a*(n[0]-e),r[1]=u+a*(n[1]-u),r},n.random=function(r,t){t=t||1;var n=2*a.RANDOM()*Math.PI;return r[0]=Math.cos(n)*t,r[1]=Math.sin(n)*t,r},n.transformMat2=function(r,t,n){var a=t[0],e=t[1];return r[0]=n[0]*a+n[2]*e,r[1]=n[1]*a+n[3]*e,r},n.transformMat2d=function(r,t,n){var a=t[0],e=t[1];return r[0]=n[0]*a+n[2]*e+n[4],r[1]=n[1]*a+n[3]*e+n[5],r},n.transformMat3=function(r,t,n){var a=t[0],e=t[1];return r[0]=n[0]*a+n[3]*e+n[6],r[1]=n[1]*a+n[4]*e+n[7],r},n.transformMat4=function(r,t,n){var a=t[0],e=t[1];return r[0]=n[0]*a+n[4]*e+n[12],r[1]=n[1]*a+n[5]*e+n[13],r},n.rotate=function(r,t,n,a){var e=t[0]-n[0],u=t[1]-n[1],o=Math.sin(a),i=Math.cos(a);return r[0]=e*i-u*o+n[0],r[1]=e*o+u*i+n[1],r},n.angle=function(r,t){var n=r[0],a=r[1],e=t[0],u=t[1],o=n*n+a*a;o>0&&(o=1/Math.sqrt(o));var i=e*e+u*u;i>0&&(i=1/Math.sqrt(i));var c=(n*e+a*u)*o*i;return c>1?0:c<-1?Math.PI:Math.acos(c)},n.zero=function(r){return r[0]=0,r[1]=0,r},n.str=function(r){return"vec2("+r[0]+", "+r[1]+")"},n.exactEquals=function(r,t){return r[0]===t[0]&&r[1]===t[1]},n.equals=function(r,t){var n=r[0],e=r[1],u=t[0],o=t[1];return Math.abs(n-u)<=a.EPSILON*Math.max(1,Math.abs(n),Math.abs(u))&&Math.abs(e-o)<=a.EPSILON*Math.max(1,Math.abs(e),Math.abs(o))},n.forEach=n.sqrLen=n.sqrDist=n.dist=n.div=n.mul=n.sub=n.len=void 0;var a=function(r){if(r&&r.__esModule)return r;var t={};if(null!=r)for(var n in r)if(Object.prototype.hasOwnProperty.call(r,n)){var a=Object.defineProperty&&Object.getOwnPropertyDescriptor?Object.getOwnPropertyDescriptor(r,n):{};a.get||a.set?Object.defineProperty(t,n,a):t[n]=r[n]}return t.default=r,t}(r("c6b4e451bc"));function e(){var r=new a.ARRAY_TYPE(2);return a.ARRAY_TYPE!=Float32Array&&(r[0]=0,r[1]=0),r}function u(r,t,n){return r[0]=t[0]-n[0],r[1]=t[1]-n[1],r}function o(r,t,n){return r[0]=t[0]*n[0],r[1]=t[1]*n[1],r}function i(r,t,n){return r[0]=t[0]/n[0],r[1]=t[1]/n[1],r}function c(r,t){var n=t[0]-r[0],a=t[1]-r[1];return Math.hypot(n,a)}function f(r,t){var n=t[0]-r[0],a=t[1]-r[1];return n*n+a*a}function s(r){var t=r[0],n=r[1];return Math.hypot(t,n)}function h(r){var t=r[0],n=r[1];return t*t+n*n}var v=s;n.len=v;var M=u;n.sub=M;var l=o;n.mul=l;var d=i;n.div=d;var m=c;n.dist=m;var b=f;n.sqrDist=b;var p=h;n.sqrLen=p;var P,A=(P=e(),function(r,t,n,a,e,u){var o,i;for(t||(t=2),n||(n=0),i=a?Math.min(a*t+n,r.length):r.length,o=n;o<i;o+=t)P[0]=r[o],P[1]=r[o+1],e(P,P,u),r[o]=P[0],r[o+1]=P[1];return r});n.forEach=A},
}, "aa4f566620", {"index":"aa4f566620","models/index":"4d02676c49","models/ace":"ff4b91e885","models/layout":"ec60963462","models/audio":"12e90a1b7e","models/deckgl":"cf3b018c7a","models/tooltips":"27d3545a25","models/html":"70a2bb70ef","models/json":"dac8d750fa","models/katex":"c81021c8fd","models/mathjax":"a93ded647d","models/player":"98100899bc","models/plotly":"7d6e800353","models/util":"62ba79515f","models/progress":"d9b3a262de","models/state":"4b4afba86a","models/vega":"14b669e6fc","models/video":"71a2bbec38","models/videostream":"76bc93d621","models/vtk/index":"63070bc9ce","models/vtk/vtk":"e04073341c","models/vtk/vtk_layout":"3755bf9cce","models/vtk/vtk_utils":"f35231aba1","models/vtk/vtkvolume":"51dfc8cb0e","models/vtk/vtkaxes":"5bc27423fe"}, {});
})

//# sourceMappingURL=panel.min.js.map
